//***************************************************************************************
// Contant Defintion Area
//***************************************************************************************
#define SET_APWM_DUTY  0
#define SET_BPWM_DUTY  1


//***************************************************************************************
// CODE Definition Area
//***************************************************************************************
int main()
{  
  System_Initial();                         // Initialize System    
  PWM_Initial();                            // Initialize APWM and BPWM. Output APWM on IOA[8], Output BPWM on IOA[9] 
  
  while(1) {
  	System_ServiceLoop();
  	switch (SP_GetCh())
  	{  	    
  	  case 0x0400:      // Key1: IOA[10] 
  	    Set_PWM_Duty(SET_APWM_DUTY, 0);     // APWM Off  	    
  	    Set_PWM_Duty(SET_BPWM_DUTY, 0);     // BPWM Off  
  	    break;    	    

  	  case 0x0800:      // Key2: IOA[11] 
  	    Set_PWM_Duty(SET_APWM_DUTY, 4);     // 4/16 APWM duty   	    
  	    Set_PWM_Duty(SET_BPWM_DUTY, 4);     // 4/16 BPWM duty   	    
  	    break;  	    	

  	  case 0x1000:      // Key3: IOA[12] 
  	    Set_PWM_Duty(SET_APWM_DUTY, 8);     // 8/16 APWM duty    	    
  	    Set_PWM_Duty(SET_BPWM_DUTY, 8);     // 8/16 BPWM duty    	    
  	    break;
  	    
  	  case 0x2000:      // Key4: IOA[13] 
  	    Set_PWM_Duty(SET_APWM_DUTY, 11);    // 11/16 APWM duty    	    
  	    Set_PWM_Duty(SET_BPWM_DUTY, 11);    // 11/16 BPWM duty    	    	    
  	    break;
  	    
  	  case 0x4000:      // Key5: IOA[14] 
  	    Set_PWM_Duty(SET_APWM_DUTY, 14);    // 14/16 APWM duty    	    
  	    Set_PWM_Duty(SET_BPWM_DUTY, 14);    // 14/16 BPWM duty    	    	    
  	    break;  

  	  case 0x8000:      // Key6: IOA[15] 
  	    Set_PWM_Duty(SET_APWM_DUTY, 15);    // 1/2 APWM duty    	    
  	    Set_PWM_Duty(SET_BPWM_DUTY, 15);    // 1/2 BPWM duty    	    	    
  	    break;  	    	    

      default:
        break;  
  	}	      
  }

  return 0;
}
