//***************************************************************************************
// Header File Included Area
//***************************************************************************************
.include GPCE001.inc


//***************************************************************************************
// Function Call Publication Area
//***************************************************************************************
.public _BREAK;
.public _FIQ;
.public _IRQ0;
.public _IRQ1;
.public _IRQ2;
.public _IRQ3;
.public _IRQ4;
.public _IRQ5;
.public _IRQ6;
.public _IRQ7;


//***************************************************************************************
// RAM Definition Area
//***************************************************************************************
.RAM


//***************************************************************************************
// CODE Definition Area
//***************************************************************************************
.TEXT

_BREAK:
	//add your code here

	reti;


_FIQ:
    push R1 to [SP];

	R1 = [P_INT_Status];
	test R1, C_IRQ0_TMA;
	jnz L_FIQ_TimerA;
	test R1, C_IRQ1_TMB;
	jnz L_FIQ_TimerB;
	jmp L_FIQ_TimerC;

L_FIQ_TimerA:
    //
    // Invert IOB[13]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit13;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ0_TMA interrupt event flag
	// 
    R1 = C_IRQ0_TMA;
    [P_INT_Status] = R1;
    
    R1 = C_IRQ0_TMA;
    [P_INT_Status] = R1;
    pop R1 from [sp];
    reti;    

L_FIQ_TimerB:
    //
    // Invert IOB[14]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit14;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ1_TMB interrupt event flag
	// 
    R1 = C_IRQ1_TMB;
    [P_INT_Status] = R1;

    R1 = C_IRQ1_TMB;
    [P_INT_Status] = R1;
    pop R1 from [sp];
    reti;

L_FIQ_TimerC:
    //
    // Invert IOB[15]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit15;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ2_TMC interrupt event flag
	// 
    R1 = C_IRQ2_TMC;
    [P_INT_Status] = R1;

    R1 = C_IRQ2_TMC;
    [P_INT_Status] = R1;
    pop R1 from [sp];
    reti;	


_IRQ0:
    push R1 to [sp];
    
    //
    // Invert IOB[0]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit0;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ0_TMA interrupt event flag
	// 
    R1 = C_IRQ0_TMA;
    [P_INT_Status] = R1;
    
    pop R1 from [sp];
	reti;


_IRQ1:
    push R1 to [sp];
    
    //
    // Invert IOB[1]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit1;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ1_TMB interrupt event flag
	// 
    R1 = C_IRQ1_TMB;
    [P_INT_Status] = R1;
    
    pop R1 from [sp];
	reti;


_IRQ2:
    push R1 to [sp];
    
    //
    // Invert IOB[2]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit2;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ2_TMC interrupt event flag
	// 
    R1 = C_IRQ2_TMC;
    [P_INT_Status] = R1;
    
    pop R1 from [sp];
	reti;


_IRQ3:
	//add your code here

	reti;


_IRQ4:
    //add your code here

	reti;


_IRQ5:
	push R1 to [SP];

	R1 = [P_INT_Status];
	test R1, C_IRQ5_EXT1;
	jnz ?L_IRQ5_EXT1;
	test R1, C_IRQ5_EXT2;
	jnz ?L_IRQ5_EXT2;

?L_IRQ5_EXT1:
    //
    // Invert IOB[3]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit3;
    [P_IOB_Buffer] = R1;	
	
	//
	// Clear IRQ5_Ext1 interrupt event flag
	// 
	R1 = C_IRQ5_EXT1;
	[P_INT_Status] = R1;

    pop R1 from [SP];
	reti;

?L_IRQ5_EXT2:
    //
    // Invert IOB[4]
    //
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit4;
    [P_IOB_Buffer] = R1;	

    //
	// Clear IRQ5_Ext2 interrupt event flag
	// 	
	R1 = C_IRQ5_EXT2;
	[P_INT_Status] = R1;

    pop R1 from [SP];
	reti;


_IRQ6:
    push R1 to [sp];

	R1 = [P_INT_Status];
	test R1, C_IRQ6_2048Hz;
	jnz ?L_IRQ6_2KHz;
	test R1, C_IRQ6_512Hz;
	jnz ?L_IRQ6_512Hz;		

?L_IRQ6_4KHz:
    //
    // Invert IOB[5]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit5;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ6_4KHz interrupt event flag
	// 
    R1 = C_IRQ6_4096Hz;
    [P_INT_Status] = R1;
    
    pop R1 from [sp];
	reti;

?L_IRQ6_2KHz:
    //
    // Invert IOB[6]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit6;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ6_2KHz interrupt event flag
	// 
    R1 = C_IRQ6_2048Hz;
    [P_INT_Status] = R1;
    
    pop R1 from [sp];
	reti;
    
?L_IRQ6_512Hz:    
    //
    // Invert IOB[7]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit7;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ6_512Hz interrupt event flag
	// 
    R1 = C_IRQ6_512Hz;
    [P_INT_Status] = R1;
    
    pop R1 from [sp];
	reti;
	

_IRQ7:
    push R1 to [sp];

	R1 = [P_INT_Status];
	test R1, C_IRQ7_16Hz;
	jnz ?L_IRQ7_16Hz;
	test R1, C_IRQ7_2Hz;
	jnz ?L_IRQ7_2Hz;		

?L_IRQ7_64Hz:
    //
    // Invert IOB[9]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit9;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ7_64Hz interrupt event flag
	// 
    R1 = C_IRQ7_64Hz;
    [P_INT_Status] = R1;
    
    pop R1 from [sp];
	reti;

?L_IRQ7_16Hz:
    //
    // Invert IOB[10]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit10;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ7_16Hz interrupt event flag
	// 
    R1 = C_IRQ7_16Hz;
    [P_INT_Status] = R1;
    
    pop R1 from [sp];
	reti;
    
?L_IRQ7_2Hz:    
    //
    // Invert IOB[11]
    //	
	R1 = [P_IOB_Buffer];
	R1 ^= C_Bit11;
    [P_IOB_Buffer] = R1;	

	//
	// Clear IRQ7_2Hz interrupt event flag
	// 
    R1 = C_IRQ7_2Hz;
    [P_INT_Status] = R1;
    
    pop R1 from [sp];
	reti;

