//***************************************************************************************
// Header File Included Area
//***************************************************************************************
.include GPCE001.inc


//***************************************************************************************
// Function Call Publication Area
//***************************************************************************************
.public  _SetLvdLevel
.public F_SetLvdLevel

.public  _Low_Voltage_Dectect
.public F_Low_Voltage_Dectect

.public  _LVD_Test_Init
.public F_LVD_Test_Init


//***************************************************************************************
// CODE Definition Area
//***************************************************************************************
.CODE

//*****************************************************************************
// Function    : F_SetLvdLevel
// Description : Setting LVD level
// Destroy     : 
// Parameter   : R1: LVD level, 
//               - 0x0000: 3.2V
//               - 0x0001: 3.0V 
//               - 0x0010: 2.8V 
//               - 0x0011: 2.6V 
// Return      : None
// Note        : None
//*****************************************************************************
_SetLvdLevel:   .proc
    R1 = SP + 3
    R1 = [R1];
F_SetLvdLevel:
    push R1 to [SP];
    
    R1 &= 0x0003;
    [P_System_LVD_Ctrl] = R1;
    
    pop R1 from [SP];
    retf
    .endp

//*****************************************************************************
// Function    : F_Low_Voltage_Dectect
// Description : Setting LVD level
// Destroy     : 
// Parameter   : None 
// Return      : None
// Note        : None
//*****************************************************************************
_Low_Voltage_Dectect:   .proc
F_Low_Voltage_Dectect:
    push R1, R2 to [sp];

    R1 = [P_IOB_Buffer];
    R1 &= 0xFFFC;
    R1 |= [P_System_LVD_Ctrl];
 
    R2 = [P_System_LVD_Ctrl];
    R2 &= C_Low_Voltage;
    jz ?L_VDD_larger_than_VLVD;      
   
    R1 |= 0x0004;	
    [P_IOB_Buffer] = R1;
    
    pop R1, R2 from [sp];
    retf    

?L_VDD_larger_than_VLVD:
    R1 &= ~0x0004;	
    [P_IOB_Buffer] = R1;
    
    pop R1, R2 from [sp];
    retf
    .endp

//*****************************************************************************
// Function    : F_LVD_Test_Init
// Description : Setting IOB[2:0] as output low with buffer
// Destroy     : 
// Parameter   : None
// Return      : None
// Note        : None
//*****************************************************************************
_LVD_Test_Init:   .proc
F_LVD_Test_Init:
    push R1 to [sp];

    R1 = [P_IOB_Buffer];
    R1 &= ~(C_Bit0 | C_Bit1 | C_Bit2);
    [P_IOB_Buffer] = R1;  

    R1 = [P_IOB_Attrib];
    R1 |= C_Bit0 | C_Bit1 | C_Bit2;     
    [P_IOB_Attrib] = R1;
    
    R1 = [P_IOB_Dir]; 
    R1 |= C_Bit0 | C_Bit1 | C_Bit2;    
    [P_IOB_Dir] = R1;  
    
    pop R1 from [sp];
    retf;
    .endp   

      