//***************************************************************************************
// Header File Included Area
//***************************************************************************************
#include "GPCE001.h"


//***************************************************************************************
// CODE Definition Area
//***************************************************************************************
int main()
{
  unsigned int RegBuffer;	
  
  //
  // Initialize System 
  //    
  System_Initial();
  LVD_Test_Init();

  while(1)
  {  
  	System_ServiceLoop();
  	switch (SP_GetCh())
  	{
  	  case 0x0100:       // Key1: IOA[8] 
  	    SetLvdLevel(0);  // LVD Voltage level setup. P_Reset_LVD_Ctrl[1:0] = 0x00 => 3.2V   	    
  	    break;
  	    
  	  case 0x0200:       // Key2: IOA[9] 
  	    SetLvdLevel(1);  // LVD Voltage level setup. P_Reset_LVD_Ctrl[1:0] = 0x01 => 3.0V   	    
  	    break;  	    
  	    
  	  case 0x0400:       // Key3: IOA[10]  
  	    SetLvdLevel(2);  // LVD Voltage level setup. P_Reset_LVD_Ctrl[1:0] = 0x10 => 2.8V   	    
  	    break;   
  	    
  	  case 0x0800:       // Key4: IOA[11]  
  	    SetLvdLevel(3);  // LVD Voltage level setup. P_Reset_LVD_Ctrl[1:0] = 0x11 => 2.6V  	    
  	    break;  	    

  	  default:
  	    break;  	  	    	    	    
  	}  	

    //
    // Dectect Low Voltage 
    // - IOB[2] = 1 => VDD < VLVD
    // - IOB[2] = 0 => VDD > VLVD
    // 
    Low_Voltage_Dectect(); 
  }  

  return 0;
}
