//***************************************************************************************
// Header File Included Area
//***************************************************************************************
.include GPCE001.inc


//***************************************************************************************
// Function Call Publication Area
//***************************************************************************************
.public  _FlashProgram
.public F_FlashProgram


//***************************************************************************************
// Contant Defintion Area
//***************************************************************************************
.define C_Flash_Enable_Access_CMD		0xAAAA
.define C_Flash_PageErase_CMD			0x5511
.define C_Flash_Program_CMD				0x5533


//***************************************************************************************
// CODE Definition Area
//***************************************************************************************
.CODE

//*****************************************************************************
// Function    : F_FlashProgram
// Description : Internal Flash Program. This function will program R2 to the
//               [R1] flash address.
// Destroy     : 
// Parameter   : R1: Flash Address
//             : R2: Data 
// Return      : None
// Note        : None
//*****************************************************************************
_FlashProgram:   .proc
	R2 = SP + 3;
	R1 = [R2++];    
	R2 = [R2];
F_FlashProgram: 
    push R1, R3 to [sp];

    INT OFF;     
    R3 = C_Flash_Enable_Access_CMD; 
    [P_Flash_Ctrl] = R3;               // Enable flash access  
    R3 = C_Flash_PageErase_CMD; 
    [P_Flash_Ctrl] = R3;               // Page erase command
    [R1] = R3;                         // Write any value on [R1] to erase [R1]
    
    R3 = C_Flash_Enable_Access_CMD; 
    [P_Flash_Ctrl] = R3;               // Enable flash access 
    R3 = C_Flash_Program_CMD; 
    [P_Flash_Ctrl] = R3;               // Program command 
    [R1] = R2;                         // Program R2 to [R1];    
    
    pop R1, R3 from [sp];
    retf;
    .endp