//***************************************************************************************
// Header File Included Area
//***************************************************************************************
.include GPCE063.inc


//***************************************************************************************
// Function Call Publication Area
//***************************************************************************************
.public  _ADC_LineIn_Init
.public F_ADC_LineIn_Init

.public  _DAC_Initial
.public F_DAC_Initial


//***************************************************************************************
// RAM Definition Area
//***************************************************************************************
.RAM


//***************************************************************************************
// Table Definition Area
//***************************************************************************************
.TEXT


//***************************************************************************************
// CODE Definition Area
//***************************************************************************************
.CODE

//*****************************************************************************
// Function    : F_ADC_LineIn_Init
// Description : Initialize ADC
//               - Auto scan Mode 
//               - Line-in from IOB[0]
// Destroy     :  
// Parameter   : None 
// Return      : None
// Note        : None
//*****************************************************************************
_ADC_LineIn_Init:   .proc
F_ADC_LineIn_Init: 
    push R1 to [sp];

	R1 = C_ADC_Timer_A | C_ADC_Manual_AN0 | C_ADC_CLK_FPLL_Div_32 | C_ADC_Bias_Enable | C_ADC_Ch0_in_LineinPB0 | C_ADC_Enable;
	[P_ADC_Ctrl] = R1;
	
	//
	// Setting IOB[0] as input float
	//
	R1 = C_ADC_AN0_Enable;
    [P_ADC_LineIn_BitCtrl] = R1;
	
	//
	// Initialize TimerA interrupt: interrupt frequence 16KHz
	//
    R1 = C_TimerA_FPLL;				   
	[P_Timer_Ctrl] = R1;
	R1= C_Timer_Setting_16K;	       
	[P_TimerA_Data] = R1;
	[P_TimerA_CNTR] = R1;
	R1 = [P_INT_Ctrl];
	R1 |= C_IRQ0_TMA;
	[P_INT_Ctrl] = R1;	
    R1 = C_IRQ0_TMA;
	[P_INT_Status] = R1;	
	IRQ ON;
	
	pop R1 from [sp];
    retf
    .endp

//*****************************************************************************
// Function    : F_DAC_Initial
// Description : Initialize DAC 
// Destroy     :  
// Parameter   : None 
// Return      : None
// Note        : None
//*****************************************************************************
_DAC_Initial:   .proc
F_DAC_Initial:
    push R1 to [sp];
    
  	R1 = C_DAC_Enable | C_DAC_TMR_Sel_TimerA;
	[P_DAC_Ctrl] = R1;		

    pop R1 from [sp];
    retf
    .endp 
    
