//***************************************************************************************
// RAM Definition Area
//***************************************************************************************
unsigned int R_SPI_Buffer [16];  
unsigned int ManufacturerAndMemoryID;


//***************************************************************************************
// CODE Definition Area
//***************************************************************************************
unsigned int T_Data_Table[16] = {
 0x0000, 0x0001, 0x0002, 0x0003, 0x0004, 0x0005, 0x0006, 0x0007,
 0x0008, 0x0009, 0x000A, 0x000B, 0x000C, 0x000D, 0x000E, 0x000F  	
};

int main()
{   
  System_Initial();                                        // Initialize System
  SPI_Initial();                                           // Initialize SPI

  while(1)
  {
  	System_ServiceLoop();
  	switch (SP_GetCh())
  	{
      case 0x0001:      // Key1: IOA[0]. SPI read/write words 
        SPI_Flash_Block_Erase(0x0000, 0x0000);             // Erase block 0
        SPI_SendNWords(T_Data_Table, 16, 0x0000, 0x0000);  // Write T_Data_Table to SPI Flash
        SPI_ReadNWords(R_SPI_Buffer, 16, 0x0000, 0x0000);  // Read 16 words of Data from SPI Flash		  
        break;

      case 0x0002:      // Key2: IOA[1]. SPI read/write one word 
        SPI_Flash_Block_Erase(0x0001, 0x0000);             // Erase block 1
        SPI_SendAWord(0x0000, 0x0001, 0x5555);             // Write 0x5555 to the address:0x00010000
        R_SPI_Buffer[0] = SPI_ReadAWord(0x0000, 0x0001);   // Read one word from the address:0x00010000       
        break; 
        
      case 0x0004:      // Key3: IOA[2]. Read ID
        ManufacturerAndMemoryID = SPI_Read_Flash_ID();
        break;
                
      default: 
        break;             
  	}
  }

  return 0;
}
