//========================================================================================
// Progarm: ADC061 V1.1
// Description: This program shows user how to switch among the 8 A/D channels
//              provided by SPCE 061
// Written by : Arthur Shieh 
// Platform: SPCE061,IDE 1.631 , Windows 2000
// Last modified date: 
// 		2000/09/04 V1.0: first version
//      2002/09/29 V1.1: Split hardware.asm into the spce061.inc and SP_Lib.asm 
//                       rearrange and comment the program 
// Note:
//  1. IOA0~IOA7 are shared with A/D line-in. IOA0~6 must be "input with float". 
//  2. This program use key input from IOB0~IOB7 to select the A/D channel.
//  3. The ADC data will be fed to DAC as audio data; therefore user can hear 
//     the audio output from DAC if the A/D input is audio signal.
//  4. User is advised to be aware that the valid A/D range is from 0 to AVDD. 
//========================================================================================
#include "sp_lib.h"

int main(){
   int Key;
   
   InitAD_DA();
   System_Initial();	

	while(1){  
		Key = SP_GetCh();
		
 		switch(Key){
				case 0x00:
					break;
				case 0x01: // Mic 
					SP_SwitchChannel(0);
					break;
				case 0x02: // Line_in 1
					SP_SwitchChannel(1);
					break;
				case 0x04: // Line_in 2
     				SP_SwitchChannel(2);					
					break;	
				case 0x08: // Line_in 3
					SP_SwitchChannel(3);					
					break;		
				case 0x10: // Line_in 4
					SP_SwitchChannel(4);					
					break;		
				case 0x20: // Line_in 5
					SP_SwitchChannel(5);					
					break;	
				case 0x40: // Line_in 6
					SP_SwitchChannel(6);					
					break;		
				case 0x80: // Line_in 7
					SP_SwitchChannel(7);					
					break;																		
				default:
					break;
		}	// end of switch(Key)
		
		System_ServiceLoop();			// for key scanning				
    }
}