//////////////////////////////////////////////////////////////////
// Function: System commander                     
// Service for H/W, keyboard scan
// By Arthur Shieh
// Input: None
// Output: None

// Functions:
//	(In Assembly view)
// 	call F_System_Initial; 
//	(In C language view)
// 	System_Initial(); 
//////////////////////////////////////////////////////////////////

.include resource.inc;
.include spce.inc;
.include sp_lib.inc;

.public R_SpeechType;
.RAM
.VAR R_SpeechType;

.CODE
.public _System_Initial;
.public	F_System_Initial;
_System_Initial: .PROC
F_System_Initial:
  		//push	BP,BP to [SP];				//add if some parameters in
  		//BP = SP + 1;
		//r1 = [BP+3];
		//r2 = [BP+4];

		call	F_Key_Scan_Initial;			// For keyboard scan
		// Add other general initialization here
		R1=0x0080;                  // CPU CLock49.152 MHz
		[P_SystemClock]=R1;	
	
		// Set IOB as input for Key input
		R1=0x0000;
		[P_IOB_Dir]=R1;
		[P_IOB_Attrib]=R1;
	
		// Set IOA as input with float for A/D input
		[P_IOA_Dir]=R1;
		[P_IOA_Attrib]=R1;

		r1 =0x0001;						
		[P_IOA_Data]=R1;

		//pop		BP,BP from [SP];		
		retf;
		.ENDP;

//****************************************************************
// Function: Main Loop of system                     
// Input: None
// Output: None
// Using:
// 	call F_System_ServiceLoop; (in assembly domain)
//  System_ServiceLoop(); (in C domain) 	
//****************************************************************
.public _System_ServiceLoop;
.public	F_System_ServiceLoop;
_System_ServiceLoop: .PROC                  
F_System_ServiceLoop:
		call	F_Key_DebounceCnt_Down;		// calling debounce subroutine for key scan subroutine
		call    F_Key_Scan_ServiceLoop;		// calling key scan subroutine 
		// Add other general service functions here		
		R1=0x0001;                      // Clear watch dog
		[P_Watchdog_Clear]=R1;       	//
        retf;
        .ENDP;
        
    
