/////////////////////////////////////////////////////////////////
// Project: TestFlashROMAccess   V1.1
// Function:  SPCE061 is using Flash as ROM, this program tests the 
//            erasing,writing and reading data on the internal flash.
// Writen by: Arthur Shieh
// Platform: SPCE061, IDE 1.631,Windows 2000
// Date:
//          2002/09/19 V1.0: First version
//      	2002/09/29 V1.1: Split hardware.asm into the spce061.inc and SP_Lib.asm 
//                            rearrange and comment the program 
// Note:
//      1. This program tests the SPCE061 internal flash. It writes 0x100 data,
//         reads back 100 data and compare its consistency.
//      2. Number of errors will be shown on LEDs of IOA. 
//////////////////////////////////////////////////////////////////
#include "spce.h"
#include "sp_lib.h"


int main(){
	int Ret=0,data=0x100,j=0;
	int addr=0x8500;
	int i,Error=0;
	// Initialize CPU clock at 49.152MHz, Set PortA to be output buffer low
	System_Initial(); 
	
	  
	SP_PageErase(addr);
	// write 100 data
	for(addr=0x8500;addr<=0x8600 ;addr++){
  	  		SP_WriteWord(addr,data);
			data++;
   	}
		// Read data back and compare    
   	addr=0x8500;
   	data=0x0100;
    
    	// read 100 data back and compare
   	for(addr=0x8500;addr<=0x8600 ;addr++){

		Ret=SP_ReadWord(addr);
	
		SP_Export(P_IOA_Buffer,Ret);
	
		if (data!=Ret) Error++; // Error happens
   	  		data++; // increment data
   	}

    SP_Export(P_IOA_Buffer,Error);	
       
	while(1){	
	}

}