//////////////////////////////////////////////////////////////////
// Function: System commander                     
// 	Service for H/W, keyboard scan
// Input: None
// Output: None

// Functions:
//	(In Assembly view)
// 	call F_System_Initial; 
//	(In C language view)
// 	System_Initial(); 
//////////////////////////////////////////////////////////////////

.include spce.inc;

.CODE
.public _System_Initial;
.public	F_System_Initial;
_System_Initial: .PROC
F_System_Initial:
  		//push	BP to [SP];				//add if some parameters in
  		//BP = SP + 1;
		//r1 = [BP+3];
		//r2 = [BP+4];

		//call	F_Key_Scan_Initial;			// For keyboard scan
		R1 = 0x0080;                       // CPUClock= 49.152MHz
		//R1 = 0x0000;                       // CPUClock= 24.576MHz		
		[P_SystemClock] = R1;
		// Add other general initialization here
		
		call	F_User_Init_IO;				//	
		
		R1 = 0							// The interrupt is controlled by user
		//R1=C_FIQ_TMA
		//[R_InterruptStatus] = R1		//
		[P_INT_Ctrl] = R1				//
        
		//r1 =0x0001;						// return value
		//pop		BP from [SP];		
		retf;
		.ENDP;

//****************************************************************
// Function: Main Loop of system                     
// Input: None
// Output: None
// Using:
// 	call F_System_ServiceLoop; (in assembly domain)
//  System_ServiceLoop(); (in C domain) 	
//****************************************************************
.public _System_ServiceLoop;
.public	F_System_ServiceLoop;
_System_ServiceLoop: .PROC                  
F_System_ServiceLoop:
		//call	F_Key_DebounceCnt_Down;		// calling debounce subroutine for key scan subroutine
		//call    F_Key_Scan_ServiceLoop;		// calling key scan subroutine 
		// Add other general service functions here	
		R1=0x0001;                      // Clear watch dog
		[P_Watchdog_Clear]=R1;       	//	
        retf;
        .ENDP;
        
    
F_User_Init_IO:
		R1 = 0xFFFF;
        [P_IOA_Dir] = R1;                    // Port A0- A15: output(OH)
        [P_IOA_Data] = R1;                   // 
        [P_IOA_Attrib] = R1;                 //      

   		R1 = 0x0000;                         //
 	    [P_IOB_Dir] = R1;                    // Port B output/OH
        [P_IOB_Data] = R1;                   //
        [P_IOB_Attrib] = R1;                 //
                
        retf;         