//////////////////////////////////////////////////////////////////
// File: Serian RAM   V1.1
// Function:  SPCE061 using serial I/O to connect to SERIAL RAM
// Writen by: Arthur Shieh
// Platform: SPCE061A, IDE1.631,Windows 2000
// Date:
//      2002/09/10 V1.0: First version
//      2002/09/29 V1.1: Split hardware.asm into the spce061.inc and SP_Lib.asm 
//                        rearrange and comment the program 
// Note:
//      1. This program tests the serial RAM. It writes 100 data,
//         reads back 100 data and compare its consistency.
//      2. Serial RAM is connected to SPCE061 EMU 2.0
//         SCK : IOB0
//         SDA : IOB1 
//         VDD
//         VSS  
//         CS  : VSS 
//////////////////////////////////////////////////////////////////
#include "spce.h"
#include "sp_lib.h"

int main(){
	int Ret=0,addr=0,data=0,i,Error=0;
	
	// Initialize IOB0 as output for SCK,  Set PortA to be output buffer low
	System_Initial();   
	
	// write 100 data
	for(i=0;i<100;i++){
    	SP_SIOSendAByte(addr,data);
		addr++;
    	data++;
    }
	// Read data back and compare    
    addr=0;
    data=0x0000;
    // read data back and compare
    for(i=0;i<100;i++){

	Ret=SP_SIOReadAByte(addr);
	
	SP_Export(P_IOA_Buffer,Ret);
	
	if (data!=Ret) Error++; // Error happens

   	data++; // increment data
   	addr++; // increment address
    }

    SP_Export(P_IOA_Buffer,Error);	
    
    // Clear Watch dog
	while(1){	
		System_ServiceLoop();
	}

}