//====================================================================================
// Progarm: LED Display using port IOB  V1.1
// Plateform : SPCE 061, IDE 1.63 Windows 2000
// By Andy
// Modified by Arthur Shieh
//
// Date: 2000/07/25 V1.0
//       2002/09/29: V1.1  Split hardware.asm into the spce061.inc and SP_Lib.asm 
//                        rearrange and comment the program 
//
// Note:	1)Assembly only. 
//			2)The delay will be [0..65535].
//====================================================================================
.INCLUDE spce.inc;					// Include io API

.RAM
.VAR R_LedCounter;						// Define a RAM space for LED display
.VAR R_DelayCounter;					// Define a RAM space for Delay subroutine

.CODE
.public _main;							// _main: must be defined for system
_main:
		R1 = 0xFFFF;					//
		[P_IOB_Dir] = R1;				// Set port IOB output
		[P_IOB_Attrib] = R1;			// 
		
		R1 = 0x0000;					//		
		[P_IOB_Data] = R1;				//
			
		[R_LedCounter] = R1;			// Reset LED counter
	
L_MainLoop:
		
		R1 = [R_LedCounter];			//	
		[P_IOB_Data] = R1;				// Send counter data to	port IOB

		R1 = [R_LedCounter];			//
		R1 += 1;						// LED Counter add 1
		[R_LedCounter] = R1;			//	
			
		R1 = 0x0000;					// Reset Delay Counter
		[R_DelayCounter] = R1;			//
		call F_Delay;					// Delay sometime
			
	    jmp	L_MainLoop;					// go back to dispaly for ever
		
//////////////////////////////////////////	
//Function: Delay Subroutine 
//////////////////////////////////////////
F_Delay:
L_DelayLoop:	
		R1=0x0001;                      // Clear watch dog
		[P_Watchdog_Clear]=R1;       	//
		
		R1 = [R_DelayCounter];			//
		R1 += 1;						// Delay low counter add 1
		[R_DelayCounter] = R1;			//	
				
		jnz  L_DelayLoop;				// counter not reach 65536 times
		retf;							//
		
//====================================================================================
// End of main.asm
//====================================================================================