//====================================================================================
// Progarm: Get a key-code and save the key-code to the memroy(R_KeyCode). V1.1
// Plateform SPCE 061, IDE 1.63, Windows 2000
// Written by: Andy Hsu
// Modified by Arthur Shieh
//
// Date:2000/07/24: V1.0 
//      2002/09/29: V1.1  Split hardware.asm into the spce.inc and SP_Lib.asm 
//                        rearrange and comment the program 
//
// Note:1)Assembly only. 
//		2)The Key-code will be {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80}.
//		3)The Keypad is connected on IOA[7..0]
//		4)The Key-code will be displayed on Port IOB, while key be pressed.
//====================================================================================
.INCLUDE spce.inc;
.INCLUDE sP_lib.inc;						// Include key API

.RAM
.VAR R_KeyCode;							// define a memory space to save key-code

.CODE
.public _main;							// _main: must be defined for system
_main:
		call F_User_Init_IO;			// Initial IO port	
		call F_Key_Scan_Initial;		// Key scan initial
		
L_MainLoop:
		call F_Key_Scan_ServiceLoop;	// Scanning Key
        call F_Key_DebounceCnt_Down;	// Key debounce
        
		call F_SP_GetCh;				// Get a key-code
	    cmp R1, 0x0000;					// Check any key?
	    je 	L_MainLoop;					// No, go check again.
	    
		[R_KeyCode] = R1;				// Yes, save key code.
		[P_IOB_Buffer] = R1;			// LED display on port IOB	
		
		jmp	L_MainLoop;

//////////////////////////////////////////	
//Function: I/O initial Subroutine 
//////////////////////////////////////////
F_User_Init_IO:
		r1 = 0x0000;					// IOA: b[15..0] input
        [P_IOA_Dir] = r1;				// 
        [P_IOA_Attrib] = r1;
        [P_IOA_Data] = r1;
        
        r1 = 0xffff;					// IOB: b[15..0] output
        [P_IOB_Dir] = r1;				// 
        [P_IOB_Attrib] = r1;			
        r1 = 0x0000;
        [P_IOB_Data] = r1; 
		retf;

//====================================================================================
// End of main.asm
//====================================================================================