/*****************************************************************************/
// Program: Get a key-code V1.1
// Plateform SPCE 061, IDE 1.63, Windows 2000
// Written by Andy Hsu
// Modified by Arthur Shieh
//
// Date: 
// 		2000/07/24: V1.0
//      2002/09/29: V1.1  Split hardware.asm into the spce061.inc and SP_Lib.asm 
//                        rearrange and comment the program    
//
// Note:	1)IOA is connected to VCC the push button switch
//          2)IOB is connected to GND through LED and 1K ohm resisters
//          3)Press keys on IOA, LEDs on IOB will show the result. 
/*****************************************************************************/
#include "spce.h"

int main(){
 int Key;
 				//Dir,  Data,  Attrib		
	SP_Init_IOA(0x0000,0x0000,0x0000); 		// Set Port IOA to be input				 
	SP_Init_IOB(0xffff,0x0000,0xffff); 		// Set Port IOB to be output
	System_Initial();
	while(1){
		Key = SP_GetCh();
		
		switch(Key){
			case 0x0000:				// No Key input
				break;	
		
			case 0x0001:					// Key 1
			case 0x0002:					// Key 2
			case 0x0004:					// Key 3
			case 0x0008:					// Key 4
			case 0x0010:					// Key 5
			case 0x0020:					// Key 6
			case 0x0040:					// Key 7
			case 0x0080:					// Key 8
				SP_Export(P_IOB_Buffer,Key);	// Display Key-code on IOB
				break;
			default:
				break;	   
		}	
		System_ServiceLoop();
    }
}	