/******************************************
** Mini OS 1.5.0 head file               **
** Author :Taylor Wang                   **
** Date   :2003/1/22                     **
*******************************************/
#ifndef	__SPOS_H__
#define	__SPOS_H__
#include "sposconfig.h"
#include "sysstruct.h"
#include "sposbody.h"
//define OS err value
#define OS_NO_ERR					0			//no err
#define OS_IN_ISR					-1
#define OS_TIME_OUT					-2
//Init------------------------------------------
#define OS_OVER_MAX					-10
#define OS_UNDER_ONE				-11
// Start
#define	OS_NO_TASK					-10
//Task----------------------------------------------
#define OS_PRIO_INVALID				-5
#define OS_PRIO_EXIST				-6
#define OS_PRIO_NULL				-7
// TaskCreate
#define OS_NO_TCB					-10
// TaskResume
#define OS_RESUME_SELF				-10
#define OS_NO_SUSPEND				-11
// time resume
#define OS_NO_TIMEDLY				-10
//Event------------------------------------------
#define OS_PEVENT_NULL				-5
#define OS_ECB_TYYPE_ERR			-6
// MboxPost
#define OS_MBOX_FULL				-10
// Qpost and Qpost Front
#define OS_QUEUE_FULL				-10
// memory----------------------------------------
#define	OS_MEM_HANDLE_NULL			-5

#define	OS_MEM_INV_ADDR				-10
#define	OS_MEM_INV_BLKS				-11
#define	OS_MEM_INV_SIZE				-12
#define	OS_MEM_NOMCB				-13
// memory put
#define	OS_MEM_PBLK_NULL			-11
//Set vector-------------------------------------
#define		OS_NO_IFT				-10

// API function 
// System initialize
extern int SpSInit(void);
extern int SpSStart(void);
// Task Api
extern void SpSSchedLock(void);
extern void SpSSchedUnLock(void);
extern int SpSTaskCreate(pTask function,void *pParameter,void *pStackTop,int iPrio);
extern int SpSTaskExit(void);
extern int SpSTaskDel(unsigned int iPrio);
extern int SpSTaskResume(int iPrio);
extern int SpSTaskSuspend(int iPrio);
extern void SpSTimeDly(unsigned int iTimeCount);
extern int SpSTimeDlyResume(int iPrio);
extern int SpSGetPri(void);
// Event api
//semaphore
extern HEvent SpSSemCreate(unsigned int iValue);
extern int SpSSemPend(HEvent hEvent,unsigned int iTimeOut);
extern int SpSSemPost(HEvent hEvent);
extern int SpSSemAccept(HEvent hEvent);
//Mailbox
extern HEvent SpSMboxCreate(void* pMail);
extern void* SpSMboxPend(HEvent hEvent,unsigned int iTimeOut,int* err);
extern int SpSMboxPost(HEvent hEvent,void* pMail);
extern void* SpSMboxAccept(HEvent hEvent);
//Queue
extern HEvent SpSQCreate(void* pStart,unsigned int iSize);
extern void* SpSQPend(HEvent hEvent,unsigned int iTimeOut,int* err);
extern int SpSQPost(HEvent hEvent,void* pMsg);
extern int SpSQPostFront(HEvent hEvent,void* pMsg);
extern void* SpSQAccept(HEvent hEvent);

extern void SpSTimeTick(void);
//mm
extern HMem SpSMemCreate(void* pStart,unsigned int iBlock,unsigned int iSize,int *err);
extern void* SpSMemGet(HMem hMem);
extern void* SpSMemGetWait(HMem hMem,unsigned int iTimeOut,int *err);
extern int SpSMemPut(HMem hMem,void* pBlk);
//other
extern int SpSVersion(void);
//System macro define
#define SpFBreak()	\
	__asm__("break")
#endif
