//==========================================================================
// Description: Example code of I/O configuration
// Writer:      Jason Huang
// Date:        2009/01/22
// Platform:    GPF16001A, unSP IDE V3.0.6, windows XP
// Version:     V1.1
//==========================================================================
//**************************************************************************
// Header File Included Area
//**************************************************************************
#include  "..\include\GPF16001A.h"

//**************************************************************************
// Contant Defintion Area
//**************************************************************************


//**************************************************************************
// Function Call Publication Area
//**************************************************************************

//**************************************************************************
// Global Variable Defintion Area
//**************************************************************************
int main()
{
    // Set PortA as input pull low and driving current is 8mA
    *P_IOA_Dir = 0x0000;
    *P_IOA_Attrib = 0x0000;
    *P_IOA_Data = 0x0000;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;	

    // Set PortA as input pull high and driving current is 8mA
    *P_IOA_Dir = 0x0000;
    *P_IOA_Attrib = 0x0000;
    *P_IOA_Data = 0xFFFF;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;	

    // Set PortA as input float with wakeup and driving current is 8mA
    *P_IOA_Dir = 0x0000;
    *P_IOA_Attrib = 0xFFFF;
    *P_IOA_Data = 0x0000;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;

    // Set PortA as input float without wakeup and driving current is 8mA
    *P_IOA_Dir = 0x0000;
    *P_IOA_Attrib = 0xFFFF;
    *P_IOA_Data = 0xFFFF;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;

    // Set PortA as inverted output high and driving current is 8mA
    *P_IOA_Dir = 0xFFFF;
    *P_IOA_Attrib = 0x0000;
    *P_IOA_Data = 0x0000;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;

    // Set PortA as inverted output low and driving current is 8mA
    *P_IOA_Dir = 0xFFFF;
    *P_IOA_Attrib = 0x0000;
    *P_IOA_Data = 0xFFFF;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;

    // Set PortA as output high and driving current is 8mA
    *P_IOA_Dir = 0xFFFF;
    *P_IOA_Attrib = 0xFFFF;
    *P_IOA_Data = 0xFFFF;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;

    // Set PortA as output low and driving current is 8mA
    *P_IOA_Dir = 0xFFFF;
    *P_IOA_Attrib = 0xFFFF;
    *P_IOA_Data = 0x0000;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;
	
    // Set PortA as ODP output and driving current is 8mA
    *P_IOA_Dir = 0x0000;
    *P_IOA_Attrib = 0xFFFF;
    *P_IOA_Data = 0xFFFF;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;			
    *P_IOA_Dir = 0xFFFF;		// switch between float and output high through modify direction register only

    // Set PortA as ODN output and driving current is 8mA
    *P_IOA_Dir = 0x0000;
    *P_IOA_Attrib = 0xFFFF;
    *P_IOA_Data = 0x0000;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;
    *P_IOA_Dir = 0xFFFF;		// switch between float and output low through modify direction register only

    // Change PortA from input pull low to output buffer
    *P_IOA_Dir = 0x0000;
    *P_IOA_Attrib = 0x0000;
    *P_IOA_Data = 0x0000;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;
    *P_IOA_Attrib = 0xFFFF;		// Setting the attribution bit to 1 before the direction bit will not produce an unexpected short pulse
    *P_IOA_Dir = 0xFFFF;

    // Set PortA as output low and driving current is 8mA
    *P_IOA_Dir = 0xFFFF;
    *P_IOA_Attrib = 0xFFFF;
    *P_IOA_Data = 0x0000;
    *P_IOA_Drv = C_8mA << C_LSL_IOA7_0_DRV | C_8mA << C_LSL_IOA15_8_DRV;

    // Set PortB as input pull low and driving current is 8mA
    *P_IOB_Dir = 0xFFFF;
    *P_IOB_Attrib = 0xFFFF;
    *P_IOB_Data = 0x0000;
    *P_IOB_Drv = C_8mA << C_LSL_IOB3_0_DRV | C_8mA << C_LSL_IOB9_4_DRV | C_8mA << C_LSL_IOB15_10;

    while (1)
    {
        *P_IOA_Data = *P_IOB_Data;		// Get PortB pad data and send to PortA
        *P_IOA_Data = *P_IOB_Buffer;	// Get PortB buffer data(0x0000) and send to PortA
    }

    return 0;
}
