//==========================================================================
// Description: Example code of Real Time Clock(RTC)
// Writer:      Jason Huang
// Date:        2009/01/22
// Platform:    GPF16001A, unSP IDE V3.0.6, windows XP
// Version:     V1.1
//==========================================================================
//**************************************************************************
// Header File Included Area
//**************************************************************************
#include  "..\include\GPF16001A.h"

//**************************************************************************
// Contant Defintion Area
//**************************************************************************
#define INT_OFF()       asm("INT OFF;")
#define IRQ_ON()        asm("IRQ ON;")

// Setup current clock as 07:59:59(H:M:S)
#define SECOND          59
#define MINUTE          59
#define HOUR            7
// Setup alarm clock as 08:00:00(H:M:S)
#define ALARM_SECOND    0
#define ALARM_MINUTE    0
#define ALARM_HOUR      8

//**************************************************************************
// Function Call Publication Area
//**************************************************************************

//**************************************************************************
// Global Variable Defintion Area
//**************************************************************************

//**************************************************************************
// Main Program
//**************************************************************************
int main()
{
    INT_OFF();                      // Turn off IRQ and FIQ

    *P_IOB_Dir = 0x0003;            // Set PortB[1..0] as output low
    *P_IOB_Attrib = 0x0003;
    *P_IOB_Data = 0x0000;

    while (*P_RTC_Busy & C_SecondBusy)  // Wait RTC second idle state to make sure the new value write valid
    {
    }
    *P_Second = SECOND;                 // Setup new second

    while (*P_RTC_Busy & C_MinuteBusy)  // Wait RTC minute idle state to make sure the new value write valid
    {
    }
    *P_Minute = MINUTE;                 // Setup new minute

    while (*P_RTC_Busy & C_HourBusy)    // Wait RTC hour idle state to make sure the new value write valid
    {
    }
    *P_Hour = HOUR;                     // Setup new hour

    *P_Alarm_Second = ALARM_SECOND;
    *P_Alarm_Minute = ALARM_MINUTE;
    *P_Alarm_Hour = ALARM_HOUR;

    *P_RTC_INT_Ctrl = C_AlarmINT;   // Enable Alarm interrupt only
    *P_RTC_Ctrl = C_RTCEN | C_ALMEN | C_HMSEN | C_SCHEMEN; // Enable Alarm, Scheduler and Hour/Minute/Second/Half-Second 

    IRQ_ON();                       // Turn on IRQ
	
    while (1)
    {
    	
    }

    return 0;
}




