//==========================================================================
// Description: Example code of SPI Rx/Tx
// Writer:      Jason Huang
// Date:        2009/01/22
// Platform:    GPF16001A, unSP IDE V3.0.6, windows XP
// Version:     V1.1
//==========================================================================
//**************************************************************************
// Header File Included Area
//**************************************************************************
#include  "..\include\GPF16001A.h"

//**************************************************************************
// Contant Defintion Area
//**************************************************************************
#define INT_OFF()       asm("INT OFF;")
#define SPI_TEST_DATA       0x0050

//**************************************************************************
// Function Call Publication Area
//**************************************************************************

//**************************************************************************
// Global Variable Defintion Area
//**************************************************************************

//**************************************************************************
// Main Program
//**************************************************************************
int main()
{
    unsigned int temp;
    INT_OFF();                      // Turn off IRQ and FIQ

    *P_IOB_Dir = 0x0003;            // Set IOB[0:1] as output low
    *P_IOB_Attrib = 0x0003;
    *P_IOB_Data = 0x0000;

    *P_SPI_Ctrl = C_SPI_SoftReset;  
    *P_SPI_Ctrl = C_SPI_Enable | C_SPI_LoopBackMode | C_SPI_MasterMode | c_SPI_SysClk_Div_2;
    *P_SPI_Misc = C_SPI_FIFO_SmartMode;      

    *P_SPI_TX_Data = SPI_TEST_DATA; // TX data

    temp = *P_SPI_RX_Status;
    while (!(temp & 0x0001))        // Wait for data received
    {
        temp = *P_SPI_RX_Status;
    }

    temp = *P_SPI_RX_Data;          // RX data
    if (temp == SPI_TEST_DATA)
    {
        *P_IOB_Buffer |= 0x0001;    // Received data is ok
    }
    else
    {	
        *P_IOB_Buffer |= 0x0002;    // Received data is error
    }

	
    while (1)
    {

    }

    return 0;
}



