//==========================================================================
// Description: Example code of SPU PCM speech
// Writer:      Jason Huang
// Date:        2009/01/22
// Platform:    GPF16001A, unSP IDE V3.0.6, windows XP
// Version:     V1.1
//==========================================================================
//**************************************************************************
// Header File Included Area
//**************************************************************************
#include  "..\include\GPF16001A.h"
#include  "..\include\GPF16001A_SPU.h"

//**************************************************************************
// Contant Defintion Area
//**************************************************************************
#define INT_OFF()       asm("INT OFF;")
#define MAIN_VOLUME     0x0040

//**************************************************************************
// Function Call Publication Area
//**************************************************************************

//**************************************************************************
// External Table Declaration
//**************************************************************************
extern unsigned int RES_PCM_16K_16BIT_LIB_SA;

//**************************************************************************
// Global Variable Defintion Area
//**************************************************************************
unsigned int temp, *pPCM_Data;

//**************************************************************************
// Main Program
//**************************************************************************
int main()
{
    INT_OFF();                      // Turn off IRQ and FIQ

    pPCM_Data = (unsigned int *)&RES_PCM_16K_16BIT_LIB_SA;

    *P_SPU_CtrFlag = C_SATURATE | C_COMP_EN | C_CH_VOL_1_DIV_1 | C_INIT_ACC; 
    *P_SPU_CtrMainVol = MAIN_VOLUME;   
    *P_SPU_CtrDummy	= C_COMPRESS_PEAK_MODE | C_COMP_RATIO_1_DIV_INIF | C_RELEASE_TIME_MUL_1| C_ATTACK_TIME_MUL_1 | 0x7000; 
    *P_SPU_CtrAttRelTime = 0x8080;  // Compressor response time
	
    *P_CHA_Ctrl = C_FIFO_EmptyIntFlag | C_CHA_EN | C_VREF_EN; 

    temp = *pPCM_Data++;            // PCM wave start address low
    *P_SPU_ChWaveAddr = temp;		
    temp = *pPCM_Data;              // PCM wave start address high
    *P_SPU_ChMode = C_HW_AUTO_REPEAT_MODE | C_16BIT_DATA_MODE | temp | (temp << 6); 
    *P_SPU_ChLoopAddr = *(--pPCM_Data);
    *P_SPU_ChPan = 0x4040;
    *P_SPU_ChWaveData0 = 0x8000;
    *P_SPU_ChWaveData1 = 0x8000;

    *P_SPU_ChPhaseHi = 0x0000;      // Phase = SampleRate * 2^19 / 281250
    *P_SPU_ChPhase = 0x7482;        // Sampel Rate is 16000
    *P_SPU_ChPhaseAccumHi = 0x0000;
    *P_SPU_ChPhaseAccum = 0x0000;

    *P_SPU_CtrChEnvMode = 0x0001;   // Set envelope mode of channel0 as manual
    *P_SPU_ChEnvelopData = 0x0070;  // Set envelope is 70H

    *P_SPU_ChAdpcmSel = C_SET_UP_SRAM_VALUE;   

    *P_SPU_CtrChStopSts = 0x0001;   // Clear stop status
    *P_SPU_CtrChEn = 0x0001;        // Enable channel0, PCM speech starts playing repeatly without any CPU loading


    while (1)
    {

    }

    return 0;
}





