//==========================================================================
// Description: Example code of TimeBase
// Writer:      Jason Huang
// Date:        2009/01/22
// Platform:    GPF16001A, unSP IDE V3.0.6, windows XP
// Version:     V1.1
//==========================================================================
//**************************************************************************
// Header File Included Area
//**************************************************************************
#include  "..\include\GPF16001A.h"

//**************************************************************************
// Contant Defintion Area
//**************************************************************************
#define INT_OFF()   asm("INT OFF;")

//**************************************************************************
// Function Call Publication Area
//**************************************************************************

//**************************************************************************
// Global Variable Defintion Area
//**************************************************************************

//**************************************************************************
// Main Program
//**************************************************************************
int main()
{
    unsigned int temp;
    INT_OFF();                      // Turn off IRQ and FIQ

    *P_IOB_Dir = 0x0007;            // Set PortB[2..0] as output low
    *P_IOB_Attrib = 0x0007;
    *P_IOB_Data = 0x0000;

    *P_TimeBaseA_Ctrl = C_TimeBaseIntFlag | C_TimeBaseEn | C_TMBA_1Hz;
    *P_TimeBaseB_Ctrl = C_TimeBaseIntFlag | C_TimeBaseEn | C_TMBB_16Hz;    
    *P_TimeBaseC_Ctrl = C_TimeBaseIntFlag | C_TimeBaseEn | C_TMBC_256Hz;   
    *P_TimeBase_Reset = C_TMB_Reset;   

    while (1)
    {
        temp = *P_TimeBaseC_Ctrl; 
        if (temp & C_TimeBaseIntFlag)
        {
            *P_TimeBaseC_Ctrl = temp;   // Clear TimeBaseC interrupt flag
            *P_IOB_Buffer ^= 0x0004;    // Toggle IOB.2 (frequency = 128Hz)
        }

        temp = *P_TimeBaseB_Ctrl;   
        if (temp & C_TimeBaseIntFlag)
        {
            *P_TimeBaseB_Ctrl = temp;   // Clear TimeBaseB interrupt flag
            *P_IOB_Buffer ^= 0x0002;    // Toggle IOB.1 (frequency = 8Hz)
        }		

        temp = *P_TimeBaseA_Ctrl;   
        if (temp & C_TimeBaseIntFlag)
        {
            *P_TimeBaseA_Ctrl = temp;   // Clear TimeBaseA interrupt flag
            *P_IOB_Buffer ^= 0x0001;    // Toggle IOB.0 (frequency = 0.5Hz)
        }
    }

    return 0;
}
