//==========================================================================
// Description: Example code of TimerC Comparison
// Writer:      Jason Huang
// Date:        2009/01/22
// Platform:    GPF16001A, unSP IDE V3.0.6, windows XP
// Version:     V1.1
//==========================================================================
//**************************************************************************
// Header File Included Area
//**************************************************************************
#include  "..\include\GPF16001A.h"

//**************************************************************************
// Contant Defintion Area
//**************************************************************************
#define INT_OFF()   asm("INT OFF;")
#define SYS_CLK     96000000


//**************************************************************************
// Function Call Publication Area
//**************************************************************************

//**************************************************************************
// Global Variable Defintion Area
//**************************************************************************

//**************************************************************************
// Main Program
//**************************************************************************
int main()
{
    unsigned int temp;
    *P_IOB_Dir = 0x0001;            // Set PortB.0 as output low
    *P_IOB_Attrib = 0x0001;
    *P_IOB_Data = 0x0000;

    INT_OFF();                      // Turn off IRQ and FIQ

    *P_TimerC_CCP_Reg = SYS_CLK/2/1000; // Setup comparison value as 1000
    *P_TimerC_Preload = 0x0000;		 
    *P_TimerC_CCP_Ctrl = C_ComparisonEn | C_CMP_HighPulse;  // Enable comparison mode, high pulse on IOB.4
    *P_TimerC_Ctrl = C_Timer_IntFlag | C_Timer_Enable | C_SRCB_1 | C_SRCA_SysClk_Div_2;

    while (1)
    {
        temp = *P_TimerC_Ctrl;
        if (temp & C_Timer_IntFlag)
        {
            *P_TimerC_Ctrl = C_Timer_IntFlag;  // Clear TimerC comparison match interrupt flag and disable TimerC
            *P_TimerC_Preload = 0x0000;	
            *P_TimerC_Ctrl = C_Timer_IntFlag | C_Timer_Enable | C_SRCB_1 | C_SRCA_SysClk_Div_2;  
            *P_IOB_Buffer ^= 0x0001;    // Toggle PortB.0 for 50% duty square wave and frequency is 500Hz
        }		
    }

    return 0;
}



