//==========================================================================
// Description: Example code of TimerC Capture
// Writer:      Jason Huang
// Date:        2009/01/22
// Platform:    GPF16001A, unSP IDE V3.0.6, windows XP
// Version:     V1.1
//==========================================================================
//**************************************************************************
// Header File Included Area
//**************************************************************************
#include  "..\include\GPF16001A.h"

//**************************************************************************
// Contant Defintion Area
//**************************************************************************
#define IRQ_ON()    asm("IRQ ON;")
#define NOP()       asm("NOP;")

//**************************************************************************
// Function Call Publication Area
//**************************************************************************

//**************************************************************************
// Global Variable Defintion Area
//**************************************************************************

//**************************************************************************
// Main Program
//**************************************************************************
int main()
{
    unsigned int temp;

    *P_IOB_Dir = 0x0001;            // Set PortB.0 as output low
    *P_IOB_Attrib = 0x0001;
    *P_IOB_Data = 0x0000;

    *P_TimerD_Preload = C_Timer_Setting_500Hz; 
    *P_TimerD_Ctrl = C_Timer_Enable | C_SRCB_1 | C_SRCA_SysClk_Div_2; 

    IRQ_ON();                       // Turn on IRQ

    while (1)
    {
        temp = *P_TimerD_Ctrl;
        if (temp & C_Timer_IntFlag)
            {
                *P_TimerD_Ctrl = temp;     // Clear TimerD up-counter-overflow interrupt flag
                *P_IOB_Buffer |= 0x0001;   // Change PortB.0 from low to high for IOB.4 capture function, ISR called
                NOP();
                NOP();
                NOP();
                NOP();
                NOP();
                NOP();
                NOP();
                NOP();
                NOP();
                NOP();
                NOP();
                NOP();
                NOP();
                NOP();
                *P_TimerC_Ctrl = C_Timer_IntFlag;  // Disable TimerC
                *P_TimerC_Preload = 0x0000;		 
                *P_TimerC_CCP_Ctrl = C_CaptureEn | C_CAP_Rising;  // captured from IOB.4
                *P_TimerC_Ctrl = C_Timer_IntFlag | C_Timer_IntEnable | C_Timer_Enable | C_SRCB_1 | C_SRCA_SysClk_Div_2; 

                *P_IOB_Buffer &= ~0x0001;       // Change PortB.0 from high to low to prepare for capturing
            }	
        }
        while (1)
        {
    
        }

    return 0;
}


