#ifndef	__GPL169121_h__
#define	__GPL169121_h__
//	write your header here



//////////////////////////////////////////////////////////////////
//  Definitions for Peripheral Control Register
//////////////////////////////////////////////////////////////////
#define		P_System_Ctrl_Base            	0x7000
#define		P_IOHW_Ctrl_Base             	0x7030
#define		P_Mem_Ctrl_Base               	0x704C
#define		P_IOPort_Ctrl_Base            	0x7060
#define		P_Interrupt_Ctrl_Base         	0x70A0
#define		P_TimeBase_Ctrl_Base          	0x70B0
#define		P_Timer_Ctrl_Base              	0x70C0
#define		P_RFC_Base              	   	0x70DF
#define		P_AudioOuput_Ctrl_Base         	0x70E0
#define		P_UARTIrDA_Ctrl_Base           	0x7100
#define		P_SPI_Ctrl_Base                	0x7140
#define		P_ADC_Ctrl_Base                	0x7160
#define		P_LCD_Ctrol_Base               	0x7180
#define		P_KeyScan_Base				   	0x718D
#define		P_Miscellaneous_Base	       	0x7190
#define		P_USB_Base				   		0x7330
#define		P_BUSSEL_Base	       			0x7340

////////////////////////////////////////
//  System Control Registers
//      Base Address Start from 0x7000
////////////////////////////////////////
#define		P_BodyID						(volatile unsigned int*)(P_System_Ctrl_Base+0x00)
#define		P_BodyInfo						(volatile unsigned int*)(P_System_Ctrl_Base+0x01)
#define		P_Reset_Flag					(volatile unsigned int*)(P_System_Ctrl_Base+0x06)
#define		P_Clock_Ctrl                    (volatile unsigned int*)(P_System_Ctrl_Base+0x07)
#define		P_LVR_Ctrl                  	(volatile unsigned int*)(P_System_Ctrl_Base+0x08)
#define		P_LVD_Ctrl                 		(volatile unsigned int*)(P_System_Ctrl_Base+0x09)
#define		P_Watchdog_Ctrl                 (volatile unsigned int*)(P_System_Ctrl_Base+0x0A)
#define		P_Watchdog_Clear                (volatile unsigned int*)(P_System_Ctrl_Base+0x0B)
#define		P_WAIT                          (volatile unsigned int*)(P_System_Ctrl_Base+0x0C)
#define		P_HALT                          (volatile unsigned int*)(P_System_Ctrl_Base+0x0D)
#define		P_SLEEP                         (volatile unsigned int*)(P_System_Ctrl_Base+0x0E)
#define		P_HALT_WakeUP_Ctrl              (volatile unsigned int*)(P_System_Ctrl_Base+0x0F)
///////////////////////////////////////
//  LCD Hardwave Control Registers
//      Base Address Start from 0x7030
////////////////////////////////////////
#define		P_ComSegSwitch_Ctrl            (volatile unsigned int*)(P_IOHW_Ctrl_Base+0x00)
#define		P_IODLCD_Ctrl                  (volatile unsigned int*)(P_IOHW_Ctrl_Base+0x01)
#define		P_IOCLCD_Ctrl                  (volatile unsigned int*)(P_IOHW_Ctrl_Base+0x02)
#define		P_IOBADC_Ctrl                  (volatile unsigned int*)(P_IOHW_Ctrl_Base+0x05)

////////////////////////////////////////
//  Memory Control Registers
//      Base Address Start from 0x704C
////////////////////////////////////////
#define		P_InMEM_Ctrl                   (volatile unsigned int*)(P_Mem_Ctrl_Base+0x04)

////////////////////////////////////////
//  I/O Port Control Registers
//      Base Address Start from 0x7060
////////////////////////////////////////
#define		P_IOA_Data                     (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x00)
#define		P_IOA_Buffer                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x01)
#define		P_IOA_Dir                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x02)
#define		P_IOA_Attrib                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x03)
#define		P_IOA_Latch                    (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x04)
#define		P_IOA_STRBEN                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x05)
#define		P_IOA_SPH                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x06)
#define		P_IOA_KEN                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x07)

#define		P_IOB_Data                     (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x08)
#define		P_IOB_Buffer                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x09)
#define		P_IOB_Dir                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x0A)
#define		P_IOB_Attrib                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x0B)
#define		P_IOB_Latch                    (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x0C)
#define		P_IOB_STRBEN                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x0D)
#define		P_IOB_SPH                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x0E)
#define		P_IOB_KEN                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x0F)

#define		P_IOC_Data                     (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x10)
#define		P_IOC_Buffer                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x11)
#define		P_IOC_Dir                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x12)
#define		P_IOC_Attrib                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x13)
#define		P_IOC_Latch                    (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x04)
#define		P_IOC_STRBEN                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x05)
#define		P_IOC_SPH                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x06)
#define		P_IOC_KEN                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x07)

#define		P_IOD_Data                     (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x18)
#define		P_IOD_Buffer                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x19)
#define		P_IOD_Dir                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x1A)
#define		P_IOD_Attrib                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x1B)
#define		P_IOD_Latch                    (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x0C)
#define		P_IOD_STRBEN                   (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x0D)
#define		P_IOD_SPH                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x20)
#define		P_IOD_KEN                      (volatile unsigned int*)(P_IOPort_Ctrl_Base+0x21)

////////////////////////////////////////
//  Interrupt Control Registers
//      Base Address Start from 0x70A0
////////////////////////////////////////
#define		P_INT_Status1                  (volatile unsigned int*)(P_Interrupt_Ctrl_Base+0x00)
        #define C_INT_EXTA              0x0001
        #define	C_INT_DMA				0x0004
		#define	C_INT_USB				0x0008
        #define C_INT_AUDAFIFOEmpty     0x0010
        #define C_INT_AUDBFIFOEmpty     0x0020
        #define	C_INT_ADCAUTOFIFOFull	0x0080
        #define C_INT_FramePulse        0x0200
		#define	C_INT_SPI				0x0400
        #define C_INT_UARTIrDA          0x0800
        #define	C_INT_ADCReady			0x4000
        #define C_INT_Key               0x8000
#define		P_INT_Status2                  	(volatile unsigned int*)(P_Interrupt_Ctrl_Base+0x01)
        #define C_INT_HMS               0x0001
        #define C_INT_Alarm             0x0002
        #define C_INT_Schedule          0x0004
        #define C_INT_LVD	    	   	0x0080
        #define C_INT_TimeBaseA         0x0100
        #define C_INT_TimeBaseB         0x0200
        #define C_INT_TimeBaseC         0x0400
        #define C_INT_TimerA            0x1000
        #define C_INT_TimerB            0x2000
        #define C_INT_TimerC            0x4000
#define		P_INT_Priority1                	(volatile unsigned int*)(P_Interrupt_Ctrl_Base+0x04)
#define		P_INT_Priority2                	(volatile unsigned int*)(P_Interrupt_Ctrl_Base+0x05)
#define		P_MINT_Ctrl                    	(volatile unsigned int*)(P_Interrupt_Ctrl_Base+0x08)
#define		P_DMAINT_Ctrl                  	(volatile unsigned int*)(P_Interrupt_Ctrl_Base+0x0A)
        #define SPI_TX_INTEN         	0x0001
        #define SPI_RX_INTEN            0x0002
        #define DAC_TX_INTEN            0x0004
        #define ADC_RX_INTEN            0x0008

////////////////////////////////////////
//  TimeBase Control Registers
//      Base Address Start from 0x70B0
////////////////////////////////////////
#define		P_TimeBaseA_Ctrl               (volatile unsigned int*)(P_TimeBase_Ctrl_Base+0x00)
#define		P_TimeBaseB_Ctrl               (volatile unsigned int*)(P_TimeBase_Ctrl_Base+0x01)
#define		P_TimeBaseC_Ctrl               (volatile unsigned int*)(P_TimeBase_Ctrl_Base+0x02)
#define		P_TimeBase_Reset               (volatile unsigned int*)(P_TimeBase_Ctrl_Base+0x08)


////////////////////////////////////////
//  Timer Control Registers
//      Base Address Start from 0x70C0
////////////////////////////////////////
#define		P_TimerA_Ctrl                  (volatile unsigned int*)(P_Timer_Ctrl_Base+0x00)
#define		P_TimerA_CCP_Ctrl              (volatile unsigned int*)(P_Timer_Ctrl_Base+0x01)
#define		P_TimerA_Preload               (volatile unsigned int*)(P_Timer_Ctrl_Base+0x02)
#define		P_TimerA_CCP_Reg               (volatile unsigned int*)(P_Timer_Ctrl_Base+0x03)
#define		P_TimerA_CCP_UpCount           (volatile unsigned int*)(P_Timer_Ctrl_Base+0x04)
#define		P_TimerB_Ctrl                  (volatile unsigned int*)(P_Timer_Ctrl_Base+0x08)
#define		P_TimerB_Preload               (volatile unsigned int*)(P_Timer_Ctrl_Base+0x0A)
#define		P_TimerB_CCP_UpCount           (volatile unsigned int*)(P_Timer_Ctrl_Base+0x0C)
#define		P_TimerC_Ctrl                  (volatile unsigned int*)(P_Timer_Ctrl_Base+0x10)
#define		P_TimerC_Preload               (volatile unsigned int*)(P_Timer_Ctrl_Base+0x12)
#define		P_TimerC_UpCount               (volatile unsigned int*)(P_Timer_Ctrl_Base+0x14)

////////////////////////////////////////
//  RFC Control Registers
//      Base Address Start from 0x70DF
////////////////////////////////////////
#define		P_RFC_Ctrl                     (volatile unsigned int*)(P_RFC_Base+0x0)

////////////////////////////////////////
//  Audio Output Control Registers
//      Base Address Start from 0x70E0
////////////////////////////////////////
#define		P_AudioOut_Ctrl                	(volatile unsigned int*)(P_AudioOuput_Ctrl_Base+0x0)
#define		P_CHA_Ctrl                     	(volatile unsigned int*)(P_AudioOuput_Ctrl_Base+0x10)
#define		P_CHA_Data                     	(volatile unsigned int*)(P_AudioOuput_Ctrl_Base+0x11)
#define		P_CHA_FIFO                     	(volatile unsigned int*)(P_AudioOuput_Ctrl_Base+0x12)
#define		P_CHB_Ctrl                     	(volatile unsigned int*)(P_AudioOuput_Ctrl_Base+0x18)
#define		P_CHB_Data                     	(volatile unsigned int*)(P_AudioOuput_Ctrl_Base+0x19)
#define		P_CHB_FIFO                     	(volatile unsigned int*)(P_AudioOuput_Ctrl_Base+0x1A)                 
#define		P_DACDMA_START	             	(volatile unsigned int*)(P_AudioOuput_Ctrl_Base+0x0E)
#define		P_DACDMA_BC		             	(volatile unsigned int*)(P_AudioOuput_Ctrl_Base+0x0F) 
#define		P_DACDMA_STATUS               	(volatile unsigned int*)(P_AudioOuput_Ctrl_Base+0x1D)

////////////////////////////////////////
//  UART / IrDA Control Registers
//      Base Address Start from 0x7100
////////////////////////////////////////
#define		P_UARTIrDA_Data                (volatile unsigned int*)(P_UARTIrDA_Ctrl_Base+0x00)
#define		P_UART_RXStatus                (volatile unsigned int*)(P_UARTIrDA_Ctrl_Base+0x01)
#define		P_UARTIrDA_Ctrl                (volatile unsigned int*)(P_UARTIrDA_Ctrl_Base+0x02)
#define		P_UARTIrDA_BaudRate            (volatile unsigned int*)(P_UARTIrDA_Ctrl_Base+0x03)
#define		P_UARTIrDA_Status              (volatile unsigned int*)(P_UARTIrDA_Ctrl_Base+0x04)
#define		P_IrDA_Ctrl                    (volatile unsigned int*)(P_UARTIrDA_Ctrl_Base+0x08)


////////////////////////////////////////
//  RTC Control Regsiters
//      Base Address Start from 0x7120
////////////////////////////////////////
#define		P_Second                       (volatile unsigned int*)(P_RTC_Ctrl_Base+0x00)
#define		P_Minute                       (volatile unsigned int*)(P_RTC_Ctrl_Base+0x01)
#define		P_Hour                         (volatile unsigned int*)(P_RTC_Ctrl_Base+0x02)
#define		P_Alarm_Second                 (volatile unsigned int*)(P_RTC_Ctrl_Base+0x04)
#define		P_Alarm_Minute                 (volatile unsigned int*)(P_RTC_Ctrl_Base+0x05)
#define		P_Alarm_Hour                   (volatile unsigned int*)(P_RTC_Ctrl_Base+0x06)
#define		P_RTC_Ctrl                     (volatile unsigned int*)(P_RTC_Ctrl_Base+0x14)
        #define C_RTCEN                 0x8000
        #define C_ALMEN                 0x0400
        #define C_HMSEN                 0x0200
        #define C_SCHEMEN               0x0100
        #define C_16HzSchd              0x0000
        #define C_32HzSchd              0x0001
        #define C_64HzSchd              0x0002
        #define C_128HzSchd             0x0003
        #define C_256HzSchd             0x0004
        #define C_512HzSchd             0x0005
        #define C_1024HzSchd            0x0006
        #define C_2048HzSchd            0x0007
#define		P_RTC_INT_Status               (volatile unsigned int*)(P_RTC_Ctrl_Base+0x15)
#define		P_RTC_INT_Ctrl                 (volatile unsigned int*)(P_RTC_Ctrl_Base+0x16)
        #define C_HSecondINT            0x0001
        #define C_SecondINT             0x0002
        #define C_MinuteINT             0x0004
        #define C_HourINT               0x0008
        #define C_ScheduleINT           0x0100
        #define C_AlarmINT              0x0400


////////////////////////////////////////
//  SPI Control Registers
//      Base Address Start from 0x7140
////////////////////////////////////////
#define		P_SPI_Ctrl                  	(volatile unsigned int*)(P_SPI_Ctrl_Base+0x00)
#define		P_SPI_TXStatus                	(volatile unsigned int*)(P_SPI_Ctrl_Base+0x01)
#define		P_SPI_TXData	                (volatile unsigned int*)(P_SPI_Ctrl_Base+0x02)
#define		P_SPI_RXStatus                	(volatile unsigned int*)(P_SPI_Ctrl_Base+0x03)
#define		P_SPI_RXData   	        		(volatile unsigned int*)(P_SPI_Ctrl_Base+0x04)
#define		P_SPITXDMA_START 	        	(volatile unsigned int*)(P_SPI_Ctrl_Base+0x08)
#define		P_SPIRXDMA_START 	        	(volatile unsigned int*)(P_SPI_Ctrl_Base+0x09)
#define		P_SPITXDMA_BC 	        		(volatile unsigned int*)(P_SPI_Ctrl_Base+0x0A)
#define		P_SPIRXDMA_BC 	        		(volatile unsigned int*)(P_SPI_Ctrl_Base+0x0B)
#define		P_SPIDMA_STATUS   	        	(volatile unsigned int*)(P_SPI_Ctrl_Base+0x0D)

////////////////////////////////////////
//  Analog Input Control Registers
//      Base Address Start from 0x7160
////////////////////////////////////////
#define		P_ADC_Setup                   	(volatile unsigned int*)(P_ADC_Ctrl_Base+0x00)
#define		P_MADC_Ctrl                		(volatile unsigned int*)(P_ADC_Ctrl_Base+0x01)
#define		P_MADC_Data	                	(volatile unsigned int*)(P_ADC_Ctrl_Base+0x02)
#define		P_ASADC_Ctrl                	(volatile unsigned int*)(P_ADC_Ctrl_Base+0x03)
#define		P_ASADC_Data   	        		(volatile unsigned int*)(P_ADC_Ctrl_Base+0x04)
#define		P_ADCDMA_STATUS 	        	(volatile unsigned int*)(P_ADC_Ctrl_Base+0x0D)
#define		P_ADCDMA_START 	        	(volatile unsigned int*)(P_ADC_Ctrl_Base+0x0E)
#define		P_ADCDMA_BC 	        		(volatile unsigned int*)(P_ADC_Ctrl_Base+0x0F)


////////////////////////////////////////
//  LCD Control Registers
//      Base Address Start from 0x7180
////////////////////////////////////////
#define		P_LCD_Setup                   	(volatile unsigned int*)(P_LCD_Ctrol_Base+0x00)
#define		P_LCD_Clock                   	(volatile unsigned int*)(P_LCD_Ctrol_Base+0x01)
#define		P_LCD_Segment                 	(volatile unsigned int*)(P_LCD_Ctrol_Base+0x02)
#define		P_LCD_Common        	        (volatile unsigned int*)(P_LCD_Ctrol_Base+0x03)
#define		P_LCD_Frame_Ctrl 	            (volatile unsigned int*)(P_LCD_Ctrol_Base+0x08)
#define		P_LCD_BPP_Ctrl                	(volatile unsigned int*)(P_LCD_Ctrol_Base+0x09)
#define		P_VLCD_Ctrl	                  	(volatile unsigned int*)(P_LCD_Ctrol_Base+0x0A)
#define		P_PUMP_Ctrl                   	(volatile unsigned int*)(P_LCD_Ctrol_Base+0x0B)
#define		P_BIAS_Ctrl	                  	(volatile unsigned int*)(P_LCD_Ctrol_Base+0x0C)

////////////////////////////////////////
//  KeyScan Control Registers
//      Base Address Start from 0x718D
////////////////////////////////////////
#define		P_KEYSCAN_Ctrl				  	(volatile unsigned int*)(P_KeyScan_Base+0x00)
#define		P_KETSCAN_DATA					(volatile unsigned int*)(P_KeyScan_Base+0x01)

////////////////////////////////////////
//  Miscellaneous Control Registers
//      Base Address Start from 0x7190
////////////////////////////////////////
#define		P_Bit_ExtendA                 	(volatile unsigned int*)(P_Miscellaneous_Base+0x00)
#define		P_Bit_ExtendB                 	(volatile unsigned int*)(P_Miscellaneous_Base+0x01)
#define		P_Bit_ExtendC                 	(volatile unsigned int*)(P_Miscellaneous_Base+0x02)
#define		P_Bit_ExtendD                 	(volatile unsigned int*)(P_Miscellaneous_Base+0x03)
#define		P_Bit_ExtendE                 	(volatile unsigned int*)(P_Miscellaneous_Base+0x04)
#define		P_Bit_ExtendF                 	(volatile unsigned int*)(P_Miscellaneous_Base+0x05)
#define		P_Byte_Swap                   	(volatile unsigned int*)(P_Miscellaneous_Base+0x60)
#define		P_Nibble_Swap	                (volatile unsigned int*)(P_Miscellaneous_Base+0x61)
#define		P_TwoBit_Swap                	(volatile unsigned int*)(P_Miscellaneous_Base+0x62)
#define		P_Bit_Reverse	                (volatile unsigned int*)(P_Miscellaneous_Base+0x63)

////////////////////////////////////////
//  USB Control Registers
//      Base Address Start from 0x7330
////////////////////////////////////////
#define		P_USB_TN                 		(volatile unsigned int*)(P_USB_Base+0x00)
#define		P_USB_UP                 		(volatile unsigned int*)(P_USB_Base+0x01)
    #define C_EP2_UP					0x0004
    #define C_EP1_UP					0x0002
    #define C_EP0_UP					0x0001
#define		P_USB_DOWN                 		(volatile unsigned int*)(P_USB_Base+0x02)
    #define C_EP2_Down					0x0004
    #define C_EP1_Down					0x0002
    #define C_EP0_Down					0x0001
#define		P_USB_EOT                 		(volatile unsigned int*)(P_USB_Base+0x03)
    #define C_EOT2						0x0004
    #define C_EOT1						0x0002
    #define C_EOT0						0x0001
#define		P_USB_BC2                 		(volatile unsigned int*)(P_USB_Base+0x04)
#define		P_USB_BC1                 		(volatile unsigned int*)(P_USB_Base+0x05)
#define		P_USB_BC0                 		(volatile unsigned int*)(P_USB_Base+0x06)
#define		P_USB_STATUS                  	(volatile unsigned int*)(P_USB_Base+0x07)
    #define C_RReset					0x0008
    #define C_RSuspend					0x0004
    #define C_RSetup					0x0002
    #define C_RStall					0x0001
#define		P_USB_EPBUFFEN	                (volatile unsigned int*)(P_USB_Base+0x08)
    #define C_EN_EP3BUFF				0x0008
    #define C_EN_EP2BUFF				0x0004
    #define C_EN_EP1BUFF				0x0002
    #define C_EN_EP0BUFF				0x0001
#define		P_USB_BAEBAS                 	(volatile unsigned int*)(P_USB_Base+0x09)
#define		P_USB_SIECOM	                (volatile unsigned int*)(P_USB_Base+0x0A)
#define     P_USB_PHYCOM                    (volatile unsigned int*)(P_USB_Base+0x0A)
    #define C_PULL_H					0x0080
    #define C_Burst_Reset				0x0040
    #define C_PHYFIFOCnt_Reset 			0x0020
    #define C_PHY_Reset					0x0010
    #define C_SetResume					0x0008
    #define C_SetStall					0x0004
    #define C_SetAddr_Clear				0x0002
    #define C_PHYCLK_Reset				0x0001
#define		P_USB_DEVADDR                 	(volatile unsigned int*)(P_USB_Base+0x0B)
#define		P_USB_BC4	                	(volatile unsigned int*)(P_USB_Base+0x0C)
#define		P_USB_BC5                 		(volatile unsigned int*)(P_USB_Base+0x0D)
#define		P_USB_INTEN                 	(volatile unsigned int*)(P_USB_Base+0x0E)
    #define C_Status_INT_EN				0x0001
    #define C_Write_INT_EN				0x0002
    #define C_Read_INT_EN				0x0004
    #define C_PHY_En					0x0080
#define		P_USB_INTSTATUS                	(volatile unsigned int*)(P_USB_Base+0x0F)
    #define C_Status_INT_Flag			0x0001
    #define C_Write_INT_Flag			0x0002
    #define C_Read_INT_Flag				0x0004

////////////////////////////////////////
//  BUSSEL Control Registers
//      Base Address Start from 0x7340
////////////////////////////////////////
#define		P_SEL_BUFACTIVE               	(volatile unsigned int*)(P_BUSSEL_Base+0x00)
    #define C_ACT_BUFF4					0x0010
    #define C_ACT_BUFF3					0x0008
    #define C_ACT_BUFF2					0x0004
    #define C_ACT_BUFF1					0x0002
    #define C_ACT_BUFF0					0x0001
#define		P_LINK_BUF10                 	(volatile unsigned int*)(P_BUSSEL_Base+0x01)
#define		P_LINK_BUF32                 	(volatile unsigned int*)(P_BUSSEL_Base+0x02)
#define		P_LINK_BUF4                 	(volatile unsigned int*)(P_BUSSEL_Base+0x03)
#define C_Buffer0Addr			0x7400
#define C_Buffer1Addr			0x7440
#define C_Buffer2Addr			0x7480
#define C_Buffer3Addr			0x74C0
#define C_Buffer4Addr			0x7500
#define	P_BUF0				(volatile unsigned int*)(0x7400)  //R/W
#define	P_BUF1				(volatile unsigned int*)(0x7440)  //R/W
#define	P_BUF2				(volatile unsigned int*)(0x7480)  //R/W
#define	P_BUF3				(volatile unsigned int*)(0x74C0)  //R/W
#define	P_BUF4				(volatile unsigned int*)(0x7500)  //R/W
#define		P_SYSTEM_CTRL                 	(volatile unsigned int*)(P_BUSSEL_Base+0x05)

//========================================================================================
//Macro Name:	UserRomChecksum
//Parameters:	none
//Return Value:	ChecksumLowWord, ChecksumHighWord
//Description:	Calculate user ROM area code checksum
//Destroy:	r1, r2
//Stack Depth:	0
//Usage:	UserRomChecksum
//Example:	UserRomChecksum
//========================================================================================
#define UserRomChecksum(ChecksumLowWord, ChecksumHighWord)							\
	asm(												\
		".define		C_UserRomPage0Start			0x8000	\n"\
		".define		C_UserRomPage0End			0xFBFF	\n"\
		".define		C_UserRomVectorStart		0xFFF5	\n"\
		".define		C_UserRomVectorEnd			0xFFFF	\n"\
		".define		C_UserRomPageNStart			0x10000	\n"\
		".define		C_UserRomPageNEnd			0x47FFF	\n"\
				"push r3,r5 to [sp]						\n"\
				"r1 = 0									\n"\
				"r2 = 0									\n"\
				"r3 = C_UserRomPage0Start				\n"\
			"L_ChecksumLoop1:							\n"\
				"cmp	r3, (C_UserRomPage0End + 1)		\n"\
				"jz		L_NextAreaChecksum1				\n"\
				"r4 = [r3++]							\n"\
				"r5 = r4 & 0x00FF						\n"\
				"r1 += r5								\n"\
				"jcc		L_AddHighByte1				\n"\
				"r2 += 1								\n"\
			"L_AddHighByte1:							\n"\
				"r5 = r4 lsr 4							\n"\
				"r5 = r5 lsr 4							\n"\
				"r1 += r5								\n"\
				"jcc		L_ChecksumLoop1				\n"\
				"r2 += 1								\n"\
				"jmp		L_ChecksumLoop1				\n"\
			"L_NextAreaChecksum1:						\n"\
				"r3 = C_UserRomVectorStart				\n"\
			"L_ChecksumLoop2:							\n"\
				"cmp	r3, (C_UserRomVectorEnd + 1)	\n"\
				"jz		L_NextAreaChecksum2				\n"\
				"r4 = [r3++]							\n"\
				"r5 = r4 & 0x00FF						\n"\
				"r1 += r5								\n"\
				"jcc		L_AddHighByte2				\n"\
				"r2 += 1								\n"\
			"L_AddHighByte2:							\n"\
				"r5 = r4 lsr 4							\n"\
				"r5 = r5 lsr 4							\n"\
				"r1 += r5								\n"\
				"jcc		L_ChecksumLoop2				\n"\
				"r2 += 1								\n"\
				"jmp		L_ChecksumLoop2				\n"\
			"L_NextAreaChecksum2:						\n"\
				"r3 = (C_UserRomPageNStart >> 16)		\n"\
				"ds = r3								\n"\
				"r3 = (C_UserRomPageNStart & 0xFFFF)	\n"\
			"L_ChecksumLoop3:							\n"\
				"cmp	r3, ((C_UserRomPageNEnd & 0xFFFF) + 1)\n"\
				"jnz		L_SkipCheckHighAddr			\n"\
				"r4 = ds								\n"\
				"cmp	r4, (C_UserRomPageNEnd >> 16)	\n"\
				"jz		L_EndChecksum					\n"\
				"L_SkipCheckHighAddr:					\n"\
				"r4 = ds:[r3++]							\n"\
				"r5 = r4 & 0x00FF						\n"\
				"r1 += r5								\n"\
				"jcc		L_AddHighByte3				\n"\
				"r2 += 1								\n"\
			"L_AddHighByte3:							\n"\
				"r5 = r4 lsr 4							\n"\
				"r5 = r5 lsr 4							\n"\
				"r1 += r5								\n"\
				"jcc	L_ChecksumLoop3					\n"\
				"r2 += 1								\n"\
				"jmp	L_ChecksumLoop3					\n"\
			"L_EndChecksum:								\n"\
				"pop r3,r5 from [sp]					\n"\
				"%0 = r1								\n"\
				"%1 = r2								\n"\
			:					\
			:"m"(ChecksumLowWord),"m"(ChecksumHighWord)		\
		);	
	
	
#endif    
          