.DEFINE GPL169251 1


.DEFINE BODY_TYPE GPL169251


//////////////////////////////////////////////////////////////////
//  Definitions for Peripheral Control Register
//////////////////////////////////////////////////////////////////
P_System_Ctrl_Base:             .VDEF           0x7000
P_IOHW_Ctrl_Base:               .VDEF           0x7030
P_Mem_Ctrl_Base:              	.VDEF           0x704C
P_IOPort_Ctrl_Base:             .VDEF           0x7060
P_Interrupt_Ctrl_Base:          .VDEF           0x70A0
P_TimeBase_Ctrl_Base:           .VDEF           0x70B0
P_Timer_Ctrl_Base:              .VDEF           0x70C0
P_AudioOuput_Ctrl_Base:         .VDEF           0x70E0
P_UARTIrDA_Ctrl_Base:           .VDEF           0x7100
P_RTC_Ctrl_Base:                .VDEF           0x7120
P_SPI_Ctrl_Base:                .VDEF           0x7140
P_ADC_Ctrl_Base:                .VDEF           0x7160
P_LCD_Ctrl_Base:                .VDEF           0x7180
P_KeyScan_Ctrl_Base:			.VDEF			0x718D
P_Miscellaneous_Base:           .VDEF           0x7190
P_USB_Base:           			.VDEF           0x7330
P_BUSSEL_Base:           		.VDEF           0x7340

////////////////////////////////////////
//  System Control Registers
//      Base Address Start from 0x7000 
////////////////////////////////////////
P_BodyID:                       .VDEF   P_System_Ctrl_Base+0x00
P_BodyInfo:						.VDEF   P_System_Ctrl_Base+0x01
P_Reset_Flag:                   .VDEF   P_System_Ctrl_Base+0x06
P_Clock_Ctrl:                   .VDEF   P_System_Ctrl_Base+0x07
P_LVR_Ctrl:                     .VDEF   P_System_Ctrl_Base+0x08
P_LVD_Ctrl:                     .VDEF   P_System_Ctrl_Base+0x09
P_WatchDog_Ctrl:                .VDEF   P_System_Ctrl_Base+0x0A
P_WatchDog_Clear:               .VDEF   P_System_Ctrl_Base+0x0B
	.DEFINE		C_WatchDog_Clear		0xA005
P_WAIT:                         .VDEF   P_System_Ctrl_Base+0x0C
	.DEFINE     C_WaitMode_Entry		0x5005
P_HALT:                         .VDEF   P_System_Ctrl_Base+0x0D
	.DEFINE     C_HaltMode_Entry		0x500A
P_SLEEP:                        .VDEF   P_System_Ctrl_Base+0x0E
	.DEFINE     C_SleepMode_Entry		0xA00A
P_HALT_WakeUP_Ctrl:             .VDEF   P_System_Ctrl_Base+0x0F
///////////////////////////////////////
//  LCD Hardwave Control Registers
//      Base Address Start from 0x7030
////////////////////////////////////////
P_ComSegSwitch_Ctrl:            .VDEF   P_IOHW_Ctrl_Base+0x00
P_IODLCD_Ctrl:					.VDEF   P_IOHW_Ctrl_Base+0x01
P_IOCLCD_Ctrl:					.VDEF   P_IOHW_Ctrl_Base+0x02
P_IOBADC_Ctrl:					.VDEF   P_IOHW_Ctrl_Base+0x05

///////////////////////////////////////
//  Memory Control Registers
//      Base Address Start from 0x704C
////////////////////////////////////////
P_InMEM_Ctrl:                   .VDEF   P_Mem_Ctrl_Base+0x00

////////////////////////////////////////
//  I/O Port Control Registers
//      Base Address Start from 0x7060
////////////////////////////////////////
P_IOA_Data:                     .VDEF   P_IOPort_Ctrl_Base+0x00
P_IOA_Buffer:                   .VDEF   P_IOPort_Ctrl_Base+0x01
P_IOA_Dir:                      .VDEF   P_IOPort_Ctrl_Base+0x02
P_IOA_Attrib:                   .VDEF   P_IOPort_Ctrl_Base+0x03
P_IOA_Latch:                    .VDEF   P_IOPort_Ctrl_Base+0x04
P_IOA_STRBEN:					.VDEF   P_IOPort_Ctrl_Base+0x05
P_IOA_SPH:						.VDEF   P_IOPort_Ctrl_Base+0x06
P_IOA_KEN:						.VDEF   P_IOPort_Ctrl_Base+0x07

P_IOB_Data:                     .VDEF   P_IOPort_Ctrl_Base+0x08
P_IOB_Buffer:                   .VDEF   P_IOPort_Ctrl_Base+0x09
P_IOB_Dir:                      .VDEF   P_IOPort_Ctrl_Base+0x0A
P_IOB_Attrib:                   .VDEF   P_IOPort_Ctrl_Base+0x0B
P_IOB_Latch:                    .VDEF   P_IOPort_Ctrl_Base+0x0C
P_IOB_STRBEN:					.VDEF   P_IOPort_Ctrl_Base+0x0D
P_IOB_SPH:						.VDEF   P_IOPort_Ctrl_Base+0x0E
P_IOB_KEN:						.VDEF   P_IOPort_Ctrl_Base+0x0F

P_IOC_Data:                     .VDEF   P_IOPort_Ctrl_Base+0x10
P_IOC_Buffer:                   .VDEF   P_IOPort_Ctrl_Base+0x11
P_IOC_Dir:                      .VDEF   P_IOPort_Ctrl_Base+0x12
P_IOC_Attrib:                   .VDEF   P_IOPort_Ctrl_Base+0x13
P_IOC_Latch:					.VDEF   P_IOPort_Ctrl_Base+0x14
P_IOC_STRBEN:					.VDEF   P_IOPort_Ctrl_Base+0x15
P_IOC_SPH:						.VDEF   P_IOPort_Ctrl_Base+0x16
P_IOC_KEN:						.VDEF   P_IOPort_Ctrl_Base+0x17

P_IOD_Data:                     .VDEF   P_IOPort_Ctrl_Base+0x18
P_IOD_Buffer:                   .VDEF   P_IOPort_Ctrl_Base+0x19
P_IOD_Dir:                      .VDEF   P_IOPort_Ctrl_Base+0x1A
P_IOD_Attrib:                   .VDEF   P_IOPort_Ctrl_Base+0x1B
P_IOD_Latch:					.VDEF   P_IOPort_Ctrl_Base+0x1C
P_IOD_STRBEN:					.VDEF   P_IOPort_Ctrl_Base+0x1D
P_IOD_SPH:						.VDEF   P_IOPort_Ctrl_Base+0x1E
P_IOD_KEN:						.VDEF   P_IOPort_Ctrl_Base+0x1F

////////////////////////////////////////
//  Interrupt Control Registers
//      Base Address Start from 0x70A0
////////////////////////////////////////
P_INT_Status1:                  .VDEF   P_Interrupt_Ctrl_Base+0x00
	.DEFINE C_INT_EXT					0x0001;
	.DEFINE	C_INT_DMA					0x0004;
	.DEFINE	C_INT_USB					0x0008;
	.DEFINE C_INT_AUDAFIFOEmpty	     	0x0010;
	.DEFINE C_INT_AUDBFIFOEmpty 	    0x0020;
	.DEFINE	C_INT_ADCAUTOFIFOFull		0x0080;
	.DEFINE C_INT_FramePulse	        0x0200;
	.DEFINE	C_INT_SPI					0x0400;
	.DEFINE C_INT_UARTIrDA          	0x0800;
	.DEFINE	C_INT_ADCReady				0x4000
	.DEFINE C_INT_Key       	        0x8000;
P_INT_Status2:                  .VDEF   P_Interrupt_Ctrl_Base+0x01
	.DEFINE C_INT_HMS	                0x0001;
	.DEFINE C_INT_Alarm 	            0x0002;
	.DEFINE C_INT_Schedule  	        0x0004;
	.DEFINE C_INT_LVD	               	0x0080;
	.DEFINE C_INT_TimeBaseA	         	0x0100;
	.DEFINE C_INT_TimeBaseB 	        0x0200;
	.DEFINE C_INT_TimeBaseC     	    0x0400;
	.DEFINE C_INT_TimerA            	0x1000;
	.DEFINE C_INT_TimerB        	    0x2000;
	.DEFINE C_INT_TimerC            	0x4000;
P_INT_Priority1:                .VDEF   P_Interrupt_Ctrl_Base+0x04
P_INT_Priority2:                .VDEF   P_Interrupt_Ctrl_Base+0x05
P_MINT_Ctrl:                    .VDEF   P_Interrupt_Ctrl_Base+0x08
P_DMAINT_Ctrl:                  .VDEF   P_Interrupt_Ctrl_Base+0x0A
	.DEFINE SPI_TX_INTEN	         	0x0001;
	.DEFINE SPI_RX_INTEN    	        0x0002;
	.DEFINE DAC_TX_INTEN        	    0x0004;
	.DEFINE ADC_RX_INTEN            	0x0008;

////////////////////////////////////////
//  TimeBase Control Registers
//      Base Address Start from 0x70B0
////////////////////////////////////////
P_TimeBaseA_Ctrl:               .VDEF   P_TimeBase_Ctrl_Base+0x00
P_TimeBaseB_Ctrl:               .VDEF   P_TimeBase_Ctrl_Base+0x01
P_TimeBaseC_Ctrl:               .VDEF   P_TimeBase_Ctrl_Base+0x02
P_TimeBase_Reset:               .VDEF   P_TimeBase_Ctrl_Base+0x08


////////////////////////////////////////
//  Timer Control Registers            
//      Base Address Start from 0x70C0                                       
////////////////////////////////////////                                     
P_TimerA_Ctrl:                  .VDEF   P_Timer_Ctrl_Base+0x00
P_TimerA_CCP_Ctrl:              .VDEF   P_Timer_Ctrl_Base+0x01
P_TimerA_Preload:               .VDEF   P_Timer_Ctrl_Base+0x02
P_TimerA_CCP_Reg:               .VDEF   P_Timer_Ctrl_Base+0x03
P_TimerA_UpCount:               .VDEF   P_Timer_Ctrl_Base+0x04
P_TimerB_Ctrl:                  .VDEF   P_Timer_Ctrl_Base+0x08
P_TimerB_Preload:               .VDEF   P_Timer_Ctrl_Base+0x0A
P_TimerB_UpCount:               .VDEF   P_Timer_Ctrl_Base+0x0C
P_TimerC_Ctrl:                  .VDEF   P_Timer_Ctrl_Base+0x10
P_TimerC_Preload:               .VDEF   P_Timer_Ctrl_Base+0x12
P_TimerC_UpCount:               .VDEF   P_Timer_Ctrl_Base+0x14

////////////////////////////////////////
//  Audio Output Control Registers
//      Base Address Start from 0x70E0
////////////////////////////////////////
P_AudioOut_Ctrl:                .VDEF   P_AudioOuput_Ctrl_Base+0x00
P_SampleRate_Ctrl:				.VDEF	P_AudioOuput_Ctrl_Base+0x08
P_CHA_Ctrl:                     .VDEF   P_AudioOuput_Ctrl_Base+0x10
P_CHA_Data:                     .VDEF   P_AudioOuput_Ctrl_Base+0x11
P_CHA_FIFO:                     .VDEF   P_AudioOuput_Ctrl_Base+0x12
P_CHB_Ctrl:                     .VDEF   P_AudioOuput_Ctrl_Base+0x18
P_CHB_Data:                     .VDEF   P_AudioOuput_Ctrl_Base+0x19
P_CHB_FIFO:                     .VDEF   P_AudioOuput_Ctrl_Base+0x1A
P_DACDMA_START:             	.VDEF   P_AudioOuput_Ctrl_Base+0x0E
P_DACDMA_BC:             		.VDEF   P_AudioOuput_Ctrl_Base+0x0F
P_DACDMA_STATUS:               	.VDEF   P_AudioOuput_Ctrl_Base+0x1D

////////////////////////////////////////
//  UART / IrDA Control Registers
//      Base Address Start from 0x7100
////////////////////////////////////////
P_UARTIrDA_Data:                .VDEF   P_UARTIrDA_Ctrl_Base+0x00
P_UART_RXStatus:                .VDEF   P_UARTIrDA_Ctrl_Base+0x01
P_UARTIrDA_Ctrl:                .VDEF   P_UARTIrDA_Ctrl_Base+0x02
P_UARTIrDA_BaudRate:            .VDEF   P_UARTIrDA_Ctrl_Base+0x03
P_UARTIrDA_Status:              .VDEF   P_UARTIrDA_Ctrl_Base+0x04
P_IrDA_Ctrl:                    .VDEF   P_UARTIrDA_Ctrl_Base+0x08


////////////////////////////////////////
//  RTC Control Regsiters
//      Base Address Start from 0x7120
////////////////////////////////////////
P_Second:                       .VDEF   P_RTC_Ctrl_Base+0x00
P_Minute:                       .VDEF   P_RTC_Ctrl_Base+0x01
P_Hour:                         .VDEF   P_RTC_Ctrl_Base+0x02
P_Alarm_Second:                 .VDEF   P_RTC_Ctrl_Base+0x04
P_Alarm_Minute:                 .VDEF   P_RTC_Ctrl_Base+0x05
P_Alarm_Hour:                   .VDEF   P_RTC_Ctrl_Base+0x06
P_RTC_Ctrl:                     .VDEF   P_RTC_Ctrl_Base+0x14
	.DEFINE C_RTCEN		                0x8000
	.DEFINE C_ALMEN     	            0x0400
	.DEFINE C_HMSEN         	        0x0200
	.DEFINE C_SCHEMEN           	    0x0100
	.DEFINE C_16HzSchd              	0x0000
	.DEFINE C_32HzSchd	              	0x0001
	.DEFINE C_64HzSchd  	            0x0002
	.DEFINE C_128HzSchd     	        0x0003
	.DEFINE C_256HzSchd         	    0x0004
	.DEFINE C_512HzSchd             	0x0005
	.DEFINE C_1024HzSchd            	0x0006
	.DEFINE C_2048HzSchd            	0x0007
P_RTC_INT_Status:               .VDEF   P_RTC_Ctrl_Base+0x15
P_RTC_INT_Ctrl:                 .VDEF   P_RTC_Ctrl_Base+0x16
	.DEFINE C_HSecondINT	            0x0001
	.DEFINE C_SecondINT     	        0x0002
	.DEFINE C_MinuteINT         	    0x0004
	.DEFINE C_HourINT               	0x0008
	.DEFINE C_ScheduleINT	           	0x0100
	.DEFINE C_AlarmINT      	        0x0400

                                        
////////////////////////////////////////
//  SPI Control Registers               
//      Base Address Start from 0x7140  
////////////////////////////////////////
P_SPI_Ctrl:                     .VDEF   P_SPI_Ctrl_Base+0x00
P_SPI_TXStatus:                 .VDEF   P_SPI_Ctrl_Base+0x01
P_SPI_TXData:	                .VDEF   P_SPI_Ctrl_Base+0x02
P_SPI_RXStatus:                 .VDEF   P_SPI_Ctrl_Base+0x03
P_SPI_RXData:   	        	.VDEF   P_SPI_Ctrl_Base+0x04
P_SPITXDMA_Start:   	        .VDEF   P_SPI_Ctrl_Base+0x08
P_SPIRXDMA_Start:   	        .VDEF   P_SPI_Ctrl_Base+0x09
P_SPITXDMA_BC:   	        	.VDEF   P_SPI_Ctrl_Base+0x0A
P_SPIRXDMA_BC:   	        	.VDEF   P_SPI_Ctrl_Base+0x0B
P_SPIDMA_Status:   	        	.VDEF   P_SPI_Ctrl_Base+0x0D                                        
	.DEFINE C_SPITX_CF					0x0001
	.DEFINE C_SPIRX_CF					0x0002
////////////////////////////////////////
//  Analog Input Control Registers               
//      Base Address Start from 0x7160  
////////////////////////////////////////
P_ADC_Setup:					.VDEF	P_ADC_Ctrl_Base+0x00
P_MADC_Ctrl:					.VDEF	P_ADC_Ctrl_Base+0x01
P_MADC_Data:					.VDEF	P_ADC_Ctrl_Base+0x02
P_ASADC_Ctrl:					.VDEF	P_ADC_Ctrl_Base+0x03
P_ASADC_Data:					.VDEF	P_ADC_Ctrl_Base+0x04
P_ADCDMA_STATUS:				.VDEF	P_ADC_Ctrl_Base+0x0D
P_ADCDMA_START:					.VDEF	P_ADC_Ctrl_Base+0x0E
P_ADCDMA_BC:					.VDEF	P_ADC_Ctrl_Base+0x0F
                                     

////////////////////////////////////////
//  LCD Control Registers               
//      Base Address Start from 0x7180  
////////////////////////////////////////
P_LCD_Setup:                    .VDEF   P_LCD_Ctrl_Base+0x00
P_LCD_Clock:                    .VDEF   P_LCD_Ctrl_Base+0x01
P_LCD_Segment:                  .VDEF   P_LCD_Ctrl_Base+0x02
P_LCD_Common:                   .VDEF   P_LCD_Ctrl_Base+0x03
P_LCD_Frame_Ctrl:               .VDEF   P_LCD_Ctrl_Base+0x08
P_LCD_BPP_Ctrl:             	.VDEF   P_LCD_Ctrl_Base+0x09
P_VLCD_Ctrl:					.VDEF   P_LCD_Ctrl_Base+0x0a
P_PUMP_Ctrl:					.VDEF   P_LCD_Ctrl_Base+0x0b
P_BIAS_Ctrl:					.VDEF   P_LCD_Ctrl_Base+0x0c
                                        

////////////////////////////////////////
//  Key Scan Control Registers               
//      Base Address Start from 0x718D  
////////////////////////////////////////                                        
P_KEYSCAN_Ctrl:					.VDEF	  P_KeyScan_Ctrl_Base+0x00
P_KETSCAN_DATA:					.VDEF   P_KeyScan_Ctrl_Base+0x01                                   
                                      
////////////////////////////////////////
// Miscellaneous Specified Registers
//      Base Address Start from 0x7190
////////////////////////////////////////
P_Bit_ExtendA:                  .VDEF   P_Miscellaneous_Base+0x0000
P_Bit_ExtendB:                  .VDEF   P_Miscellaneous_Base+0x0001
P_Bit_ExtendC:                  .VDEF   P_Miscellaneous_Base+0x0002
P_Bit_ExtendD:                  .VDEF   P_Miscellaneous_Base+0x0003
P_Bit_ExtendE:                  .VDEF   P_Miscellaneous_Base+0x0004
P_Bit_ExtendF:                  .VDEF   P_Miscellaneous_Base+0x0005
P_Byte_Swap:                    .VDEF   P_Miscellaneous_Base+0x0060
P_Nibble_Swap:                  .VDEF   P_Miscellaneous_Base+0x0061
P_TwoBit_Swap:                  .VDEF   P_Miscellaneous_Base+0x0062
P_Bit_Reverse:                  .VDEF   P_Miscellaneous_Base+0x0063

////////////////////////////////////////
// USB Control Registers
//      Base Address Start from 0x7330
////////////////////////////////////////
P_USB_TN:                  		.VDEF   P_USB_Base+0x0000
P_USB_UP:                  		.VDEF   P_USB_Base+0x0001
	.DEFINE C_EP2_UP					0x0004
	.DEFINE C_EP1_UP					0x0002
	.DEFINE C_EP0_UP					0x0001
P_USB_DOWN:                  	.VDEF   P_USB_Base+0x0002
	.DEFINE C_EP2_Down					0x0004
	.DEFINE C_EP1_Down					0x0002
	.DEFINE C_EP0_Down					0x0001
P_USB_EOT:                  	.VDEF   P_USB_Base+0x0003
	.DEFINE C_EOT2						0x0004
	.DEFINE C_EOT1						0x0002
	.DEFINE C_EOT0						0x0001
P_USB_BC2:                  	.VDEF   P_USB_Base+0x0004
P_USB_BC1:                  	.VDEF   P_USB_Base+0x0005
P_USB_BC0:                  	.VDEF   P_USB_Base+0x0006
P_USB_STATUS:                   .VDEF   P_USB_Base+0x0007
	.DEFINE C_RReset					0x0008
	.DEFINE C_RSuspend					0x0004
	.DEFINE C_RSetup					0x0002
	.DEFINE C_RStall					0x0001
P_USB_EPBUFFEN:                 .VDEF   P_USB_Base+0x0008
	.DEFINE C_EN_EP3BUFF				0x0008
	.DEFINE C_EN_EP2BUFF				0x0004
	.DEFINE C_EN_EP1BUFF				0x0002
	.DEFINE C_EN_EP0BUFF				0x0001
P_USB_BAEBAS:                  	.VDEF   P_USB_Base+0x0009
P_USB_PHYCOM:                  	.VDEF   P_USB_Base+0x000A
	.DEFINE C_PULL_H					0x0080
	.DEFINE C_Burst_Reset				0x0040
	.DEFINE C_PHYFIFOCnt_Reset 			0x0020
	.DEFINE C_PHY_Reset					0x0010
	.DEFINE C_SetResume					0x0008
	.DEFINE C_SetStall					0x0004
	.DEFINE C_SetAddr_Clear				0x0002
	.DEFINE C_PHYCLK_Reset				0x0001
P_USB_DEVADDR:                  .VDEF   P_USB_Base+0x000B
P_USB_BC4:                  	.VDEF   P_USB_Base+0x000C
P_USB_BC5:                  	.VDEF   P_USB_Base+0x000D
P_USB_INTEN:                  	.VDEF   P_USB_Base+0x000E
	.DEFINE C_Status_INT_EN				0x0001
	.DEFINE C_Write_INT_EN				0x0002
	.DEFINE C_Read_INT_EN				0x0004
	.DEFINE C_PHY_En					0x0080
P_USB_INTSTATUS:                .VDEF   P_USB_Base+0x000F
	.DEFINE C_Status_INT_Flag			0x0001
	.DEFINE C_Write_INT_Flag			0x0002
	.DEFINE C_Read_INT_Flag				0x0004
////////////////////////////////////////
// BUSSEL Control Registers
//      Base Address Start from 0x7340
////////////////////////////////////////
P_SEL_BUFACTIVE:                .VDEF   P_BUSSEL_Base+0x0000
	.DEFINE C_ACT_BUFF4					0x0010
	.DEFINE C_ACT_BUFF3					0x0008
	.DEFINE C_ACT_BUFF2					0x0004
	.DEFINE C_ACT_BUFF1					0x0002
	.DEFINE C_ACT_BUFF0					0x0001
P_LINK_BUF10:                	.VDEF   P_BUSSEL_Base+0x0001
P_LINK_BUF32:                	.VDEF   P_BUSSEL_Base+0x0002
P_LINK_BUF4:                	.VDEF   P_BUSSEL_Base+0x0003
	.DEFINE C_BUFF0Addr					0x7400
	.DEFINE C_BUFF1Addr					0x7440
	.DEFINE C_BUFF2Addr					0x7480
	.DEFINE C_BUFF3Addr					0x74C0
	.DEFINE C_BUFF4Addr					0x7500
P_SYSTEM_Ctrl:					.VDEF   P_BUSSEL_Base+0x0005
//========================================================================================
// End of include file
//========================================================================================


//========================================================================================
//Macro Name:	M_ClearWatchdog
//Parameters:	none
//Return Value:	none
//Description:	setup data segment(DS) of CPU
//Destroy:	r1
//Stack Depth:	0
//Usage:	M_ClearWatchdog
//Example:	M_ClearWatchdog
//========================================================================================
M_ClearWatchdog:	.MACRO
		r1 = 0xA005
		[P_Watchdog_Clear] = r1
		.ENDM
			
//========================================================================================
//Macro Name:	M_UserRomChecksum
//Parameters:	none
//Return Value:	r1: Checksum Low Word, r2: Checksum High Word
//Description:	Calculate user ROM area code checksum
//Destroy:	r1, r2
//Stack Depth:	0
//Usage:	M_UserRomChecksum
//Example:	M_UserRomChecksum
//========================================================================================
	.DEFINE		C_UserRomPage0Start			0x8000
	.DEFINE		C_UserRomPage0End			0xFBFF
	.DEFINE		C_UserRomVectorStart		0xFFF5
	.DEFINE		C_UserRomVectorEnd			0xFFFF
	.DEFINE		C_UserRomPageNStart			0x10000
	.DEFINE		C_UserRomPageNEnd			0x47FFF
	
M_UserRomChecksum:	.MACRO
	r1 = 0
	r2 = 0
	push r3, r5 to [sp]
	r3 = C_UserRomPage0Start
L_ChecksumLoop1:
	cmp		r3, (C_UserRomPage0End + 1)
	jz		L_NextAreaChecksum1
	r4 = [r3++]
	r5 = r4 & 0x00FF
	r1 += r5
	jcc		L_AddHighByte1
	r2 += 1

L_AddHighByte1:
	r5 = r4 lsr 4
	r5 = r5 lsr 4
	r1 += r5	
	jcc		L_ChecksumLoop1
	r2 += 1
	jmp		L_ChecksumLoop1
	
L_NextAreaChecksum1:
	r3 = C_UserRomVectorStart
L_ChecksumLoop2:
	cmp		r3, (C_UserRomVectorEnd + 1)
	jz		L_NextAreaChecksum2
	r4 = [r3++]
	r5 = r4 & 0x00FF
	r1 += r5
	jcc		L_AddHighByte2
	r2 += 1

L_AddHighByte2:
	r5 = r4 lsr 4
	r5 = r5 lsr 4
	r1 += r5
	jcc		L_ChecksumLoop2
	r2 += 1
	jmp		L_ChecksumLoop2
	
L_NextAreaChecksum2:
	r3 = (C_UserRomPageNStart >> 16)
	ds = r3
	r3 = (C_UserRomPageNStart & 0xFFFF)
L_ChecksumLoop3:
	cmp		r3, ((C_UserRomPageNEnd & 0xFFFF) + 1)
	jnz		L_SkipCheckHighAddr
	r4 = ds
	cmp		r4, (C_UserRomPageNEnd >> 16)
	jz		L_EndChecksum
L_SkipCheckHighAddr:	
	r4 = ds:[r3++]
	r5 = r4 & 0x00FF
	r1 += r5
	jcc		L_AddHighByte3
	r2 += 1

L_AddHighByte3:
	r5 = r4 lsr 4
	r5 = r5 lsr 4
	r1 += r5
	jcc		L_ChecksumLoop3
	r2 += 1
	jmp		L_ChecksumLoop3
	
L_EndChecksum:	
	pop r3, r5 from [sp]	
	.ENDM			
			
