//****************************************************************
// Function: Fast Interrupt Service routine Area                     
// 	Service for 	(1)PWM FIQ
//					(2)Timer A FIQ
//					(3)Timer B FIQ
// 	User's FIQ must hook on here                            
// 	_FIQ:									// Fast interrupt entrence
//  _IRQ1:									// interrupt entrence
//  _IRQ2:									// interrupt entrence
//  _IRQ3:									// interrupt entrence
//  _IRQ4:									// interrupt entrence
//  _IRQ5:									// interrupt entrence
//  _IRQ6:									// interrupt entrence     
//  _IRQ7:									// interrupt entrence
//****************************************************************
.TEXT
.include spce.inc				// include io information
		

.public _BREAK;
.public _FIQ;
.public	_IRQ0;
.public _IRQ1;
.public _IRQ2;
.public _IRQ3;
.public _IRQ4;
.public _IRQ5;
.public _IRQ6;
.public _IRQ7;

                
_FIQ:                                  
        push r1,r4 to [sp];
		
		r1 = C_FIQ_TMA;						// 
		test r1,[P_INT_Ctrl];				//
		jne	L_FIQ_TimerA;					// Timer A FIQ entrence 
		r1 = C_FIQ_TMB;						//
		test r1,[P_INT_Ctrl];				//
		jne L_FIQ_TimerB;						// Timer B FIQ entrence	
	
L_FIQ_PWM:										// PWM FIQ entrence
		//------------------------------------------------------------------
		// hook PWM FIQ subroutine here and define it to be external
		//------------------------------------------------------------------
		r1 = C_FIQ_PWM;
        [P_INT_Clear] = r1;
		pop r1,r4 from [sp];
        reti;
		
L_FIQ_TimerA:	
		[P_INT_Clear] = r1;
		//------------------------------------------------------------------		
		// hook Timer A FIQ subroutine here and define it to be external
		//------------------------------------------------------------------
		pop r1,r4 from [sp];
        reti;
        
L_FIQ_TimerB:   
		[P_INT_Clear] = r1;
		//------------------------------------------------------------------
		// hook Timer B FIQ subroutine here and define it to be external
		//------------------------------------------------------------------
		pop r1,r4 from [sp];
        reti;             

/////////////////////////////////////////////////////////////////////////////////////////
// Function: Interrupt Service routine Area                     
// 	Service for 	IRQ1 - IRQ7
// 	User's IRQ must hook on here                                 
/////////////////////////////////////////////////////////////////////////////////////////  
_BREAK:        
		push r1,r4 to [sp];
		
		pop r1,r4 from [sp];
        reti;  
     
_IRQ0:        
		push r1,r4 to [sp];
		
		pop r1,r4 from [sp];
        reti;  

_IRQ1:        
		push R1 to [SP]
	
		R1 = [P_ADC];
		[P_DAC1] = R1;
		[P_DAC2] = R1;

		R1 = 0x1000;
		[P_INT_Clear] = R1;
		pop R1 from [SP];
		reti;
		       
_IRQ2:        
		push r1,r4 to [sp];
		
		pop r1,r4 from [sp];
        reti;         
        
_IRQ3:        
		push r1,r4 to [sp];
		
		pop r1,r4 from [sp];
        reti;         
        
_IRQ4:        
		push r1,r4 to [sp];
		
		pop r1,r4 from [sp];
        reti;  
        
_IRQ5:        
		push r1,r4 to [sp];
		
		pop r1,r4 from [sp];
        reti;         
        
_IRQ6:        
		push r1,r4 to [sp];
		
		pop r1,r4 from [sp];
        reti;         
        
_IRQ7:        
		push r1,r4 to [sp];
		
		pop r1,r4 from [sp];
        reti;

//========================================================================================        
// End of isr.asm
//========================================================================================
        