//////////////////////////////////////////////////////////////////////////////////////////
// Progarm: ADC test V1.1
// Description: Pick voice from microphone and send out to speaker using 8KHz sample rate 
// Plateform: SPC500A, IDE 1.631
// Writen by: Andy Hsu
// Modified by Arthur Shieh
//
// Date: 2000/12/07 : First version
//       2000/12/07 : v1.1
// Note: 
//       1. This example fetchs PCm data from Mic through ADC and send the data to 2 DACs 
//          immediately.
//       2. It gets data by direct mode.
//////////////////////////////////////////////////////////////////////////////////////////
.PUBLIC _main										// Define Main function if no .C

.define CPU_CLOCK_RATE 24 							// 24MHz

.if CPU_CLOCK_RATE == 20
.define TIMER_DATA_FOR_8KHZ (0xffff - 1250/2)		// 8kHz sampling rate for Fosc/2
.endif

.if CPU_CLOCK_RATE == 24
.define TIMER_DATA_FOR_8KHZ (0xffff - 1500)			// 8kHz sampling rate for Fosc/2
.endif

.include spce.inc;

.CODE
//.................AD, DA initialization code....................
_InitAD_DA: 
		INT OFF;	
	
		R1 = 0x0030; 				// select Fosc/2 as timer A clock source
		[P_TimerA_Ctrl] = R1;		//
		R1 = TIMER_DATA_FOR_8KHZ; 	// Fs = 8kHz
		[P_TimerA_Data] = R1;		//
		
		R1 = 0x0039;				// AGC enable
		//R1 = 0x0011				// AGC disable 
		[P_ADC_Ctrl] = R1;			// Mode=auto, Source=MIC,
		
		R1 = 0x00A8;				//
		[P_DAC_Ctrl] = R1;			// Direct apply data, DAC mode with push pull output
		R1 = 0x1000;				//
		[P_INT_Ctrl] = R1;			// Enable IRQ1 for Timer A
		
		INT IRQ;
		retf;

//................ Monitor Loop ..................................
_main: 
		call _InitAD_DA				// AD Initialization
	
L_DeadLoop:
		R1 = 0x0001;				// Clear Watch Dog
		[P_Watchdog_Clear] = R1;
		jmp 	L_DeadLoop;	
		

