//=============================================================================
// Program: UartAPI.c V1.1
// Description:  This program send 0x0100 sample data(0x0000~0x00FF) to EchoServer 
//               ,get the response data, count the discrepencies and 
//               display the error count report to IOA on LED.
// By  Arthur Shieh
// Platform: SPCE 061A, IDE 1.633, Windows 2000
// Date: 2002/09/10
// Mainteinence history:
//       2002/09/10:  First Version
//       2002/10/22:  V1.1 Rewrite C main 
//                         
//
// Note:
//   UART Setting:Rx :IOB7
//              Tx :IOB10 
//              Baud rate: 115200 bps
//              Parity   : Even
//              Stop bit : 1
//              IRQ      : 7
//                 
//   Input : None
//   Output: LED on IOA0~IOA7 
//=============================================================================
	

volatile unsigned int *P_IOA_DATA   =(unsigned int*)(0x7000);		//Port A data register
volatile unsigned int *P_IOA_DIR    =(unsigned int*)(0x7002);		//Port A direction register
volatile unsigned int *P_IOA_ATTRIB = (unsigned int*)(0x7003);	    //Port A attribute register

int main()
{
	int i,j;
	int data = 0;
	int Ret = 0;
 	int Error = 0;  
    
    SP_UART_Init();
    
    *P_IOA_DIR =0xFFFF;		//Port A Output low for LED display
    *P_IOA_ATTRIB = 0xFFFF;	
    *P_IOA_DATA =0x0000;	
     	
	for(i=0;i<0x100;i++){
	 // sent a byte
	 SP_UartSentByte(data);
	 // read a byte
	 Ret = SP_UartReadByte();
     // compare data sent and received
	 if(Ret!=data){ 
        Error++;
        //delay for frame error
		for(j=0;j<0xFFFF;j++){// delay fro frame errors
			}
	 }
	 // display deta received	 
     *P_IOA_DATA =Ret ;
     data++; 
    }
	// display error counts    
	*P_IOA_DATA =Error  ; 
	// service loop
	while(1){}
	return 0;
}