//====================================================================================
// Progarm: Get a key-code and save the key-code to the memroy(R_KeyCode). V1.2
//
// Written by Andy Hsu
// Modified by Arthur Shieh
//
// Date: 
// 		2000/07/24: V1.0
//		2000/12/07: V1.1
//      2002/09/29: V1.2  Split hardware.asm into the spce500.inc and SP_Lib.asm 
//                        rearrange and comment the program    
//
// Note:	1)Assembly only. 
//			2)The Key-code will be {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80}.
//			3)The Keypad is on IOA[7..0]
//			4)After a Key is pressed, the Key-code will display on IOB 
//====================================================================================
.INCLUDE spce.inc;
.INCLUDE sp_lib.inc;						// Include key API

.RAM
.VAR R_KeyCode;							// define a memory space to save key-code

.CODE
.public _System_Initial;
_System_Initial: .PROC
		call F_User_Init_IO;			// Initial IO port	
		call F_Key_Scan_Initial;		// Key scan initial
		retf;
		.ENDP
	
.public _System_ServiceLoop;
_System_ServiceLoop:	.PROC
		call F_Key_Scan_ServiceLoop;	// Scanning Key
        call F_Key_DebounceCnt_Down;	// Key debounce
        retf;
        .ENDP      
		

F_User_Init_IO:
		r1 = 0x0000;					// IOA: b[15..0] input
        [P_IOA_Dir] = r1;				// 
        [P_IOA_Attrib] = r1;
        [P_IOA_Data] = r1;
        
        r1 = 0xffff;					// IOB: b[15..0] output
        [P_IOB_Dir] = r1;				// 
        [P_IOB_Attrib] = r1;			
        r1 = 0x0000;
        [P_IOB_Data] = r1; 
		retf;

//====================================================================================
// End of System.asm
//====================================================================================