//////////////////////////////////////////////////////////////////
// Function: System commander                     
// 	Service for H/W, keyboard scan
// Input: None
// Output: None

// Functions:
//	(In Assembly view)
// 	call F_System_Initial; 
//	(In C language view)
// 	System_Initial(); 
//////////////////////////////////////////////////////////////////

.include resource.inc;
.include spce.inc;
.include sp_lib.inc;

.public R_SpeechType;
.RAM
.VAR R_SpeechType;

.CODE
.public _System_Initial;
.public	F_System_Initial;
_System_Initial: .PROC
F_System_Initial:
  		//push	BP,BP to [SP];				//add if some parameters in
  		//BP = SP + 1;
		//r1 = [BP+3];
		//r2 = [BP+4];
		
		call	F_Key_Scan_Initial;			// For keyboard scan
		
		// Add other general initialization here
		
		//r1 =0x0001;						// return value
		//pop		BP,BP from [SP];		
		retf;
		.ENDP;

//****************************************************************
// Function: Main Loop of system                     
// Input: None
// Output: None
// Using:
// 	call F_System_ServiceLoop; (in assembly domain)
//  System_ServiceLoop(); (in C domain) 	
//****************************************************************
.public _System_ServiceLoop;
.public	F_System_ServiceLoop;
_System_ServiceLoop: .PROC                  
F_System_ServiceLoop:
		call	F_Key_DebounceCnt_Down;		// calling debounce subroutine for key scan subroutine
		call    F_Key_Scan_ServiceLoop;		// calling key scan subroutine 
		// Add other general service functions here		
		R1=0x0001;                      // Clear watch dog
		[P_Watchdog_Clear]=R1;       	//
        retf;
        .ENDP;
        
.public F_User_Init_IO;        
F_User_Init_IO:        
		r1 = 0xff00;				// IOA: b7-b0 input
		[P_IOA_Dir] = r1;			// IOA: b15-b8 output	
        [P_IOA_Attrib] = r1;		// 
        [P_IOA_Data] = r1; 
        
        r1 = 0xFFFF;				// IOB: b15-b0 output
        [P_IOB_Dir] = r1;			// 
        [P_IOB_Attrib] = r1;
        [P_IOB_Data] = r1;
        retf;     
        
///////////////////////////////////////////
.public F_Sleep_Init_IO;
F_Sleep_Init_IO:
		R1=0xff80;                      // b6..0 input pull low, b8..15 output
        [P_IOA_Dir]=R1;              // b7: output for scan line
        R1=0xff80;                      // 
        [P_IOA_Attrib]=R1;
        R1=0x0000;                      // 
        [P_IOA_Data]=R1;
		retf;