//========================================================================================
// Progarm: ADCTest V1.0
// Description: This program shows user how to switch among the 8 A/D channels
//              provided by SPF32
//		The ADC request uses external request trig on IOA8
// Written by : Rison Lo
// Platform: SPCF321,IDE 1.65 , Windows 2000
// Last modified date: 
// 		2003/05/28 V1.0: first version
//
//	Switch_ch(ch) : ch is the selected AD channel number
//                        
// Note:
//  1. IOA0~IOA7 are shared with A/D line-in. IOA0~7 must be "input with float". 
//  2. This program use key input from IOB0~IOB7 to select the A/D channel.
//  3. The ADC data will be fed to DAC as audio data; therefore user can hear 
//     the audio output from DAC if the A/D input is audio signal.
//  4. User is advised to be aware that the valid A/D range is from 0 to AVDD. 
//  5. This program use external ADC conversion request trigger from IOA8
//========================================================================================

int main(){
   int Key = 0;
   
   InitADC();
   System_Initial();	

	while(1){  	
		Key = SP_GetCh();
		switch( Key)
		    {
			case 0x00:
				break;
			case 0x01:				
    			Switch_ch(0);				
				break;
				
			case 0x02:
    			Switch_ch(1);			
				break;
				
			case 0x04:
    			Switch_ch(2);			
				break;
				
			case 0x08:
    			Switch_ch(3);
				break;
				
			case 0x10:
    			Switch_ch(4);
				break;
				
			case 0x20:
    			Switch_ch(5);
				break;
				
			case 0x40:
    			Switch_ch(6);
				break;
				
			case 0x80:
    			Switch_ch(7);
				break;
				
			default:
				break;																
		    }	
		    System_ServiceLoop();			// Service loop for Key Scanning				
    }
}