//////////////////////////////////////////////////////////////////////////////////////////
// Progarm: ADC test
// Description: Pick voice from microphone or line in and send out to 
//              speaker using 8KHz sample rate 
// Writen by: Rison Lo
// Platform: SPF32,IDE 1.65 , Windows 2000
//
// Date: 2003/05/28 V1.0
//
//////////////////////////////////////////////////////////////////////////////////////////
.include	spf32.inc

.define	ch_0 			0x0000;
.define	ch_1 			0x0010;
.define	ch_2 			0x0020;
.define	ch_3 			0x0030;
.define	ch_4 			0x0040;
.define	ch_5 			0x0050;
.define	ch_6 			0x0060;
.define	ch_7 			0x0070;
.define clk_16			0x0000;
.define clk_32			0x0004;
.define clk_64			0x0008;
.define clk_128			0x000C;

.CODE

///////////////////////////////////////////////////////////////
//Function : _InitADC
//Description: This function initializes the A/D channels, ADC 
//              . 
//Syntax: InitAD_DA()
//Used register: R1
//Return: none
///////////////////////////////////////////////////////////////
//.................ADC initialization code....................
.public _InitADC;
_InitADC:
	INT OFF;
	
// select ch0, ADC clock is CLK/16	
	R1 = ch_0 | clk_32;
	
	R1 |= 0x0A00;			// ADC INT enable, ADC Ext request trig
//	R1 |= 0x0B00;			// ADC INT enable, ADC Ext request trig, ADC VRT enable
	[P_ADC_Ctrl] = R1;
	
	R1 &= 0xFFFD;			// Chip Select
	[P_ADC_Ctrl] = R1;
	
	Call F_DelayPT;			// ADC Chip Sel settlt time > 2ms
	
	R1 |= 0x0001;			// ADCA enable
	[P_ADC_Ctrl] = R1;	

	R1 = [P_System_Ctrl];
	R1 &= 0xFFFD;			// Audio DAC enable
	[P_System_Ctrl] = R1;
	
	R1 = 0x2000;			// ADC INT enable
	[P_INT_Ctrl] = R1;	

	INT IRQ;
	retf;
	
///////////////////////////////////////////////////////////////
// Function : Dealy for programming time (base on CPUCLK= 54MHz)
// Syntax: DelayPT()   
// Used register: R2
///////////////////////////////////////////////////////////////

.public _DelayPT;
_DelayPT: .proc
F_DelayPT:                     	// 13 cycles
        push R2,R2 to [sp];    	//  7 cycles
        R2 = 15000;            	//  6 cycles
L_DelayLoopPT:
        R2 -= 1;               	//  3 cycles           26+19+8*15000=120045(2.2ms)
        jne     L_DelayLoopPT; 	//  5 cycles
        pop R2,R2 from [sp];   	//  7 cycles
        retf;                  	// 12 cycles
        .endp;	