//////////////////////////////////////////////////////////////////
// ISR Service 
//	
// By Rison Lo
// Platform: SPU32,unSP IDE 1.65, Windows 2000
// Date: 	2003.05.30	:First version
//
//
//////////////////////////////////////////////////////////////////
.include spf32.inc

.external R_OutMask;

.TEXT
.public _BREAK;
_BREAK:
	reti;
		
.public _FIQ;
_FIQ:
	reti;
		
.public _IRQ0;
_IRQ0:
	reti;
		
.public _IRQ1;
_IRQ1:
	reti;
		
.public _IRQ2;
_IRQ2:
	push R1,R5 to [sp]
	
	R1 = [P_INT_Clear];
	TEST R1,0x0800;			// Test TMA INT
	JNZ L_IRQ2_TMA;		
	
	R1 = [P_INT_Clear];
	TEST R1,0x0400;			// Test TMB INT
	JNZ L_IRQ2_TMB;		
	
	JMP L_Exit;
	
L_IRQ2_TMA:	
	R1 = [R_OutMask];
	R1 ^= 0x00ff;
	[R_OutMask] = R1;
	[P_IOA_Data] = R1;
	R1 = 0x0800;
	[P_INT_Clear] = R1;
	[P_TimerA_IRQCLR] = R1;

	JMP L_Exit;
	
L_IRQ2_TMB:
	R1 = [R_OutMask];
	R1 ^= 0xff00;
	[R_OutMask] = R1;
	[P_IOA_Data] = R1;
	R1 = 0x0400;
	[P_INT_Clear] = R1;	
	[P_TimerB_IRQCLR] = R1;		
	
L_Exit:	
	POP R1,R5 from [sp]
	reti;
		
.public _IRQ3;
_IRQ3:
	reti;
			
.public _IRQ4
_IRQ4:	
	reti;	
	    
.public _IRQ5;
_IRQ5:
	reti;

.public _IRQ6;
_IRQ6:
	reti;	

.public _IRQ7
_IRQ7:
	reti;

		.END 