//////////////////////////////////////////////////////////////////
// Function: Generate Timer A, Timer B IRQ2
// 			 Different frequeny pulses will generate on IOA ports
//			 IOA 0~7 : according to timer A
//			 IOA 8~15 : according to timer B 
//	
// By Rison Lo
// Platform: SPU32,unSP IDE 1.65, Windows 2000
// Date: 	2003.05.30	:First version
//
//
//////////////////////////////////////////////////////////////////

.include spf32.inc;

.public R_OutMask;

.RAM
.VAR R_OutMask;

.CODE   
.public _main;
_main:

	INT OFF;
	
	R1 = 0xffff; 
	[P_IOA_Attrib] = R1;
	[P_IOA_Dir] = R1;
	[P_IOA_Data] = R1;
	
	[P_IOB_Attrib] = R1;
	[P_IOB_Dir] = R1;
	[P_IOB_Data] = R1;
	
	[P_IOC_Attrib] = R1;
	[P_IOC_Dir] = R1;
	[P_IOC_Data] = R1;
	
	R1 = 65535 - (32/8);
	[P_TimerA_Data] = R1;
		
	// Select clock source A for Fsoc/2HZ and source B to 1
	R1 = 0x0032;
	[P_TimerA_Ctrl] = R1;

	// Enable Timer A
	R1 = 1;	
	[P_TimerA_On] = R1;

	R1 = 65535 - (32/3);
	[P_TimerB_Data] = R1;
		
	// Select clock source B for Fsoc/2
	R1 = 0x0002;
	[P_TimerB_Ctrl] = R1;

	// Enable Timer B
	R1 = 1;	
	[P_TimerB_On] = R1;

	R1 = 0x0C00; 			//JEnable IRQ2_TMA, IRQ2_TMB
	[P_INT_Ctrl] = R1;			
	
	R1 = 0;
	[R_OutMask] = R1;
	
	INT IRQ;
    
Loop:
	NOP;
	NOP;
	NOP;
	NOP;
	JMP Loop;