//////////////////////////////////////////////////////////////////
// IRQ/FIQ Service
//	
// By Rison Lo
// Platform: SPU32,unSP IDE 1.65, Windows 2000
// Date: 	2003.06.02	:First version
//
//
//////////////////////////////////////////////////////////////////

.include spf32.inc

.external R_OutMask;

.TEXT
.public _BREAK;
_BREAK:
	reti;
		
.public _FIQ;
_FIQ:
	reti;
		
.public _IRQ0;
_IRQ0:
	reti;
		
.public _IRQ1;
_IRQ1:
	reti;
		
.public _IRQ2;
_IRQ2:
	reti;
		
.public _IRQ3;
_IRQ3:
	reti;
			
.public _IRQ4
_IRQ4:	
	reti;	
	    
.public _IRQ5;
_IRQ5:
	push R1,R5 to [sp]
	
	R1 = [P_INT_Clear];
	TEST R1,0x1000;			// Test Ext2 INT
	JNZ L_IRQ5_Ext2;		
	
	R1 = [P_INT_Clear];
	TEST R1,0x0200;			// Test Ext1 INT
	JNZ L_IRQ5_Ext1;		
	
	JMP L_Exit;
	
L_IRQ5_Ext1:	
	R1 = [R_OutMask];
	R1 ^= 0x00ff;
	[R_OutMask] = R1;
	[P_IOA_Data] = R1;
	R1 = 0x0200;
	[P_INT_Clear] = R1;

	JMP L_Exit;
	
L_IRQ5_Ext2:
	R1 = [R_OutMask];
	R1 ^= 0xff00;
	[R_OutMask] = R1;
	[P_IOA_Data] = R1;
	R1 = 0x1000;
	[P_INT_Clear] = R1;	
	
L_Exit:	
	POP R1,R5 from [sp]

	reti;

.public _IRQ6;
_IRQ6:
	reti;	

.public _IRQ7
_IRQ7:
	reti;

		.END 