//////////////////////////////////////////////////////////////////
// IRQ/FIQ Service
//	
// By Rison Lo
// Platform: SPU32,unSP IDE 1.65, Windows 2000
// Date: 	2003.06.02	:First version
//
//
//////////////////////////////////////////////////////////////////
.include spf32.inc

.external R_OutMask;

.TEXT
.public _BREAK;
_BREAK:
	reti;
		
.public _FIQ;
_FIQ:
	reti;
		
.public _IRQ0;
_IRQ0:
	reti;
		
.public _IRQ1;
_IRQ1:
	reti;
		
.public _IRQ2;
_IRQ2:
	reti;
		
.public _IRQ3;
_IRQ3:
	reti;
			
.public _IRQ4
_IRQ4:	
	reti;	
	    
.public _IRQ5;
_IRQ5:
	reti;

.public _IRQ6;
_IRQ6:

    reti;

.public _IRQ7
_IRQ7:
	push R1,R5 to [sp]		
	
	R1 = [P_INT_Clear];
	TEST R1,0x0008;			// Test 4Hz INT
	JNZ L_IRQ7_4Hz;			
	
	R1 = [P_INT_Clear];				
	test R1,0x0002;    		// Test TMB1 INT
	JNZ L_IRQ7_TMB1;			
	
	R1 = [P_INT_Clear];				
	test R1,0x0001;    		// Test TMB2 INT
	JNZ L_IRQ7_TMB2;	

	JMP L_Exit;
////////////////////////////////////////////////////////////////	
L_IRQ7_TMB1:                 		// TMB1 INT
	R1 = [R_OutMask];
	R1 ^= 0x00ff;
	[R_OutMask] = R1;
	[P_IOA_Data] = R1;
	R1 = 0x0002;
	[P_INT_Clear] = R1;	

 	JMP L_Exit;
////////////////////////////////////////////////////////////////  	
L_IRQ7_TMB2:
	R1 = [R_OutMask];
	R1 ^= 0x0f00;
	[R_OutMask] = R1;
	[P_IOA_Data] = R1; 
	R1 = 0x0001;
	[P_INT_Clear] = R1;
	
	R1 = [P_INT_Clear];				
	test R1,0x0001;    		// Test TMB1 INT
	JNZ L_IRQ7_TMB1;
	
	JMP L_Exit;	
////////////////////////////////////////////////////////////////
L_IRQ7_4Hz:
	R1 = [R_OutMask];
	R1 ^= 0xf000;
	[R_OutMask] = R1;
	[P_IOA_Data] = R1;
	R1 = 0x0008;
	[P_INT_Clear] = R1;

	R1 = [P_INT_Clear];				
	test R1,0x0002;    		// Test TMB1 INT
	JNZ L_IRQ7_TMB1;	

	R1 = [P_INT_Clear];				
	test R1,0x0001;    		// Test TMB2 INT
	JNZ L_IRQ7_TMB2;

L_Exit:
	
    POP R1,R5 from [sp]
    reti;

		.END 