//////////////////////////////////////////////////////////////////
// SPI Rx/Tx demo program	: use key scan to send data or receive data
//							  Connect two SPF and program one in Tx mode 					
//							  and the other Rx mode to test the SPI transmission.	
// By Rison Lo
// Platform: SPU32,unSP IDE 1.65, Windows 2000
// Date: 	2003.05.30	:First version
//
//
//////////////////////////////////////////////////////////////////

.include spf32.inc;

.define Read 0
.define Write 1

.IRAM
.VAR R_Data = 0;
T_Buffer: .dw 100 dup(0);
.var R_Debounce = 0; 

.define C_EndBuffer T_Buffer+100;

.code
.public _main
_main:
 
    R1 = 0x0000
    [P_IOA_Data] =R1;
    [P_IOA_Dir] =R1;
    [P_IOA_Attrib] =R1;      

    // SPI Init
	R1 = 0x0B;	
	[P_SPICR] = R1;     // enable SPI, enable Rx int, enable Tx int
	//R1 = 0x0FFE;      // SCR=15, CPSR = 254 , bps=54M/(254*(1+15))= 13.287KHz 
	//R1 = 0x0F13;      // SCR=15, CPSR = 19 , bps=54M/(19*(1+15))= 177.632KHz	
	//R1 = 0x091B;      // SCR=9, CPSR = 27 , bps=54M/(27*(1+9))= 200KHz	
	R1 = 0x0814;        // SCR=8, CPSR = 20 , bps=54M/(20*(1+8))= 300KHz		
	[P_SPIDIV] = r1;    //
    
?L_KeyScan:
    R1 = [P_IOA_Data];
    
//key 0
?L_Key0:  				// send 1 byte data
    test R1, 0x01;
    jz ?L_Key1;
    
    R1 = 0xAA;
    [P_SPIDR] = R1;		// write to tx fifo
    jmp ?L_End;
       
// key 1
?L_Key1:   				// send data
    test R1, 0x02;
    jz ?L_Key2;
    
    R1 = 0x00;
        
?L_LoopW:
    R2 = [P_SPICR];
    test R2, 0x80;		// Check if SPI is busy or not
    jz ?L_LoopW;
    
	[P_SPIDR] = R1;     // Send data
	R1 += 1;            // Increment data
	CMP R1, 0xFF;       // Check if 0xFF
	JZ ?L_End;
	jmp ?L_LoopW;

// key 2
?L_Key2:  				// read data
    test R1, 0x04;
    jz ?L_KeyScan;
    
    R1 = 0x00;
    R5 = T_Buffer;        
    [P_SPIDR] = R1; 	// clear fifo
?L_LoopR:
    nop;
    [P_SPIDR] = R1; 
    
?L_WaitFIFO:
    R2 = [P_SPICR];
    test R2, 0x80;   		// busy //Rx FIFO Full
    jz ?L_WaitFIFO;
    
	R1= [P_SPIDR] ;
	[R5] = R1;
	R5 += 1;	
	cmp R5,C_EndBuffer;
	je ?L_End;
	
	jmp ?L_LoopR;
    
?L_End:
    jmp ?L_End;
    
    