//====================================================================================
// Progarm: SPF16256 using to result port define PORT  
// Wrote by: Peter Yang
// Start Date: 05/08/2003
// Last modified date: 05/08/2003 
//====================================================================================
//
//	IOA	Port Define
//
.define	P_IO_Mode			0x3d00
.define	P_IOA_Data			0x3d01
.define P_IOA_Buffer		0x3d02
.define	P_IOA_Dir			0x3d03
.define	P_IOA_Attrib		0x3d04
.define	P_IOA_Latch			0x3d05
.define	P_IOB_Data			0x3d06
.define P_IOB_Buffer		0x3d07
.define	P_IOB_Dir			0x3d08
.define	P_IOB_Attrib		0x3d09
.define	P_IOB_Latch			0x3d0a
.define	P_IOC_Data			0x3d0b
.define P_IOC_Buffer		0x3d0c
.define	P_IOC_Dir			0x3d0d
.define	P_IOC_Attrib		0x3d0e
.define P_INT_Ctrl			0x3d21
.define P_INT_Clear			0x3d22
.define P_Watchdog_clear	0x3d2f
//
//	Port definition for SPU32 unit ; 32 Channels mode
//
.define	P_CtrChEnL			0x3400
.define	P_CtrChEn_H				0x3500
.define P_CtrMainVol		0x3401
.define	P_CtrChFiqEn		0x3402
.define	P_CtrChFiqEn_H			0x3502
.define P_CtrChFiqSts		0x3403
.define P_CtrChFiqSts_H			0x3503
.define P_CtrBeatBase		0x3404
.define P_CtrBeatCnt		0x3405
.define P_CtrEnvClkSel0		0x3406
.define P_CtrEnvClkSel0_H		0x3506
.define P_CtrEnvClkSel1		0x3407
.define P_CtrEnvClkSel1_H		0x3507
.define P_CtrEnvClkSel2		0x3408
.define P_CtrEnvClkSel2_H		0x3508
.define P_CtrEnvClkSel3		0x3409
.define P_CtrEnvClkSel3_H		0x3509
.define P_CtrEnvRampDown	0x340a
.define P_CtrEnvRampDown_H		0x350a
.define P_CtrChStopSts		0x340b
.define P_CtrChStopSts_H		0x350b
.define P_CtrChZeroCrossEn	0x340c
.define P_CtrChZeroCrossEn_H	0x350c
.define P_CtrFlag			0x340d
.define P_CtrDummy			0x340e
.define P_CtrChSts			0x340f
.define P_CtrChSts_H			0x350f
.define P_CtrWaveInL		0x3410
.define P_CtrWaveInR		0x3411
.define P_CtrWaveOutL		0x3412
.define P_CtrWaveOutR		0x3413
.define P_CtrChRepeatEn		0x3414
.define P_CtrChRepeatEn_H		0x3514
.define P_CtrChEnvMode		0x3415
.define P_CtrChEnvMode_H		0x3515
.define P_CtrChToneRelease	0x3416
.define P_CtrChToneRelease_H	0x3516
.define P_CtrChEnvIrqSts	0x3417
.define P_CtrChEnvIrqSts_H		0x3517
.define P_CtrChPitchBandEn	0x3418
.define P_CtrChPitchBandEn_H	0x3518
.define	P_CtrChEnH			0x3500
//
// Channel 0 - 15 SPU RAM function definition
//
.define P_ChWaveAddr		0x3000
.define P_ChMode			0x3001
.define P_ChLoopAddr		0x3002
.define P_ChPan				0x3003
.define P_ChEnvelop0		0x3004
.define P_ChEnvelopData		0x3005
.define P_ChEnvelop1		0x3006
.define P_ChEnvelopSeg		0x3007
.define P_ChEnvelopOffset	0x3008
.define P_ChWaveData0		0x3009
.define P_ChEnvelopLoop		0x300A
.define P_ChWaveData1		0x300B
// 300C ~ 300F unused
.define P_ChPhaseHi			0x3200				// Less Significant 3 bits
.define P_ChPhaseAccumHi	0x3201				// Less Significant 3 bits
.define P_ChTargetPhaseHi	0x3202				// Target Phase High 3 bits
.define P_ChRampDownClk		0x3203				// 3 bits
.define P_ChPhase			0x3204				// 16 bits phase value
.define P_ChPhaseAccum		0x3205
.define P_ChTargetPhase		0x3206

.define ADPCM				0x8000
.define ToneColor16			0x4000
.define ToneColor8			0x0000
.define ManEnvMode			0x0001
.define AutEnvMode			0x0000

.define SWToneMode			0x0000
.define HWEndToneMode		0x1000
.define HWRepToneMode		0x2000

.define LPEn				0x100
.define Ch32En				0x14
.define Ch16En				0x04
.define Ch8En				0x00
.define InitialSRAM			0x008
.define NoHighQualityInt	0x400
.define CompEn				0x800
.define VCEn				0x40
.define	HVol				0x80
.define Noint				0x200
.define Yesint				0x000
.define OnePageROM			0x41
//
//	UART Data Frame Format
//
.define	Port_UART_ctrl			0x3D30
.define	Port_UART_status		0x3D31
.define	Port_UART_Reset			0x3D32
.define	Port_UART_BaudrateL		0x3D33
.define	Port_UART_BaudrateH		0x3D34
.define	Port_UART_txbuf			0x3D35
.define	Port_UART_rxbuf			0x3D36
//
//	LCD Data Port Format
//
.define	CONTROL0				0x2000
.define	CONTROL1				0x2001
.define	ADDR					0x2002
.define	DCCLKDIV				0x2003
.define	IOD_DATA				0x2004
.define	IOD_BUF					0x2005
.define	IOD_DIR					0x2006
.define	IOD_ATTR				0x2007
.define	LCDON					0x0100		// LCD Countroler Enable
.define	LCDINV					0x0200		// LCD Inverter
.define	MEXT					0x0001		// 1: Access External Memory, 0: Working RAM

//
//	Chip parameter definition
//
.define  D_TotalCH			16
//.define  D_ServiceRate		140625	// SPF32 FPGA mode Service rate; 27MHz/6/32
.define  D_ServiceRate		281250	// SPF32 RealChip mode

//.define  D_BeatBaseCnt		176		// BeatBaseCnt for 5 ms, BeatBaseCnt = D_ServiceRate * 5ms
.define D_BeatBaseCnt		352			// Realchip Beat base count : 3.55us*4(frames)*352 = 4998.4us

//.define  D_BASEPHASE   	0x3BA		// 2^(PhaseBits=19)*256/D_ServiceRate(140625)
.define  D_BASEPHASE   	0x1DD		// 2^(PhaseBits=19)*256/D_ServiceRate(281250)

.define  D_DAC_Volumn	0x7F			// Realchip : 0x7f, FPGA : 0x7F
//.define  D_GeneralRampDnOffset	0x0600	// Default value for Note Off Rampdown(Release) 0x3<<9
.define  D_GeneralRampDnOffset	0x0600	// Default value for Note Off Rampdown(Release) 0x2<<9

//.define  D_EnvClockWord	0x2222		// FPGA mode : every 16 quarter frame 	16*4*7.11us
.define  D_EnvClockWord	0x3333		// Realchip mode : every 32 quarter frame 	32*4*3.55us = 0.454ms
						
//.define  D_DefaultRampDownClock	0x0001	// FPGA mode : every 13*16 quarter frame (5.9ms) 
.define  D_DefaultRampDownClock	0x0002   // Realchip mode : every 13*64 quarter frame (11.8ms) 
								
.define  D_AlpHeaderSize	20		// 20 words for ALP header

.define  D_32CH_Mode	0x0010		// D4 : 1 as 32ch, 0 as 16/8 CH Mode depend on D2
.define  D_16CH_Mode	0x0004		// 16 channels
.define  D_8Ch_Mode		0x0000		// 8 Channels


// MIDI event value definition
.define  D_Middle_Pan	0x40
.define  D_Max_Velocity	0x7f
.define  D_Max_Volumn	0x7f


//
// D_ServiceRate dependent [ FPGA:140625 | Realchip:281250 ]
//
.data
T_VarPhaseTableBottom:	
//2^12 * 2^19 / (281250)
//2^12 * 2^19 / SERVICE_RATE
	.dw	15		// -107
	.dw	16		// -106
	.dw	17		// -105
	.dw	18		// -104
	.dw	19		// -103
	.dw	21		// -102
	.dw	22		// -101
	.dw	23		// -100
	.dw	25		// -99
	.dw	26		// -98
	.dw	28		// -97
	.dw	29		// -96
	.dw	31		// -95
	.dw	33		// -94
	.dw	35		// -93
	.dw	37		// -92
	.dw	39		// -91
	.dw	42		// -90
	.dw	44		// -89
	.dw	47		// -88
	.dw	50		// -87
	.dw	53		// -86
	.dw	56		// -85
	.dw	59		// -84
	.dw	63		// -83
	.dw	66		// -82
	.dw	70		// -81
	.dw	75		// -80
	.dw	79		// -79
	.dw	84		// -78
	.dw	89		// -77
	.dw	94		// -76
	.dw	100		// -75
	.dw	106		// -74
	.dw	112		// -73
	.dw	119		// -72
	.dw	126		// -71
	.dw	133		// -70
	.dw	141		// -69
	.dw	150		// -68
	.dw	159		// -67
	.dw	168		// -66
	.dw	178		// -65
	.dw	189		// -64
	.dw	200		// -63
	.dw	212		// -62
	.dw	225		// -61
	.dw	238		// -60
	.dw	252		// -59
	.dw	267		// -58
	.dw	283		// -57
	.dw	300		// -56
	.dw	318		// -55
	.dw	337		// -54
	.dw	357		// -53
	.dw	378		// -52
	.dw	401		// -51
	.dw	425		// -50
	.dw	450		// -49
	.dw	477		// -48
	.dw	505		// -47
	.dw	535		// -46
	.dw	567		// -45
	.dw	601		// -44
	.dw	637		// -43
	.dw	674		// -42
	.dw	715		// -41
	.dw	757		// -40
	.dw	802		// -39
	.dw	850		// -38
	.dw	900		// -37
	.dw	954		// -36
	.dw	1011		// -35
	.dw	1071		// -34
	.dw	1135		// -33
	.dw	1202		// -32
	.dw	1274		// -31
	.dw	1349		// -30
	.dw	1430		// -29
	.dw	1515		// -28
	.dw	1605		// -27
	.dw	1700		// -26
	.dw	1801		// -25
	.dw	1908		// -24
	.dw	2022		// -23
	.dw	2142		// -22
	.dw	2270		// -21
	.dw	2405		// -20
	.dw	2548		// -19
	.dw	2699		// -18
	.dw	2860		// -17
	.dw	3030		// -16
	.dw	3210		// -15
	.dw	3401		// -14
	.dw	3603		// -13
	.dw	3817		// -12
	.dw	4044		// -11
	.dw	4285		// -10
	.dw	4540		// -9
	.dw	4810		// -8
	.dw	5096		// -7
	.dw	5399		// -6
	.dw	5720		// -5
	.dw	6060		// -4
	.dw	6420		// -3
	.dw	6802		// -2
	.dw	7206		// -1
//2^12 * 2^19 / (281250)	
T_VarPhaseTable:
	.dw D_BASEPHASE	// 0
//2^8 * 2^19 / (281250)
	.dw	 505		// 1
	.dw	 535		// 2
	.dw	 567		// 3
	.dw	 601		// 4
	.dw	 637		// 5
	.dw	 674		// 6
	.dw	 715		// 7
	.dw	 757		// 8
	.dw	 802		// 9
	.dw	 850		// 10
	.dw	 900		// 11
	.dw	 954		// 12
	.dw	 1011		// 13
	.dw	 1071		// 14
	.dw	 1135		// 15
	.dw	 1202		// 16
	.dw	 1274		// 17
	.dw	 1349		// 18
	.dw	 1430		// 19
	.dw	 1515		// 20
	.dw	 1605		// 21
	.dw	 1700		// 22
	.dw	 1801		// 23
	.dw	 1908		// 24
	.dw	 2022		// 25
	.dw	 2142		// 26
	.dw	 2270		// 27
	.dw	 2405		// 28
	.dw	 2548		// 29
	.dw	 2699		// 30
	.dw	 2860		// 31
	.dw	 3030		// 32
	.dw	 3210		// 33
	.dw	 3401		// 34
	.dw	 3603		// 35
	.dw	 3817		// 36
	.dw	 4044		// 37
	.dw	 4285		// 38
	.dw	 4540		// 39
	.dw	 4810		// 40
	.dw	 5096		// 41
	.dw	 5399		// 42
	.dw	 5720		// 43
	.dw	 6060		// 44
	.dw	 6420		// 45
	.dw	 6802		// 46
	.dw	 7207		// 47
	.dw	 7635		// 48
	.dw	 8089		// 49
	.dw	 8570		// 50
	.dw	 9080		// 51
	.dw	 9620		// 52
	.dw	 10192		// 53
	.dw	 10798		// 54
	.dw	 11440		// 55
	.dw	 12121		// 56
	.dw	 12841		// 57
	.dw	 13605		// 58
	.dw	 14414		// 59
	.dw	 15271		// 60
	.dw	 16179		// 61
	.dw	 17141		// 62
	.dw	 18161		// 63
	.dw	 19240		// 64
	.dw	 20385		// 65
	.dw	 21597		// 66
	.dw	 22881		// 67
	.dw	 24242		// 68
	.dw	 25683		// 69
	.dw	 27210		// 70
	.dw	 28828		// 71
	.dw	 30543		// 72
	.dw	 32359		// 73
	.dw	 34283		// 74
	.dw	 36322		// 75
	.dw	 38481		// 76
	.dw	 40770		// 77
	.dw	 43194		// 78
	.dw	 45762		// 79
	.dw	 48484		// 80
	.dw	 51367		// 81
	.dw	 54421		// 82
	.dw	 57657		// 83
	.dw	 61086		// 84
	.dw	 64718		// 85

