//////////////////////////////////////////////////////////////////
// Function: System commander                     
// 	Service for H/W, keyboard scan, watchdog clear
// By Arthur Shieh
// Platform: SPF32,unSP IDE 1.65, Windows 2000
// Date: 	2002.11.22		:First version
//
// Input: None
// Output: None

// Functions:
//	call F_System_Initial;
//	call F_WatchdogClear;
// 	call F_System_ServiceLoop;
//  call F_User_Init_IO;
//
// API:
// 	System_Initial();      : Initial system
//  WatchdogClear();       : Clear watchdog
//  System_ServiceLoop();  : Key scan, watchdog clear
//////////////////////////////////////////////////////////////////
.include SPF32.inc

.CODE
//****************************************************************
// Function: System initial setting                    
// Input: None
// Output: None
// Syntax:
// 	call F_System_Initial; (in assembly domain)
//  System_Initial(); (in C domain) 	
//****************************************************************
.public _System_Initial;
.public	F_System_Initial;
_System_Initial: .PROC
F_System_Initial:

		retf;
		.ENDP;

//****************************************************************
// Function: Main Loop of system                     
// Input: None
// Output: None
// Using:
// 	call F_System_ServiceLoop; (in assembly domain)
//  System_ServiceLoop(); (in C domain) 	
//****************************************************************
.public _System_ServiceLoop;
.public	F_System_ServiceLoop;
_System_ServiceLoop: .PROC                  
F_System_ServiceLoop:
		//call	F_Key_DebounceCnt_Down;		// calling debounce subroutine for key scan subroutine
		//call    F_Key_Scan_ServiceLoop;		// calling key scan subroutine 
		// Add other general service functions here	
		R1 = C_Watchdog_Clear;                      // Clear watch dog
		[P_Watchdog_Clear]=R1;       	//	
        retf;
        .ENDP;
        
//****************************************************************
// Function: I/O initial setting                    
// Input: None
// Output: None
// Syntax:
// 	call F_User_Init_IO; (in assembly domain)
//****************************************************************     
F_User_Init_IO:
               
        retf;   
        
        
//****************************************************************
// Function: Clear watchdog                     
// Input: None
// Output: None
// Using:
// 	call F_Clear_Watchdog; (in assembly domain)
//  Clear_Watchdog(); (in C domain) 	
//****************************************************************
.public _Clear_Watchdog;
.public	F_Clear_Watchdog;
_Clear_Watchdog: .PROC                  
F_Clear_Watchdog:
		//call	F_Key_DebounceCnt_Down;		// calling debounce subroutine for key scan subroutine
		//call    F_Key_Scan_ServiceLoop;		// calling key scan subroutine 
		// Add other general service functions here	
		R1 = C_Watchdog_Clear;                      // Clear watch dog
		[P_Watchdog_Clear]=R1;       	//	
        retf;
        .ENDP;      