/*****************************************************************************
 Program: example for math using 
 author: wenyan
 Date: 2002/07/16
*****************************************************************************/

#include "math.h"
#include "errno.h"
#include "stdio.h"
#include "string.h"
#include "fdlibm.h"


int main()
{
	float x,y,z;
	long lx,ly;
	char * buffer; 	
	
	x=-0.1;
	y=asinf(x);			//-0.100167				
	x=y-(-0.100167);
	x=fabs(x);
	if (x>0.000001) printf("asinf test error1!");

	x=0.1;
	y=asinf(x);			//0.100167
	x=y-0.100167;
	x=fabs(x);
	if (x>0.000001) printf("asinf test error2!");
	
	x=0.4;
	y=asinf(x);			//0.411517
	x=y-0.411517;
	x=fabs(x);
	if (x>0.000001) printf("asinf test error3!");	

	x=-0.4;
	y=asinf(x);			//-0.411517				
	x=y-(-0.411517);
	x=fabs(x);
	if (x>0.000001) printf("asinf test error4!");	

	x=0.5;
	y=asinf(x);			//0.523599
	x=y-0.523599;
	x=fabs(x);
	if (x>0.000001) printf("asinf test error5!");	

	x=-0.5;
	y=asinf(x);			//-0.523599	
	x=y-(-0.523599);
	x=fabs(x);
	if (x>0.000001) printf("asinf test error6!");	

	x=0.7;
	y=asinf(x);			//0.775398
	x=y-0.775398;
	x=fabs(x);
	if (x>0.000001) printf("asinf test error7!");	

	x=-0.7;
	y=asinf(x);			//-0.775398				
	x=y-(-0.775398);
	x=fabs(x);
	if (x>0.000001) printf("asinf test error8!");	

	x=0.9;
	y=asinf(x);			//1.11977
	x=y-1.11977;
	x=fabs(x);
	if (x>0.000001) printf("asinf test error9!");	

	x=-0.9;
	y=asinf(x);			//-1.11977				
	x=y-(-1.11977);
	x=fabs(x);
	if (x>0.000001) printf("asinf test error10!");	

	x=0.975;
	y=asinf(x);			//1.34672
	x=y-1.34672;
	x=fabs(x);
	if (x>0.000002) printf("asinf test error11!");	

	x=-0.975;
	y=asinf(x);			//-1.34672				
	x=y-(-1.34672);
	x=fabs(x);
	if (x>0.000002) printf("asinf test error12!");	

	x=0.99;
	y=asinf(x);			//1.42926
	x=y-1.42926;
	x=fabs(x);
	if (x>3.1e-6) printf("asinf test error13!");	

	x=-0.99;
	y=asinf(x);			//-1.42926				
	x=y-(-1.42926);
	x=fabs(x);
	if (x>0.000004) printf("asinf test error14!");	

	x=0.0;
	y=asinf(x);			//0	
	if (y!=0) printf("asinf test error15!");

	x=1;
	y=asinf(x);			//1.5708
	x=y-1.5708;
	x=fabs(x);
	if (x>3.6e-6) printf("asinf test error16!");	

	x=-1;
	y=asinf(x);			//-1.5708
	x=y-(-1.5708);
	x=fabs(x);
	if (x>0.000004) printf("asinf test error17!");	

	x=2;
	y=asinf(x);			//nan
	GET_FLOAT_WORD(ly,y);
	if (ly!=0xffffffff) printf("asinf test error18!");
	buffer = strerror(errno);
	printf("Error: %s\n",buffer);	
	
	x=-2;
	y=asinf(x);			//nan	
	GET_FLOAT_WORD(ly,y);
	if (ly!=0xffffffff) printf("asinf test error19!");
	
	x=3.4e38;
	y=asinf(x);			//nan
	GET_FLOAT_WORD(ly,y);
	if (ly!=0xffffffff) printf("asinf test error20!");
	
	x=-3.4e38;
	y=asinf(x);			//nan
	GET_FLOAT_WORD(ly,y);
	if (ly!=0xffffffff) printf("asinf test error21!");
	
	x=7.45e-9;			
	y=asinf(x);			//7.45e-9
	if (y!=7.45e-9) printf("asinf test error22!");

	x=-7.45e-9;
	y=asinf(x);			//-7.45e-9				
	if (y!=-7.45e-9) printf("asinf test error23!");

	x=3e-38;
	y=asinf(x);			//3e-38
	if (y!=3e-38) printf("asinf test error24!");
	
	x=-3e-38;
	y=asinf(x);			//-3e-38	
	if (y!=-3e-38) printf("asinf test error25!");

	printf("asinf test ok!");
	printf_end();
	return;
}
	
