//*****************************************************************************
// author: wenyan
// Date: 2002/07/16
//*****************************************************************************/

//write 1 byte to output port

// ssize_t _write(int d, const char *buf, size_t nbytes);
// int _write(int handle,void * buf,unsigned len);

.define C_STDOUT_FILENO      1
.define C_EOF -1
.define C_NUL 0

.define C_HIGH_BYTE 0x1
.define C_IS_LF	    0x2

.IRAM
.VAR _G_OutputPort=0x7101
.VAR _G_Buffer						// 2002-6-28 wwy add
.VAR _G_LowFlag=0x0					// bit0 =0: low byte,  =1: high byte;
									// bit1 =0: not LF,    =1: is LF '\n';  
									
// overloading _printf_init function
.code
.public __printf_init	
__printf_init: .proc 				//initial printf port
	push bp,bp to [sp]
	bp=sp+1
	push r1,r1 to [sp]
	r1=[bp+3]
    [_G_OutputPort]=r1
    pop r1,r1 from [sp]
    pop bp,bp from [sp]
    retf  
    .endp 

// overloading _printf_end function
//2002-6-28 add by wangwenyan
.public __printf_end					//printf the end character    
__printf_end: .proc
	push r1,r2 to [sp]
	r1=[_G_LowFlag]
	test r1,C_HIGH_BYTE
	jz __printf_end_exit
	r1&=~C_HIGH_BYTE
	[_G_LowFlag]=r1
	r1=[_G_Buffer]					
	r2=[_G_OutputPort]				//write to port
	[r2]=r1	
__printf_end_exit:
	pop r1,r2 from [sp]
	retf
	.endp    

// overloading _write function
// this function will be called by _printf function
.public __write
__write:	.proc
	push bp to [sp]
	bp=sp+1
	push r2,r4 to [sp]
	
	r1=[bp+3]						//handle
	cmp r1,C_STDOUT_FILENO
	je l_not_error
l_return_error:
	r1=C_EOF		
    jmp l_exit

l_not_error:	
	r2=[bp+4]						//buffer pointer
	r1=0							//actual length
	r3=[bp+5]						//len		
	jz l_exit
	
	r4=[_G_LowFlag]
	test r4,C_HIGH_BYTE
	jz _l_start_from_lowbyte
    r4&=~C_HIGH_BYTE
    [_G_LowFlag]=r4	
//    r4=0
	r4=[_G_Buffer]					//2002-6-28 change by wangwenyan
    jmp _l_next_byte
_l_start_from_lowbyte:
_l_write_loop:
	r5=[_G_LowFlag]
	test r5,C_IS_LF
	jz _l_not_LF1
	r5&=~C_IS_LF
	[_G_LowFlag]=r5
	r4=0xd
	jmp _l_next_byte
_l_not_LF1:	
	r4=[r2++]						//low byte
	cmp r4,0xa						//'\n' LF 
	jne _l_not_LF2
	r4|=0x0d00						//'\r' CR
	jmp _l_write_1word
_l_not_LF2:
	r1+=1
	cmp r1,r3
	jne _l_next_byte
//	r5=[_G_OutputPort]				//write to port
//	[r5]=r4
    [_G_Buffer]=r4					//2002-6-28 wwy change
    r5=[_G_LowFlag]
    r5|=C_HIGH_BYTE
    [_G_LowFlag]=r5
    jmp l_exit
_l_next_byte:
	r5=[r2++]						//high byte
	r5=r5 lsl 4
	r5=r5 lsl 4
	r4|=r5
	cmp r5,0x0a00					//'\n' LF 
	jne _l_write_1word
	r5=[_G_LowFlag]
	r5|=C_IS_LF
	[_G_LowFlag]=r5	
_l_write_1word:
	r5=[_G_OutputPort]				//write to port
	[r5]=r4	
	r1+=1
	cmp r1,r3
	jne _l_write_loop
l_exit:	
	pop r2,r4 from [sp]
	pop bp from [sp]
    retf
		.endp
		
