#ifndef _STDARG_H
#define _STDARG_H

/* Values returned by __builtin_classify_type.  */

enum type_class
{
  no_type_class = -1,
  void_type_class, integer_type_class, char_type_class,
  enumeral_type_class, boolean_type_class,
  pointer_type_class, reference_type_class, offset_type_class,
  real_type_class, complex_type_class,
  function_type_class, method_type_class,
  record_type_class, union_type_class,
  array_type_class, string_type_class, set_type_class, file_type_class,
  lang_type_class
};

typedef void *__gnuc_va_list;

#define va_start(AP, LASTARG) \
  (AP = ((__gnuc_va_list) __builtin_next_arg (LASTARG)))

#define va_end(AP) ((void)0)

#define va_arg(AP, TYPE)                                                \
  ((__builtin_classify_type (* (TYPE *) 0) == array_type_class          \
    || __builtin_classify_type (* (TYPE *) 0) == record_type_class)     \
    ? (AP = (__gnuc_va_list)((char *)(AP) + sizeof (char *)),           \
            **((TYPE **)(void *)((char *)(AP) - sizeof (char *))))      \
    : (AP = (__gnuc_va_list)((char *)(AP) + sizeof(TYPE)),              \
            *((TYPE *)(void *)((char *)(AP) - sizeof(TYPE)))))

typedef __gnuc_va_list va_list;

#endif

