/*
 * string.h
 *
 * Definitions for memory and string functions.
 */
 
#ifndef _STRING_H_
#define	_STRING_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "_ansi.h"
#include <sys/reent.h>

#define __need_size_t
#include <stddef.h>

#ifndef NULL
#define NULL 0
#endif 

extern void * memchr(const void *,int,size_t);
extern int memcmp(const void *,const void *,size_t);
extern void * memcpy(void *,const void *,size_t);
extern void * memmove(void *,const void *,size_t);
extern void * memset(void *,int,size_t);
extern void setmem(void *,unsigned int,char);

extern char * strcat(char *,const char *);
extern char * strchr(const char *, int);
extern int strcmp(const char *,const char *);
extern int strcoll(const char *, const char *);
extern char * strcpy(char *,const char *);
extern size_t strcspn(const char *, const char *);
extern char * strerror(int);						
extern size_t strlen(const char *);
extern char * strncat(char *, const char *, size_t);
extern int strncmp(const char *, const char *, size_t);
extern char * strncpy(char *, const char *, size_t);
extern char * strpbrk(const char *, const char *);
extern char	* strrchr(const char *, int);
extern size_t strspn(const char *, const char *);
extern char * strstr(const char *, const char *);

#ifndef _REENT_ONLY
extern char	* strtok(char *, const char *);
#endif

extern size_t strxfrm(char *, const char *, size_t);


#ifndef __STRICT_ANSI__
extern int	bcmp(const char *, const char *, size_t);
extern void bcopy(const char *, char *, size_t);
extern void bzero(char *, size_t);
extern char * index(const char *, int);
extern void * memccpy(void *,const void *,int,size_t);
extern char * rindex(const char *, int);
extern int strcasecmp(const char *,const char *);
extern char * strdup(const char *);
extern int strncasecmp(const char *, const char *, size_t);
extern char* strlwr(char*);
extern char* strupr(char*);

extern void movmem(void *,void *,unsigned);
extern char * stpcpy(char *,const char *);
extern char* strnset(char*,char,unsigned);
extern char* strrev(char*);
extern char* strset(char*,char);
extern void swab(const char*,char*,unsigned int);


extern void* charpack(void *dst,char *s);		/* wenyan add */
extern void* charunpack(void *dst,void *s);		/* wenyan add */


/* These function names are used on Windows and perhaps other systems.  */
#ifndef strcmpi
#define strcmpi strcasecmp
#endif
#ifndef stricmp
#define stricmp strcasecmp
#endif
#ifndef strncmpi
#define strncmpi strncasecmp
#endif
#ifndef strnicmp
#define strnicmp strncasecmp
#endif

#endif /* ! __STRICT_ANSI__ */

#ifdef __cplusplus
}
#endif
#endif /* _STRING_H_ */

