#ifndef __CODEGENQPCX_H__
#define __CODEGENQPCX_H__


#include 	"GPCE1_CE3.h"
#include	"KernelDefine.h"

//===========================================================================
// Function
//===========================================================================
#define 	ENABLE						1
#define 	DISABLE						0

#define 	D_UseKeyMatrix				DISABLE
#define 	D_UseInput					DISABLE

#define 	D_UseA1800					ENABLE
#define 	D_UseA3400Pro				ENABLE
#define 	D_UseMIDI					DISABLE
#define		D_UseGEO					DISABLE

#define		D_UseTimer					DISABLE

#define		D_UseUserEvent				DISABLE
#define		D_MaxUserEvent				0

#define		D_UseRandom					ENABLE
#define		D_UseFG						ENABLE
#define		D_UseBG						ENABLE
#define		D_UseMute					ENABLE

#define		D_UseSleep					ENABLE
#define		D_RTCFastSleep				DISABLE
#define		D_UseIOEventCtrl			DISABLE
#define		D_InputDelay				DISABLE
#define		D_MainLoop					DISABLE
#define		D_DisableINT				ENABLE
#define		D_AutoRampdown				ENABLE
#define		D_SPIFCHighDrivingCheck		DISABLE
#define		D_TimerA					DISABLE
#define		D_TimerB					DISABLE
#define		D_TimerC					DISABLE
#define		D_KEY_Change_INT			DISABLE
#define		D_EXT1_INT					DISABLE
#define		D_EXT2_INT					DISABLE
#define		D_TB_4KHz_INT				DISABLE
#define		D_TB_2KHz_INT				DISABLE
#define		D_TB_512Hz_INT				DISABLE
#define		D_RTC_64Hz_INT				DISABLE
#define		D_RTC_16Hz_INT				DISABLE
#define		D_RTC_2Hz_INT				DISABLE

#define		D_BGCount					1

#if D_UseKeyMatrix == ENABLE
#define 	D_KeyBitCtrlEnable			DISABLE
#endif

#if D_UseInput == ENABLE
#define 	D_InputEnable				ENABLE
#endif
//===========================================================================
// System
//===========================================================================
#define 	D_TimeBaseCounter			4		// 4096Hz event * 4 = 1024Hz event
#define 	D_DACAudioMode				DISABLE	// ENABLE / DISABLE
#define		D_OP_Control				DISABLE	// ENABLE / DISABLE
#define		P_OP_En_Dir					0xFFFF		// P_IOA_Dir / P_IOB_Dir / 0xFFFF
#define		P_OP_En_Buf					0xFFFF		// P_IOA_Buffer / P_IOB_Buffer / 0xFFFF
#define		D_OP_En_Bit					0xFFFF		// 0x0001	<-- bit 
//===========================================================================
// GEO
//===========================================================================
#if D_UseGEO == ENABLE
#define		D_GEOMode					1		// 0: DriveMode  1: SinkMode
#endif

//===========================================================================
// Key Matrix
//         
//===========================================================================
#if D_UseKeyMatrix == ENABLE
#define		D_MaxKeyNum					0
#define		D_MaxSenseLineNum			0
#define		D_MaxDriveLineNum			0
#define		D_MaxDrivePortNum			0







#define 	D_KeyEnableRamCount		((D_MaxKeyNum-1)/16)+1

#endif

//===========================================================================
// Direct Trigger

//===========================================================================
#if D_UseInput == ENABLE
#define 	D_InputPullLow				ENABLE
#define		D_MaxInputPort				0
#define		D_MaxInputNum				0







#define 	D_InputEnableRamCount		((D_MaxInputNum-1)/16)+1

#endif 		// .IF D_UseInput == ENABLE

//===========================================================================
// User Timer
//===========================================================================
#if D_UseTimer == ENABLE

#define 	D_MaxTimerNum				0

#endif

//===========================================================================
// IO Event
//===========================================================================
#define 	C_IO_EVENT_NUM    			0		// IO number for IO_Event
#define 	C_SW_PWM_FREQ     			60		// PWM frequency (Unit: Hz)
#define 	C_SW_PWM_LEVEL    			128		// PWM level selection (32/64/128/256)
#define 	C_PWM_FREQ        			65536 - (SystemClock / (C_SW_PWM_FREQ * C_SW_PWM_LEVEL))	// for PWM Service Timer Setting
#define 	D_IOEventEnableRamCount		((C_IO_EVENT_NUM-1)/16)+1

#define		C_IO_1						C_IOC0
#define		C_IO_2						C_IOC0
#define		C_IO_3						C_IOC0
#define		C_IO_4						C_IOC0
#define		C_IO_5						C_IOC0
#define		C_IO_6						C_IOC0
#define		C_IO_7						C_IOC0
#define		C_IO_8						C_IOC0
#define		C_IO_9						C_IOC0
#define		C_IO_10						C_IOC0
#define		C_IO_11						C_IOC0
#define		C_IO_12						C_IOC0
#define		C_IO_13						C_IOC0
#define		C_IO_14						C_IOC0
#define		C_IO_15						C_IOC0
#define		C_IO_16						C_IOC0

#define		C_IO_17						C_IOC0
#define		C_IO_18						C_IOC0
#define		C_IO_19						C_IOC0
#define		C_IO_20						C_IOC0
#define		C_IO_21						C_IOC0
#define		C_IO_22						C_IOC0
#define		C_IO_23						C_IOC0
#define		C_IO_24						C_IOC0
#define		C_IO_25						C_IOC0
#define		C_IO_26						C_IOC0
#define		C_IO_27						C_IOC0
#define		C_IO_28						C_IOC0
#define		C_IO_29						C_IOC0
#define		C_IO_30						C_IOC0
#define		C_IO_31						C_IOC0
#define		C_IO_32						C_IOC0

#define		C_IO_33						C_IOC0
#define		C_IO_34						C_IOC1
#define		C_IO_35						C_IOC2
#define		C_IO_36						C_IOC3
#define		C_IO_37						C_IOC4
#define		C_IO_38						C_IOC5
#define		C_IO_39						C_IOC6
#define		C_IO_40						C_IOC7

//===========================================================================
// Touch Key
//===========================================================================
#define		D_TouchKey					DISABLE
#define		D_TouchProbeEnable			DISABLE

#if D_TouchKey == ENABLE  

#define		C_PadNumber					0
#define		C_ScanNo					0
#define		C_NumOfScans				1
#define		C_UpStep					20
#define		C_DnStep					40
#define		C_AbnorDetCntEn				0			
#define		C_AbnorDetCnt				40




#define		D_TouchScanIndex_0			0xFFFF
#define		D_TouchScanIndex_1			0xFFFF
#define		D_TouchScanIndex_2			0xFFFF
#define		D_TouchScanIndex_3			0xFFFF
#define		D_TouchScanIndex_4			0xFFFF
#define		D_TouchScanIndex_5			0xFFFF
#define		D_TouchScanIndex_6			0xFFFF
#define		D_TouchScanIndex_7			0xFFFF
#define		D_TouchScanIndex_8			0xFFFF
#define		D_TouchScanIndex_9			0xFFFF
#define		D_TouchScanIndex_10			0xFFFF
#define		D_TouchScanIndex_11			0xFFFF
#define		D_TouchScanIndex_12			0xFFFF
#define		D_TouchScanIndex_13			0xFFFF
#define		D_TouchScanIndex_14			0xFFFF
#define		D_TouchScanIndex_15			0xFFFF
#define		D_TouchScanIndex_16			0xFFFF
#define		D_TouchScanIndex_17			0xFFFF
#define		D_TouchScanIndex_18			0xFFFF
#define		D_TouchScanIndex_19			0xFFFF
#define		D_TouchScanIndex_20			0xFFFF
#define		D_TouchScanIndex_21			0xFFFF
#define		D_TouchScanIndex_22			0xFFFF
#define		D_TouchScanIndex_23			0xFFFF
#define		D_TouchScanIndex_24			0xFFFF
#define		D_TouchScanIndex_25			0xFFFF
#define		D_TouchScanIndex_26			0xFFFF
#define		D_TouchScanIndex_27			0xFFFF
#define		D_TouchScanIndex_28			0xFFFF
#define		D_TouchScanIndex_29			0xFFFF
#define		D_TouchScanIndex_30			0xFFFF
#define		D_TouchScanIndex_31			0xFFFF


#endif	// D_TouchKey == ENABLE

#if	D_TouchProbeEnable == ENABLE



#endif	// D_TouchProbeEnable == ENABLE

#endif	// #ifndef __CODEGENQPCX_INC__ 