#ifndef __CODEGENQPCX_H__
#define __CODEGENQPCX_H__


#include 	"GPCE1_CE3.h"
#include	"KernelDefine.h"

//===========================================================================
// Function
//===========================================================================
#define 	ENABLE						1
#define 	DISABLE						0

#define 	D_UseKeyMatrix				ENABLE
#define 	D_UseInput					ENABLE

#define 	D_UseA1800					ENABLE
#define 	D_UseA3400Pro				ENABLE
#define 	D_UseMIDI					DISABLE
#define		D_UseGEO					DISABLE

#define		D_UseTimer					DISABLE

#define		D_UseUserEvent				DISABLE
#define		D_MaxUserEvent				0

#define		D_UseRandom					ENABLE
#define		D_UseFG						ENABLE
#define		D_UseBG						ENABLE
#define		D_UseMute					ENABLE

#define		D_UseSleep					ENABLE
#define		D_RTCFastSleep				DISABLE
#define		D_UseIOEventCtrl			DISABLE
#define		D_InputDelay				DISABLE
#define		D_MainLoop					DISABLE
#define		D_DisableINT				ENABLE
#define		D_AutoRampdown				ENABLE
#define		D_SPIFCHighDrivingCheck		DISABLE
#define		D_TimerA					DISABLE
#define		D_TimerB					DISABLE
#define		D_TimerC					DISABLE
#define		D_KEY_Change_INT			DISABLE
#define		D_EXT1_INT					DISABLE
#define		D_EXT2_INT					DISABLE
#define		D_TB_4KHz_INT				DISABLE
#define		D_TB_2KHz_INT				DISABLE
#define		D_TB_512Hz_INT				DISABLE
#define		D_RTC_64Hz_INT				DISABLE
#define		D_RTC_16Hz_INT				DISABLE
#define		D_RTC_2Hz_INT				DISABLE

#define		D_BGCount					1

#if D_UseKeyMatrix == ENABLE
#define 	D_KeyBitCtrlEnable			DISABLE
#endif

#if D_UseInput == ENABLE
#define 	D_InputEnable				ENABLE
#endif
//===========================================================================
// System
//===========================================================================
#define 	D_TimeBaseCounter			4		// 4096Hz event * 4 = 1024Hz event
#define 	D_DACAudioMode				DISABLE	// ENABLE / DISABLE
#define		D_OP_Control				DISABLE	// ENABLE / DISABLE
#define		P_OP_En_Dir					0xFFFF		// P_IOA_Dir / P_IOB_Dir / 0xFFFF
#define		P_OP_En_Buf					0xFFFF		// P_IOA_Buffer / P_IOB_Buffer / 0xFFFF
#define		D_OP_En_Bit					0xFFFF		// 0x0001	<-- bit 
//===========================================================================
// GEO
//===========================================================================
#if D_UseGEO == ENABLE
#define		D_GEOMode					1		// 0: DriveMode  1: SinkMode
#endif

//===========================================================================
// Key Matrix
//         PA.0    PA.1    PA.2    PA.3    
// PB.8    K1      K2      K3      K4      
// PB.9    K5      K6      K7      K8      
// PB.10   K9      K10     K11     K12     
//===========================================================================
#if D_UseKeyMatrix == ENABLE
#define		D_MaxKeyNum					12
#define		D_MaxSenseLineNum			4
#define		D_MaxDriveLineNum			3
#define		D_MaxDrivePortNum			1

#define		D_SensePort					P_IOA_Data
#define		D_SenseLinesMask			0x000F

#define		D_SenseLine0				0x0001
#define		D_SenseLine1				0x0002
#define		D_SenseLine2				0x0004
#define		D_SenseLine3				0x0008

#define		D_DriveLine0				0x0100
#define		D_DriveLine1				0x0200
#define		D_DriveLine2				0x0400

#define		D_DriveLinePortAddr0		P_IOB_Buffer
#define		D_DriveLinePortAddr1		P_IOB_Buffer
#define		D_DriveLinePortAddr2		P_IOB_Buffer

#define		D_DrivePortReadAddr0		P_IOB_Data
#define		D_DrivePortWriteAddr0		P_IOB_Buffer
#define		D_DriveLinesMask0			0x0700

#define		D_KeyDebounceTime0			40
#define		D_KeyDebounceTime1			40
#define		D_KeyDebounceTime2			40
#define		D_KeyDebounceTime3			40
#define		D_KeyDebounceTime4			40
#define		D_KeyDebounceTime5			40
#define		D_KeyDebounceTime6			40
#define		D_KeyDebounceTime7			40
#define		D_KeyDebounceTime8			40
#define		D_KeyDebounceTime9			40
#define		D_KeyDebounceTime10			40
#define		D_KeyDebounceTime11			40


#define		D_KeyPressValid0			1
#define		D_KeyPressValid1			1
#define		D_KeyPressValid2			1
#define		D_KeyPressValid3			1
#define		D_KeyPressValid4			1
#define		D_KeyPressValid5			1
#define		D_KeyPressValid6			1
#define		D_KeyPressValid7			1
#define		D_KeyPressValid8			1
#define		D_KeyPressValid9			1
#define		D_KeyPressValid10			1
#define		D_KeyPressValid11			1

#define		D_KeyReleaseValid0			1
#define		D_KeyReleaseValid1			1
#define		D_KeyReleaseValid2			1
#define		D_KeyReleaseValid3			1
#define		D_KeyReleaseValid4			1
#define		D_KeyReleaseValid5			1
#define		D_KeyReleaseValid6			1
#define		D_KeyReleaseValid7			1
#define		D_KeyReleaseValid8			1
#define		D_KeyReleaseValid9			1
#define		D_KeyReleaseValid10			1
#define		D_KeyReleaseValid11			1

#define		D_KeyPressClearStack0		1
#define		D_KeyPressClearStack1		1
#define		D_KeyPressClearStack2		1
#define		D_KeyPressClearStack3		1
#define		D_KeyPressClearStack4		1
#define		D_KeyPressClearStack5		1
#define		D_KeyPressClearStack6		1
#define		D_KeyPressClearStack7		1
#define		D_KeyPressClearStack8		1
#define		D_KeyPressClearStack9		1
#define		D_KeyPressClearStack10		1
#define		D_KeyPressClearStack11		1

#define		D_KeyReleaseClearStack0		1
#define		D_KeyReleaseClearStack1		1
#define		D_KeyReleaseClearStack2		1
#define		D_KeyReleaseClearStack3		1
#define		D_KeyReleaseClearStack4		1
#define		D_KeyReleaseClearStack5		1
#define		D_KeyReleaseClearStack6		1
#define		D_KeyReleaseClearStack7		1
#define		D_KeyReleaseClearStack8		1
#define		D_KeyReleaseClearStack9		1
#define		D_KeyReleaseClearStack10	1
#define		D_KeyReleaseClearStack11	1


#define 	D_KeyEnableRamCount		((D_MaxKeyNum-1)/16)+1

#endif

//===========================================================================
// Direct Trigger
// PA.4  PA.5  
//===========================================================================
#if D_UseInput == ENABLE
#define 	D_InputPullLow				ENABLE
#define		D_MaxInputPort				1
#define		D_MaxInputNum				2

#define		P_Input0					P_IOA_Data
#define		D_NonInputPinMask0			0x0030

#define		P_InputBaseAddr				P_IOA_Data

#define		D_InputPortOffset0			P_IOA_Data - P_InputBaseAddr
#define		D_InputPortOffset1			P_IOA_Data - P_InputBaseAddr

#define		D_InputPortAddress0			P_IOA_Data
#define		D_InputPortAddress1			P_IOA_Data

#define		D_MinderOffset0				0
#define		D_MinderOffset1				0

#define		D_InputPin0					0x0010
#define		D_InputPin1					0x0020

#define		D_InputIsTouch0				0
#define		D_InputIsTouch1				0

#define		D_InputDebounceTime0		40
#define		D_InputDebounceTime1		40


#define		D_TgRisingValid0			1
#define		D_TgRisingValid1			1

#define		D_TgFallingValid0			1
#define		D_TgFallingValid1			1

#define		D_TgRisingClearStack0		1
#define		D_TgRisingClearStack1		1

#define		D_TgFallingClearStack0		1
#define		D_TgFallingClearStack1		1


#define 	D_InputEnableRamCount		((D_MaxInputNum-1)/16)+1

#endif 		// .IF D_UseInput == ENABLE

//===========================================================================
// User Timer
//===========================================================================
#if D_UseTimer == ENABLE

#define 	D_MaxTimerNum				0

#endif

//===========================================================================
// IO Event
//===========================================================================
#define 	C_IO_EVENT_NUM    			0		// IO number for IO_Event
#define 	C_SW_PWM_FREQ     			60		// PWM frequency (Unit: Hz)
#define 	C_SW_PWM_LEVEL    			128		// PWM level selection (32/64/128/256)
#define 	C_PWM_FREQ        			65536 - (SystemClock / (C_SW_PWM_FREQ * C_SW_PWM_LEVEL))	// for PWM Service Timer Setting
#define 	D_IOEventEnableRamCount		((C_IO_EVENT_NUM-1)/16)+1

#define		C_IO_1						C_IOC0
#define		C_IO_2						C_IOC0
#define		C_IO_3						C_IOC0
#define		C_IO_4						C_IOC0
#define		C_IO_5						C_IOC0
#define		C_IO_6						C_IOC0
#define		C_IO_7						C_IOC0
#define		C_IO_8						C_IOC0
#define		C_IO_9						C_IOC0
#define		C_IO_10						C_IOC0
#define		C_IO_11						C_IOC0
#define		C_IO_12						C_IOC0
#define		C_IO_13						C_IOC0
#define		C_IO_14						C_IOC0
#define		C_IO_15						C_IOC0
#define		C_IO_16						C_IOC0

#define		C_IO_17						C_IOC0
#define		C_IO_18						C_IOC0
#define		C_IO_19						C_IOC0
#define		C_IO_20						C_IOC0
#define		C_IO_21						C_IOC0
#define		C_IO_22						C_IOC0
#define		C_IO_23						C_IOC0
#define		C_IO_24						C_IOC0
#define		C_IO_25						C_IOC0
#define		C_IO_26						C_IOC0
#define		C_IO_27						C_IOC0
#define		C_IO_28						C_IOC0
#define		C_IO_29						C_IOC0
#define		C_IO_30						C_IOC0
#define		C_IO_31						C_IOC0
#define		C_IO_32						C_IOC0

#define		C_IO_33						C_IOC0
#define		C_IO_34						C_IOC1
#define		C_IO_35						C_IOC2
#define		C_IO_36						C_IOC3
#define		C_IO_37						C_IOC4
#define		C_IO_38						C_IOC5
#define		C_IO_39						C_IOC6
#define		C_IO_40						C_IOC7

//===========================================================================
// Touch Key
//===========================================================================
#define		D_TouchKey					DISABLE
#define		D_TouchProbeEnable			DISABLE

#if D_TouchKey == ENABLE  

#define		C_PadNumber					0
#define		C_ScanNo					0
#define		C_NumOfScans				1
#define		C_UpStep					20
#define		C_DnStep					40
#define		C_AbnorDetCntEn				0			
#define		C_AbnorDetCnt				40




#define		D_TouchScanIndex_0			0xFFFF
#define		D_TouchScanIndex_1			0xFFFF
#define		D_TouchScanIndex_2			0xFFFF
#define		D_TouchScanIndex_3			0xFFFF
#define		D_TouchScanIndex_4			0xFFFF
#define		D_TouchScanIndex_5			0xFFFF
#define		D_TouchScanIndex_6			0xFFFF
#define		D_TouchScanIndex_7			0xFFFF
#define		D_TouchScanIndex_8			0xFFFF
#define		D_TouchScanIndex_9			0xFFFF
#define		D_TouchScanIndex_10			0xFFFF
#define		D_TouchScanIndex_11			0xFFFF
#define		D_TouchScanIndex_12			0xFFFF
#define		D_TouchScanIndex_13			0xFFFF
#define		D_TouchScanIndex_14			0xFFFF
#define		D_TouchScanIndex_15			0xFFFF
#define		D_TouchScanIndex_16			0xFFFF
#define		D_TouchScanIndex_17			0xFFFF
#define		D_TouchScanIndex_18			0xFFFF
#define		D_TouchScanIndex_19			0xFFFF
#define		D_TouchScanIndex_20			0xFFFF
#define		D_TouchScanIndex_21			0xFFFF
#define		D_TouchScanIndex_22			0xFFFF
#define		D_TouchScanIndex_23			0xFFFF
#define		D_TouchScanIndex_24			0xFFFF
#define		D_TouchScanIndex_25			0xFFFF
#define		D_TouchScanIndex_26			0xFFFF
#define		D_TouchScanIndex_27			0xFFFF
#define		D_TouchScanIndex_28			0xFFFF
#define		D_TouchScanIndex_29			0xFFFF
#define		D_TouchScanIndex_30			0xFFFF
#define		D_TouchScanIndex_31			0xFFFF


#endif	// D_TouchKey == ENABLE

#if	D_TouchProbeEnable == ENABLE



#endif	// D_TouchProbeEnable == ENABLE

#endif	// #ifndef __CODEGENQPCX_INC__ 