.IFNDEF __CODEGENQPCX_INC__
.DEFINE __CODEGENQPCX_INC__

.include 	GPCE1_CE3.inc
.include	KernelDefine.inc

//===========================================================================
// Function
//===========================================================================
.define 	ENABLE						1
.define 	DISABLE						0

.define 	D_UseKeyMatrix				DISABLE
.define 	D_UseInput					ENABLE

.define 	C_PrjA18A34MS02				0
.define 	C_PrjA18A34MS028ch			1
.define 	C_Prj1chA18MS02				2
.define 	C_Prj2chA18					3
.define 	C_Prj2chA34MS02				4
.define 	C_Prj4chA34					5

.define 	C_MS02_Type_4ch				0
.define 	C_MS02_Type_8ch				1
.define 	C_MS02_Type_8ch_wo_Mixer	2

.define		D_ProjectType				1

// 1ch A18 + 1ch A18 + 4ch MS02 
.if D_ProjectType == C_PrjA18A34MS02
	.define 	D_UseA1800				ENABLE
	.define 	D_UseA3400Pro			ENABLE
	.define 	D_UseMIDI				ENABLE
	.define		D_MS02_Lib_Type			C_MS02_Type_4ch

	.define 	D_UseA1800_CH2			DISABLE
	.define 	D_UseA1800_CH3			DISABLE
	.define 	D_UseA1800_Internal		ENABLE
	.define 	D_UseA3400Pro_CH1		DISABLE
	.define 	D_UseA3400Pro_CH2		DISABLE
	.define 	D_UseA3400Pro_CH3		DISABLE
	.define 	D_UseA3400Pro_CH4		DISABLE
	.define 	D_UseA3400Pro_Internal	ENABLE
.endif

// 1ch A18 + 1ch A18 + 8ch MS02 
.if D_ProjectType == C_PrjA18A34MS028ch
	.define 	D_UseA1800				ENABLE
	.define 	D_UseA3400Pro			ENABLE
	.define 	D_UseMIDI				ENABLE
	.define		D_MS02_Lib_Type			C_MS02_Type_8ch_wo_Mixer
	
	.define 	D_UseA1800_CH2			DISABLE
	.define 	D_UseA1800_CH3			DISABLE
	.define 	D_UseA1800_Internal		ENABLE
	.define 	D_UseA3400Pro_CH1		DISABLE
	.define 	D_UseA3400Pro_CH2		DISABLE
	.define 	D_UseA3400Pro_CH3		DISABLE
	.define 	D_UseA3400Pro_CH4		DISABLE
	.define 	D_UseA3400Pro_Internal	ENABLE
.endif

// 1ch A18 + 8ch MS02 
.if D_ProjectType == C_Prj1chA18MS02
	.define 	D_UseA1800				ENABLE
	.define 	D_UseA3400Pro			DISABLE
	.define 	D_UseMIDI				ENABLE
	.define		D_MS02_Lib_Type			C_MS02_Type_8ch

	.define 	D_UseA1800_CH2			ENABLE
	.define 	D_UseA1800_CH3			DISABLE
	.define 	D_UseA1800_Internal		DISABLE
	.define 	D_UseA3400Pro_CH1		DISABLE
	.define 	D_UseA3400Pro_CH2		DISABLE
	.define 	D_UseA3400Pro_CH3		DISABLE
	.define 	D_UseA3400Pro_CH4		DISABLE
	.define 	D_UseA3400Pro_Internal	DISABLE
.endif

// 2ch A18
.if D_ProjectType == C_Prj2chA18
	.define 	D_UseA1800				ENABLE
	.define 	D_UseA3400Pro			DISABLE
	.define 	D_UseMIDI				DISABLE

	.define 	D_UseA1800_CH2			ENABLE
	.define 	D_UseA1800_CH3			ENABLE
	.define 	D_UseA1800_Internal		DISABLE
	.define 	D_UseA3400Pro_CH1		DISABLE
	.define 	D_UseA3400Pro_CH2		DISABLE
	.define 	D_UseA3400Pro_CH3		DISABLE
	.define 	D_UseA3400Pro_CH4		DISABLE
	.define 	D_UseA3400Pro_Internal	DISABLE
.endif
// 2ch A34 + 8ch MS02 
.if D_ProjectType == C_Prj2chA34MS02
	.define 	D_UseA1800				DISABLE
	.define 	D_UseA3400Pro			ENABLE
	.define 	D_UseMIDI				ENABLE
	.define		D_MS02_Lib_Type			C_MS02_Type_8ch

	.define 	D_UseA1800_CH2			DISABLE
	.define 	D_UseA1800_CH3			DISABLE
	.define 	D_UseA1800_Internal		DISABLE
	.define 	D_UseA3400Pro_CH1		ENABLE
	.define 	D_UseA3400Pro_CH2		ENABLE
	.define 	D_UseA3400Pro_CH3		DISABLE
	.define 	D_UseA3400Pro_CH4		DISABLE
	.define 	D_UseA3400Pro_Internal	DISABLE
.endif

// 4ch A34
.if D_ProjectType == C_Prj4chA34
	.define 	D_UseA1800				DISABLE
	.define 	D_UseA3400Pro			ENABLE
	.define 	D_UseMIDI				DISABLE

	.define 	D_UseA1800_CH2			DISABLE
	.define 	D_UseA1800_CH3			DISABLE
	.define 	D_UseA1800_Internal		DISABLE
	.define 	D_UseA3400Pro_CH1		ENABLE
	.define 	D_UseA3400Pro_CH2		ENABLE
	.define 	D_UseA3400Pro_CH3		ENABLE
	.define 	D_UseA3400Pro_CH4		ENABLE
	.define 	D_UseA3400Pro_Internal	DISABLE
.endif

.define		D_UseGEO					DISABLE

.define		D_UseTimer					DISABLE

.define		D_UseUserEvent				DISABLE
.define		D_MaxUserEvent				0

.define		D_UseRandom					ENABLE
.define		D_UseFG						ENABLE
.define		D_UseBG						ENABLE
.define		D_UseMute					ENABLE

.define		D_UseSleep					ENABLE
.define		D_RTCFastSleep				DISABLE
.define		D_UseIOEventCtrl			DISABLE
.define		D_InputDelay				DISABLE
.define		D_MainLoop					DISABLE
.define		D_DisableINT				ENABLE
.define		D_AutoRampdown				ENABLE
.define		D_SPIFCHighDrivingCheck		DISABLE
.define		D_TimerA					DISABLE
.define		D_TimerB					DISABLE
.define		D_TimerC					DISABLE
.define		D_KEY_Change_INT			DISABLE
.define		D_EXT1_INT					DISABLE
.define		D_EXT2_INT					DISABLE
.define		D_TB_4KHz_INT				DISABLE
.define		D_TB_2KHz_INT				DISABLE
.define		D_TB_512Hz_INT				DISABLE
.define		D_RTC_64Hz_INT				DISABLE
.define		D_RTC_16Hz_INT				DISABLE
.define		D_RTC_2Hz_INT				DISABLE

.define		D_BGCount					1

.if D_UseKeyMatrix == ENABLE
.define 	D_KeyBitCtrlEnable			DISABLE
.endif

.if D_UseInput == ENABLE
.define 	D_InputEnable				DISABLE
.endif
//===========================================================================
// System
//===========================================================================
.define 	D_TimeBaseCounter			4		// 4096Hz event * 4 = 1024Hz event
.define 	D_DACAudioMode				DISABLE	// ENABLE / DISABLE
.define		D_OP_Control				DISABLE	// ENABLE / DISABLE
.define		P_OP_En_Dir					0xFFFF		// P_IOA_Dir / P_IOB_Dir / 0xFFFF
.define		P_OP_En_Buf					0xFFFF		// P_IOA_Buffer / P_IOB_Buffer / 0xFFFF
.define		D_OP_En_Bit					0xFFFF		// 0x0001	<-- bit 

//===========================================================================
// GEO
//===========================================================================
.if D_UseGEO == ENABLE
.define		D_GEOMode					0		// 0: DriveMode  1: SinkMode
.endif

//===========================================================================
// Key Matrix
//         
//;==========================================================================
.if D_UseKeyMatrix == ENABLE
.define		D_MaxKeyNum					0
.define		D_MaxSenseLineNum			0
.define		D_MaxDriveLineNum			0
.define		D_MaxDrivePortNum			0







.define 	D_KeyEnableRamCount		((D_MaxKeyNum-1)/16)+1

.endif

//===========================================================================
// Direct Trigger
// PA.0  PA.1  PA.2  PA.3  
//===========================================================================
.IF D_UseInput == ENABLE
.define 	D_InputPullLow				ENABLE
.define		D_MaxInputPort				1
.define		D_MaxInputNum				4

.define		P_Input0					P_IOA_Data
.define		D_NonInputPinMask0			0x000F

.define		P_InputBaseAddr				P_IOA_Data

.define		D_InputPortOffset0			P_IOA_Data - P_InputBaseAddr
.define		D_InputPortOffset1			P_IOA_Data - P_InputBaseAddr
.define		D_InputPortOffset2			P_IOA_Data - P_InputBaseAddr
.define		D_InputPortOffset3			P_IOA_Data - P_InputBaseAddr

.define		D_InputPortAddress0			P_IOA_Data
.define		D_InputPortAddress1			P_IOA_Data
.define		D_InputPortAddress2			P_IOA_Data
.define		D_InputPortAddress3			P_IOA_Data

.define		D_MinderOffset0				0
.define		D_MinderOffset1				0
.define		D_MinderOffset2				0
.define		D_MinderOffset3				0

.define		D_InputPin0					0x0001
.define		D_InputPin1					0x0002
.define		D_InputPin2					0x0004
.define		D_InputPin3					0x0008

.define		D_InputIsTouch0				0
.define		D_InputIsTouch1				0
.define		D_InputIsTouch2				0
.define		D_InputIsTouch3				0

.define		D_InputDebounceTime0		40
.define		D_InputDebounceTime1		40
.define		D_InputDebounceTime2		40
.define		D_InputDebounceTime3		40


.define		D_TgRisingValid0			1
.define		D_TgRisingValid1			1
.define		D_TgRisingValid2			1
.define		D_TgRisingValid3			1

.define		D_TgFallingValid0			1
.define		D_TgFallingValid1			1
.define		D_TgFallingValid2			1
.define		D_TgFallingValid3			1

.define		D_TgRisingClearStack0		1
.define		D_TgRisingClearStack1		1
.define		D_TgRisingClearStack2		1
.define		D_TgRisingClearStack3		1

.define		D_TgFallingClearStack0		1
.define		D_TgFallingClearStack1		1
.define		D_TgFallingClearStack2		1
.define		D_TgFallingClearStack3		1


.define 	D_InputEnableRamCount		((D_MaxInputNum-1)/16)+1


.ENDIF 		// .IF D_UseInput == ENABLE

//===========================================================================
// IO Information for PowerOn & Wakeup
//						Dir	Attrib	Buffer
// Input Pull-low		 0		0		 0
// Input Pull-floating	 0		1		 X
// Output Low			 1		1		 0
// Output High			 1		1		 1
//===========================================================================
.define		D_Max_IO_Port_Num			2

.define		P_IO0_Dir					P_IOA_Dir
.define		P_IO0_Attrib				P_IOA_Attrib
.define		P_IO0_Buffer				P_IOA_Buffer
.define		D_PowerOnDir0				0x0000
.define		D_PowerOnAttrib0			0x0000
.define		D_PowerOnBuffer0			0x0000
.define		D_BeforeSleepDir0			0x0000
.define		D_BeforeSleepAttrib0		0x0000
.define		D_BeforeSleepBuffer0		0x0000
.define		D_IOA_WKU_Enable			ENABLE

.define		P_IO1_Dir					P_IOB_Dir
.define		P_IO1_Attrib				P_IOB_Attrib
.define		P_IO1_Buffer				P_IOB_Buffer
.define		D_PowerOnDir1				0x0000
.define		D_PowerOnAttrib1			0x0000
.define		D_PowerOnBuffer1			0x0000
.define		D_BeforeSleepDir1			0x0000
.define		D_BeforeSleepAttrib1		0x0000
.define		D_BeforeSleepBuffer1		0x0000
.define		D_IOB_WKU_Enable			ENABLE

// All PC set input pull-low (PC0/1 only support input mode)
//.define	P_IO2_Dir					P_IOC_Dir
//.define	P_IO2_Attrib				P_IOC_Attrib
//.define	P_IO2_Buffer				P_IOC_Buffer
//.define	D_PowerOnDir2				00000000B
//.define	D_PowerOnAttrib2			00000000B
//.define	D_PowerOnBuffer2			00000000B
//.define	D_BeforeSleepDir2			00000000B
//.define	D_BeforeSleepAttrib2		00000000B
//.define	D_BeforeSleepBuffer2		00000000B
//.define	D_IOC_WKU_Enable			ENABLE

//===========================================================================
// User Timer
//===========================================================================
.if D_UseTimer == ENABLE

.define 	D_MaxTimerNum				0

.endif

//===========================================================================
// IO Event
//===========================================================================
.define 	C_IO_EVENT_NUM    			0		// IO number for IO_Event
.define 	C_SW_PWM_FREQ     			60		// PWM frequency (Unit: Hz)
.define 	C_SW_PWM_LEVEL    			128		// PWM level selection (32/64/128/256)
.define 	C_PWM_FREQ        			65536 - (SystemClock / (C_SW_PWM_FREQ * C_SW_PWM_LEVEL))	// for PWM Service Timer Setting
.define 	D_IOEventEnableRamCount		((C_IO_EVENT_NUM-1)/16)+1

.define		D_Event_Use_PortA			DISABLE
.define		D_Event_Use_PortB			DISABLE
.define		D_Event_Use_PortC			DISABLE

.define		D_Event_Mask_PortA			0x0000
.define		D_Event_Mask_PortB			0x0000
.define		D_Event_Mask_PortC			0x0000

.define		D_Event_IoValue_PortA		0x0000
.define		D_Event_IoValue_PortB		0x0000
.define		D_Event_IoValue_PortC		0x0000

.define		C_IO_1						C_IOC0
.define		C_IO_2						C_IOC0
.define		C_IO_3						C_IOC0
.define		C_IO_4						C_IOC0
.define		C_IO_5						C_IOC0
.define		C_IO_6						C_IOC0
.define		C_IO_7						C_IOC0
.define		C_IO_8						C_IOC0
.define		C_IO_9						C_IOC0
.define		C_IO_10						C_IOC0
.define		C_IO_11						C_IOC0
.define		C_IO_12						C_IOC0
.define		C_IO_13						C_IOC0
.define		C_IO_14						C_IOC0
.define		C_IO_15						C_IOC0
.define		C_IO_16						C_IOC0

.define		C_IO_17						C_IOC0
.define		C_IO_18						C_IOC0
.define		C_IO_19						C_IOC0
.define		C_IO_20						C_IOC0
.define		C_IO_21						C_IOC0
.define		C_IO_22						C_IOC0
.define		C_IO_23						C_IOC0
.define		C_IO_24						C_IOC0
.define		C_IO_25						C_IOC0
.define		C_IO_26						C_IOC0
.define		C_IO_27						C_IOC0
.define		C_IO_28						C_IOC0
.define		C_IO_29						C_IOC0
.define		C_IO_30						C_IOC0
.define		C_IO_31						C_IOC0
.define		C_IO_32						C_IOC0

.define		C_IO_33						C_IOC0
.define		C_IO_34						C_IOC1
.define		C_IO_35						C_IOC2
.define		C_IO_36						C_IOC3
.define		C_IO_37						C_IOC4
.define		C_IO_38						C_IOC5
.define		C_IO_39						C_IOC6
.define		C_IO_40						C_IOC7

//===========================================================================
// Touch Key
//===========================================================================
.define		D_TouchKey					DISABLE
.define		D_TouchProbeEnable			DISABLE

.if D_TouchKey == ENABLE  

.define		C_PadNumber					0
.define		C_ScanNo					0
.define		C_NumOfScans				1
.define		C_UpStep					20
.define		C_DnStep					40
.define		C_AbnorDetCntEn				0			
.define		C_AbnorDetCnt				40
.define		C_AutoReleaseEn				ENABLE			
.define		C_AutoReleaseCnt			2000




// C_Padx_SchmittL_1 (x1.0)
// C_Padx_SchmittL_2 (x1.1)
// C_Padx_SchmittL_3 (x1.2)
// C_Padx_SchmittL_4 (x1.3)
// C_Padx_SchmittL_5 (x1.4)
// C_Padx_SchmittL_6 (x0.9)
// C_Padx_SchmittL_7 (x0.8)
// C_Padx_SchmittL_8 (x0.7)

// C_Padx_SchmittH_1 (x1.0)
// C_Padx_SchmittH_2 (x1.1)
// C_Padx_SchmittH_3 (x1.2)
// C_Padx_SchmittH_4 (x1.3)
// C_Padx_SchmittH_5 (x1.4)
// C_Padx_SchmittH_6 (x0.9)
// C_Padx_SchmittH_7 (x0.8)
// C_Padx_SchmittH_8 (x0.7)

.define		D_TouchScanIndex_0			0xFFFF
.define		D_TouchScanIndex_1			0xFFFF
.define		D_TouchScanIndex_2			0xFFFF
.define		D_TouchScanIndex_3			0xFFFF
.define		D_TouchScanIndex_4			0xFFFF
.define		D_TouchScanIndex_5			0xFFFF
.define		D_TouchScanIndex_6			0xFFFF
.define		D_TouchScanIndex_7			0xFFFF
.define		D_TouchScanIndex_8			0xFFFF
.define		D_TouchScanIndex_9			0xFFFF
.define		D_TouchScanIndex_10			0xFFFF
.define		D_TouchScanIndex_11			0xFFFF
.define		D_TouchScanIndex_12			0xFFFF
.define		D_TouchScanIndex_13			0xFFFF
.define		D_TouchScanIndex_14			0xFFFF
.define		D_TouchScanIndex_15			0xFFFF
.define		D_TouchScanIndex_16			0xFFFF
.define		D_TouchScanIndex_17			0xFFFF
.define		D_TouchScanIndex_18			0xFFFF
.define		D_TouchScanIndex_19			0xFFFF
.define		D_TouchScanIndex_20			0xFFFF
.define		D_TouchScanIndex_21			0xFFFF
.define		D_TouchScanIndex_22			0xFFFF
.define		D_TouchScanIndex_23			0xFFFF
.define		D_TouchScanIndex_24			0xFFFF
.define		D_TouchScanIndex_25			0xFFFF
.define		D_TouchScanIndex_26			0xFFFF
.define		D_TouchScanIndex_27			0xFFFF
.define		D_TouchScanIndex_28			0xFFFF
.define		D_TouchScanIndex_29			0xFFFF
.define		D_TouchScanIndex_30			0xFFFF
.define		D_TouchScanIndex_31			0xFFFF


.endif	// D_TouchKey == ENABLE

.if	D_TouchProbeEnable == ENABLE



.endif	// D_TouchProbeEnable == ENABLE

.ENDIF	// .ifndef __CODEGENQPCX_INC__ 