/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_main.c											     */	
/* Description : main entry function of C programming					     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v2.0A or later version					     */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */
/* Environemnts of this demo:												 */								
/* HW : SPMC75F2313A EVM board V1.1											 */
/* SW : u'nSP IDE V2.0A, Windows XP 										 */
/* ========================================================================= */

#include "Spmc75f2313a.h"
#include "unspmacro.h"

UInt16 i = 0;

int main(void)
{
	unsigned int data;
	unsigned int *ptr;
	
//
	Disable_FIQ_IRQ();
//
	for(;;)
	{
		/*************************************************************************/
		/* erase the first frame of bank 14										 */
		/*************************************************************************/
		P_Flash_RW->W = 0x5A5A;
		P_Flash_RW->W = 0xBFFF;		         /* setup bank 14 is read/write mode */

		P_Flash_Cmd->W = 0xAAAA;
		P_Flash_Cmd->W = 0x5511;
		ptr = (unsigned int *)0xF000;
		*ptr = 0;

		/*************************************************************************/
		/* program one word on 0xF700											 */
		/*************************************************************************/
		P_Flash_Cmd->W = 0xAAAA;
		P_Flash_Cmd->W = 0x5533;
		ptr = (unsigned int *)0xF000;
		*ptr = 0x5555;

		/*************************************************************************/
		/* Sequential program data testing, range from 0xF000 to 0xF7FF			 */
		/*************************************************************************/
		P_Flash_Cmd->W = 0xAAAA;
		for(i = 0xF001; i < 0xF800; i++)
		{
			P_Flash_Cmd->W = 0x5544;
			ptr = (unsigned int *)i;
			*ptr = i;
		}	
		P_Flash_Cmd->W = 0xFFFF;		    /* end of sequential programming */

		ptr = (unsigned int *)0xF000;
		data = *ptr;
		if(data != 0x5555)
		{
			P_IOB_Data->W = 0xFFFF;
			while(1);	
		}	

		/* Sequential read data back to verify */
		for(i = 0xF001; i < 0xF800; i++)
		{
			ptr = (unsigned int *)i;
			data = *ptr;
			if(data != i)
			{
				while(1);	
			}
		}	
		
		while(1);
	}

	return (1);
} /* main() */