/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_main.c											     */	
/* Description : main entry function of C programming					     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v2.0A or later version				         */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */
/* Environemnts of this demo:												 */								
/* HW : SPMC75F2313A EVM board V1.1											 */
/* SW : u'nSP IDE V2.0, Windows XP 										     */
/* ========================================================================= */

#include "Spmc75f2313a.h"
#include "unspmacro.h"

void F_Delay(unsigned int uiTimeMs);

int main(void)
{
	Disable_FIQ_IRQ();
	
	/* Set IOB[5:12] Configuration */
	P_IOB_SPE->W = 0x0000;
	
	P_IOB_Attrib->W = 0xFFFF;
	P_IOB_Dir->W = 0xFFFF;
	P_IOB_Data->W =	0x0000;
	

	for(;;)
	{
 		P_IOB_Buffer->B.bit5 ^=	1;		                 /* toggle IOB5 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOB_Buffer->B.bit6 ^=	1;		                 /* toggle IOB6 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOB_Buffer->B.bit7 ^=	1;		                 /* toggle IOB7 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOB_Buffer->B.bit8 ^=	1;		                 /* toggle IOB8 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOB_Buffer->B.bit9 ^=	1;		                 /* toggle IOB9 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOB_Buffer->B.bit10 ^= 1;		                /* toggle IOB10 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOB_Buffer->B.bit11 ^= 1;			            /* toggle IOB11 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOB_Buffer->B.bit12 ^= 1;			            /* toggle IOB12 */
 		F_Delay(250);									 /* Delay 250ms */

	}

	return (1);
} /* main() */

//=============================================================
// F_Delay() : delay x(uiTime) ms
//=============================================================
void F_Delay(unsigned int uiTimeMs)
{
	unsigned int i,j;
    for(i = 0; i < uiTimeMs; i++)
    	for(j = 0; j < 0x120; j++)
    	   P_WatchDog_Clr->W = CW_WatchDog_Clear;
} /* F_delay() */
