/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_93c46.h											     */	
/* Description : 93C46 eeprom data definition							     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v1.18.1A or later version				     */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */
#ifndef __SPMC75_93C46_H
#define __SPMC75_93C46_H

#define EEP_CS			15
#define _READ_b			0x06							              /* 110 */
#define _WRITE_b		0x05							              /* 101 */
#define _EWEN_b			0x04										  /* 100 */
#define _EWDS_b			0x04										  /* 100 */
#define _ERASE_b		0x07										  /* 111 */
#define _ERAL_b			0x04										  /* 100 */
#define _WRAL_b			0x04										  /* 100 */

#define Enable93Cx6		CS_Port->W |=  (1 << CS_Pin)
#define Disable93Cx6	CS_Port->W &= ~(1 << CS_Pin)

#define ACCESS_OK		0				 
#define ACCESS_FAIL		1

#endif /* __SPMC75_93C46_H */