/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_93c46_ext.h										     */	
/* Description : 93C46 eeprom external callable functions				     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v1.18.1A or later version				     */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */

#ifndef __SPMC75_93C46_EXT_H
#define __SPMC75_93C46_EXT_H

extern void  Spmc75_SetupSPI(UInt8 Clock_rate, UInt16 csport_addr, UInt16 cspin);

extern void  Spmc75_SPI_93C46_WREN(void);
extern void  Spmc75_SPI_93C46_WRDS(void);
extern UInt8 Spmc75_SPI_93C46_Read(UInt8 addr);
extern UInt8 Spmc75_SPI_93C46_Write(UInt8 addr, UInt8 data);
extern UInt8 Spmc75_SPI_93C46_ERASE(UInt8 addr);
extern UInt8 Spmc75_SPI_93C46_ERASE_ALL(void);
extern UInt8 Spmc75_SPI_93C46_WRITE_ALL(UInt8 data);


#endif /* __SPMC75_93C46_EXT_H */