/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_main.c											     */	
/* Description : main entry function of C programming					     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v2.0A or later version				     	 */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */
/* Environemnts of this demo:												 */								
/* HW : SPMC75F2313A EVM board V1.0											 */
/* SW : u'nSP IDE V2.0A, Windows XP 										 */
/* ========================================================================= */

#include ".\include\Spmc75f2313a.h"
#include "unspmacro.h"
#include "Spmc75_93c46_ext.h"

UInt16 ReadData[128] = { 0 };

int main(void)
{
	UInt16 i = 0, ERR = 0;
	UInt8  test_data = 0;
	
	Disable_FIQ_IRQ();
//
	Spmc75_SetupSPI(CB_SPI_SPIFS_CPUCLKdiv64, P_IOB_Data_ADDR, 6);
												  /* chip select pin = PB.6 */

	for(;;)
	{
		Spmc75_SPI_93C46_WREN();
		
		ERR = Spmc75_SPI_93C46_ERASE_ALL();
		if(ERR)
			while(1);

		ERR = Spmc75_SPI_93C46_ERASE(0x01);
		if(ERR)
			while(1);
		else
			test_data = Spmc75_SPI_93C46_Read(0x01);	

		ERR = Spmc75_SPI_93C46_Write(0x01, 0x6F);	
		if(ERR)
			while(1);
		else
			test_data = Spmc75_SPI_93C46_Read(0x01);	
		
		ERR = Spmc75_SPI_93C46_Write(2, 0x3F);	
		if(ERR)
			while(1);
		else
			test_data = Spmc75_SPI_93C46_Read(2);	
		
		ERR = Spmc75_SPI_93C46_WRITE_ALL(0x55);
		if(ERR)
			while(1);
		
		/* Initial read testing */
		for(i = 0; i < 128; i++)
		{
			ReadData[i] = Spmc75_SPI_93C46_Read(i);	
		}

		/* Data write testing */
		for(i = 0; i < 128; i++)
		{
			ERR = Spmc75_SPI_93C46_Write(i, i);	
			if(ERR)
				while(1);
		}

		/* Write-Read testing */
		for(i = 0; i < 128; i++)
		{
			ReadData[i] = Spmc75_SPI_93C46_Read(i);	
		}


		while(1);
	}

	return (1);
} /* main() */

