/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_main.c											     */	
/* Description : main entry function of C programming					     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v2.0A or later version				         */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */
/* Environemnts of this demo:												 */								
/* HW : SPMC75F2413A EVM board V1.2									 		 */
/* SW : u'nSP IDE V2.0A, Windows XP 										 */
/* ========================================================================= */

#include "Spmc75f2413a.h"
#include "unspmacro.h"

UInt16 adc_data = 0;

int main(void)
{
	UInt16 dummy;
	
	Disable_FIQ_IRQ();
	
	P_ADC_Setup->W = 0xC000;	// ADC power on, enable ADC converter
								// FCK/8

	P_ADC_Ctrl->B.ADCCHS = 0;	// start from IOA6
	P_ADC_Channel->W = 0x00FF;	// enable ADC channel 0 ~ 7
	
	P_ADC_Ctrl->B.ADCSTR = 1;	// start ADC conversion
	while(!P_ADC_Ctrl->B.ADCRDY);		
	dummy = P_ADC_Data->W;		// ignore first conversion data	
	
	P_ADC_Ctrl->B.ADCSTR = 1;	// start ADC conversion	
	P_ADC_Ctrl->B.ADCIE = 1;

	P_IOB_Dir->B.bit12 = 1;					              /* PB.12 is RCLK */
	P_SPI_Ctrl->W = 0x8020;

	IRQ_ON();	

	for(;;)
	{
		Display_Number(adc_data);
	}

	return (1);
} /* main() */

void IRQ7(void)	__attribute__ ((ISR));
void IRQ7(void)
{
	if(P_ADC_Ctrl->B.ADCIF)
	{
		P_ADC_Ctrl->B.ADCIF = 1;
		adc_data = (P_ADC_Data->W & 0xFFC0) >> 6;
		P_ADC_Ctrl->B.ADCSTR = 1;	// start ADC conversion	
	}	
} /* IRQ7() */


