// ========================================================================= 
// The information contained herein is the exclusive property of             
// Sunplus Technology Co. And shall not be distributed, reproduced,          
// or disclosed in whole in part without prior written permission.           
//             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     
//                    ALL RIGHTS RESERVED                                    
// The entire notice above must be reproduced on all authorized copies.      
// ========================================================================= 
// File Name   : spmc75f2413a.inc										     	
// Description : SPMC75F2413A register definition					     
// Processor   : SPMC75X series											     	
// Author      : Chih ming Huang										     
// Tools	   : u'nSP IDE tools v1.18.1A or later version				     
// Version     : 1.00 													     	
// Security    : Confidential Proprietary 							         
// E-Mail      : MaxHuang@sunplus.com.tw								     
// ========================================================================= 

//***************************************************************************//
//***************************************************************************//
// A. CPU control register													 //
//***************************************************************************//
//***************************************************************************//
.DEFINE P_System_Option 			0x8000	
.DEFINE P_Wait_Enter 				0x700C
.DEFINE P_Stdby_Enter 				0x700E
.DEFINE P_Reset_Status 				0x7006
.DEFINE P_Clk_Ctrl 					0x7007
.DEFINE P_WatchDog_Ctrl 			0x700A
.DEFINE P_WatchDog_Clr 				0x700B
.DEFINE	P_Wakeup_Ctrl 				0x700F
.DEFINE P_INT_Status 				0x70A0
.DEFINE P_INT_Priority 				0x70A4
.DEFINE P_MisINT_Ctrl 				0x70A8

//***************************************************************************//
//***************************************************************************//
// B. I/O Port register														 //
//***************************************************************************//
//***************************************************************************//
.DEFINE P_IOA_Data 					0x7060
.DEFINE P_IOA_Buffer 				0x7061
.DEFINE P_IOA_Dir 					0x7062
.DEFINE P_IOA_Attrib 				0x7063
.DEFINE P_IOA_Latch 				0x7064
.DEFINE P_IOA_SPE 					0x7080
.DEFINE	P_IOA_KCER 					0x7084

.DEFINE P_IOB_Data 					0x7068
.DEFINE P_IOB_Buffer 				0x7069
.DEFINE P_IOB_Dir 					0x706A
.DEFINE P_IOB_Attrib 				0x706B
.DEFINE P_IOB_Latch 				0x706C
.DEFINE P_IOB_SPE 					0x7081

.DEFINE P_IOC_Data 					0x7070
.DEFINE P_IOC_Buffer 				0x7071
.DEFINE P_IOC_Dir 					0x7072
.DEFINE P_IOC_Attrib 				0x7073
.DEFINE P_IOC_Latch 				0x7074
.DEFINE P_IOC_SPE 					0x7082

.DEFINE P_IOD_Data 					0x7078
.DEFINE P_IOD_Buffer 				0x7079
.DEFINE P_IOD_Dir 					0x707A
.DEFINE P_IOD_Attrib 				0x707B

//***************************************************************************//
//***************************************************************************//
// C. Timer 0,Timer 1,Timer 2,Timer 3,Timer 4								 //
//***************************************************************************//
//***************************************************************************//
.DEFINE P_TMR0_Ctrl 				0x7400
.DEFINE P_TMR1_Ctrl 				0x7401
.DEFINE P_TMR2_Ctrl 				0x7402
.DEFINE P_TMR3_Ctrl 				0x7403
.DEFINE P_TMR4_Ctrl 				0x7404

.DEFINE P_TMR_LDOK 					0x740A
                                    	
.DEFINE P_TMR0_TCNT 				0x7430
.DEFINE P_TMR1_TCNT 				0x7431
.DEFINE P_TMR2_TCNT 				0x7432
.DEFINE P_TMR3_TCNT 				0x7433
.DEFINE P_TMR4_TCNT 				0x7434
                                    	
.DEFINE P_TMR0_TGRA 				0x7440
.DEFINE P_TMR0_TGRB 				0x7441
.DEFINE P_TMR0_TGRC 				0x7442
                                    	
.DEFINE P_TMR1_TGRA 				0x7443
.DEFINE P_TMR1_TGRB 				0x7444
.DEFINE P_TMR1_TGRC 				0x7445

.DEFINE P_TMR2_TGRA 				0x7446
.DEFINE P_TMR2_TGRB 				0x7447
                                    	
.DEFINE P_TMR3_TGRA 				0x7448
.DEFINE P_TMR3_TGRB 				0x7449
.DEFINE P_TMR3_TGRC 				0x744A
.DEFINE P_TMR3_TGRD 				0x744B
                                    	
.DEFINE P_TMR4_TGRA 				0x744C
.DEFINE P_TMR4_TGRB 				0x744D
.DEFINE P_TMR4_TGRC 				0x744E
.DEFINE P_TMR4_TGRD 				0x744F
                                    	
.DEFINE P_TMR0_TPR 					0x7435
.DEFINE P_TMR1_TPR 					0x7436
.DEFINE P_TMR2_TPR 					0x7437
.DEFINE P_TMR3_TPR 					0x7438
.DEFINE P_TMR4_TPR 					0x7439
                                    	
.DEFINE P_TMR0_TBRA 				0x7450
.DEFINE P_TMR0_TBRB 				0x7451
.DEFINE P_TMR0_TBRC 				0x7452
                                    	
.DEFINE P_TMR1_TBRA 				0x7453
.DEFINE P_TMR1_TBRB 				0x7454
.DEFINE P_TMR1_TBRC 				0x7455
                                    	
.DEFINE P_TMR2_TBRA 				0x7456
.DEFINE P_TMR2_TBRB 				0x7457
                                    	
.DEFINE P_TMR3_TBRA 				0x7458
.DEFINE P_TMR3_TBRB 				0x7459
.DEFINE P_TMR3_TBRC 				0x745A
                                    	
.DEFINE P_TMR4_TBRA 				0x745C
.DEFINE P_TMR4_TBRB 				0x745D
.DEFINE P_TMR4_TBRC 				0x745E
                                    	
.DEFINE	P_TMR0_IOCtrl 				0x7410
.DEFINE	P_TMR1_IOCtrl 				0x7411
.DEFINE	P_TMR2_IOCtrl 				0x7412
.DEFINE	P_TMR3_IOCtrl 				0x7413
.DEFINE	P_TMR4_IOCtrl 				0x7414

.DEFINE P_TMR0_INT 					0x7420
.DEFINE P_TMR1_INT 					0x7421
.DEFINE P_TMR2_INT 					0x7422
.DEFINE P_TMR3_INT 					0x7423
.DEFINE P_TMR4_INT 					0x7424
                                    	
.DEFINE P_TMR0_Status 				0x7425
.DEFINE P_TMR1_Status 				0x7426
.DEFINE P_TMR2_Status 				0x7427
.DEFINE P_TMR3_Status 				0x7428
.DEFINE P_TMR4_Status 				0x7429
                                    	
.DEFINE P_TMR_Start 				0x7405
.DEFINE P_TMR_Output 				0x7406

.DEFINE P_TMR3_OutputCtrl 			0x7407
.DEFINE P_TMR4_OutputCtrl 			0x7408
                                    	
.DEFINE	P_POS0_DectCtrl 			0x7462
.DEFINE	P_POS1_DectCtrl 			0x7463
                                    	
.DEFINE	P_POS0_DectData 			0x7464
.DEFINE	P_POS1_DectData 			0x7465
                                    	
.DEFINE	P_TMR3_DeadTime 			0x7460
.DEFINE	P_TMR4_DeadTime 			0x7461
                                    	
.DEFINE	P_TPWM_Write 				0x7409
                                    	
.DEFINE	P_Fault1_Ctrl	 			0x7466
.DEFINE	P_Fault2_Ctrl	 			0x7467
                                    	
.DEFINE	P_OL1_Ctrl		 			0x7468
.DEFINE	P_OL2_Ctrl		 			0x7469
                                    	
.DEFINE	P_Fault1_Release 			0x746A
.DEFINE	P_Fault2_Release 			0x746B

//***************************************************************************//
//***************************************************************************//
// D. 10-bit ADC converter register											 //
//***************************************************************************//
//***************************************************************************//
.DEFINE P_ADC_Setup 				0x7160
.DEFINE P_ADC_Ctrl 					0x7161
.DEFINE P_ADC_Data 					0x7162
.DEFINE P_ADC_Channel 				0x7166

//***************************************************************************//
//***************************************************************************//
// E. Standard Peripheral Interface  SPI register							 //
//***************************************************************************//
//***************************************************************************//
.DEFINE P_SPI_Ctrl 					0x7140
.DEFINE P_SPI_TxStatus 				0x7141
.DEFINE P_SPI_TxBuf 				0x7142
.DEFINE P_SPI_RxStatus 				0x7143
.DEFINE P_SPI_RxBuf 				0x7144

//***************************************************************************//
//***************************************************************************//
// F. Flash organization and control register								 //
//***************************************************************************//
//***************************************************************************//
.DEFINE P_Flash_RW 					0x7554	
.DEFINE P_Flash_Cmd 				0x7555

//***************************************************************************//
//***************************************************************************//
// G. UART Control Register													 //
//***************************************************************************//
//***************************************************************************//
.DEFINE P_UART_Data 				0x7100	
.DEFINE P_UART_RXStatus 			0x7101	
.DEFINE P_UART_Ctrl 				0x7102	
.DEFINE P_UART_BaudRate 			0x7103	
.DEFINE P_UART_Status 				0x7104	

//***************************************************************************//
//***************************************************************************//
// H. Compare Match Timer Register											 //				
//***************************************************************************//
//***************************************************************************//
.DEFINE P_CMT_Start 				0x7500
.DEFINE P_CMT_Ctrl 					0x7501
.DEFINE P_CMT0_TCNT 				0x7508
.DEFINE P_CMT1_TCNT 				0x7509
.DEFINE P_CMT0_TPR 					0x7510
.DEFINE P_CMT1_TPR 					0x7511	

//***************************************************************************//
//***************************************************************************//
// I. Time Base Register													 //				
//***************************************************************************//
//***************************************************************************//
.DEFINE P_TMB_Reset 				0x70B8
.DEFINE P_BZO_Ctrl 					0x70B9

//***************************************************************************//
//***************************************************************************//
//Constant Definition														 //
//***************************************************************************//
//***************************************************************************//
//=================================//
// Generic Port register   		   //
//=================================//
// bit set //
.DEFINE	CB_BIT0						0
.DEFINE	CB_BIT1						1
.DEFINE	CB_BIT2						2
.DEFINE	CB_BIT3						3
.DEFINE	CB_BIT4						4
.DEFINE	CB_BIT5						5
.DEFINE	CB_BIT6						6
.DEFINE	CB_BIT7						7
.DEFINE	CB_BIT8						8
.DEFINE	CB_BIT9						9
.DEFINE	CB_BIT10					10
.DEFINE	CB_BIT11					11
.DEFINE	CB_BIT12					12
.DEFINE	CB_BIT13					13
.DEFINE	CB_BIT14					14
.DEFINE	CB_BIT15					15

//=================================//
// flash control register		   //
//=================================//

// P_Wait_Enter register // 
// word set //
.DEFINE	CW_WaitCMD					0x5005
.DEFINE	CW_WaitClr					0x0001

// P_Stdby_Enter register // 
// word set //
.DEFINE	CW_StdbyCMD					0xA00A
.DEFINE	CW_StdbyClr					0x0001

// P_System_Option register // 
// word set //
.DEFINE CW_SYS_CLK_R				0x0000
.DEFINE CW_SYS_CLK_OSC				0x0001
.DEFINE CW_SYS_WDG_Disable			(0x0000 << 1)
.DEFINE CW_SYS_WDG_Enable			(0x0001 << 1)
.DEFINE CW_SYS_LVR_Disable			(0x0000 << 2)
.DEFINE CW_SYS_LVR_Enable			(0x0001 << 2)
.DEFINE CW_SYS_LVD_Disable			(0x0000 << 3)
.DEFINE CW_SYS_LVD_Enable			(0x0001 << 3)
.DEFINE CW_SYS_Security_Protect		(0x0000 << 4)
.DEFINE CW_SYS_Security_NoProtect	(0x0001 << 4)
.DEFINE CW_SYS_Verification 		(0x02AA << 5)

// Bit set //
.DEFINE CB_SYS_CLK						0
.DEFINE CB_SYS_WDG						1
.DEFINE CB_SYS_LVR						2
.DEFINE CB_SYS_LVD						3
.DEFINE CB_SYS_Security					4
.DEFINE CB_SYS_Verification0			5
.DEFINE CB_SYS_Verification1			6
.DEFINE CB_SYS_Verification2			7
.DEFINE CB_SYS_Verification3			8
.DEFINE CB_SYS_Verification4			9
.DEFINE CB_SYS_Verification5			10
.DEFINE CB_SYS_Verification6			11
.DEFINE CB_SYS_Verification7			12
.DEFINE CB_SYS_Verification8			13
.DEFINE CB_SYS_Verification9			14
.DEFINE CB_SYS_Verification10			15

// P_Reset_Status register // 
// word set //
.DEFINE CW_CLEAR_EXTRF				0x0001
.DEFINE CW_CLEAR_PORF				(0x0001 << 1)
.DEFINE CW_CLEAR_WDRF				(0x0001 << 2)
.DEFINE CW_CLEAR_LPLVRF				(0x0001 << 3)
.DEFINE CW_CLEAR_SPLVRF				(0x0001 << 4)
.DEFINE CW_CLEAR_IARF				(0x0001 << 5)
.DEFINE CW_CLEAR_IIRF				(0x0001 << 6)
.DEFINE CW_CLEAR_FCHK 				(0x0055 << 9)

// Bit set //
.DEFINE CB_CLEAR_EXTRF					0
.DEFINE CB_CLEAR_PORF					1
.DEFINE CB_CLEAR_WDRF					2
.DEFINE CB_CLEAR_LVRF					3
.DEFINE CB_CLEAR_IARF					5
.DEFINE CB_CLEAR_IIRF					6
.DEFINE CB_CLEAR_FCHK0 					8
.DEFINE CB_CLEAR_FCHK1 					9
.DEFINE CB_CLEAR_FCHK2 					10
.DEFINE CB_CLEAR_FCHK3 					11
.DEFINE CB_CLEAR_FCHK4 					12
.DEFINE CB_CLEAR_FCHK5 					13
.DEFINE CB_CLEAR_FCHK6 					14
.DEFINE CB_CLEAR_FCHK7 					15

// P_Clk_Ctrl register // 
// word set //
.DEFINE CW_CLK_OSCIE				(0x0001 << 14)
.DEFINE CW_CLK_OSCSF				(0x0001 << 15)

// Bit set //
.DEFINE CB_CLK_OSCIE					14
.DEFINE CB_CLK_OSCSF					15

// P_WatchDog_Ctrl register // 
// word set //
.DEFINE CW_WDPS_FCKdiv65536			0x0000
.DEFINE CW_WDPS_FCKdiv32768			0x0001
.DEFINE CW_WDPS_FCKdiv16384			0x0002
.DEFINE CW_WDPS_FCKdiv8192			0x0003
.DEFINE CW_WDPS_FCKdiv4096			0x0004
.DEFINE CW_WDPS_FCKdiv2048			0x0005
.DEFINE CW_WDPS_FCKdiv1024			0x0006
.DEFINE CW_WDPS_FCKdiv512			0x0007

.DEFINE CW_WDCHK_Setting			(0x0015 << 3)
.DEFINE CW_WDRS_SYS_Reset			(0x0000 << 14)
.DEFINE CW_WDRS_CPU_Reset			(0x0001 << 14)
.DEFINE CW_WDEN						(0x0001 << 15)
.DEFINE CW_WatchDog_Clear			0xA005

// Bit set //
.DEFINE CB_WDPS0						0
.DEFINE CB_WDPS1						1
.DEFINE CB_WDPS2						2
.DEFINE CB_WDCHK0						3
.DEFINE CB_WDCHK1						4
.DEFINE CB_WDCHK2						5
.DEFINE CB_WDCHK3						6
.DEFINE CB_WDCHK4						7
.DEFINE CB_WDRS							14
.DEFINE CB_WDEN							15

// P_Wakeup_Ctrl register // 
// word set //
.DEFINE CW_CMTWE_Enable				(0x0001<<4)
.DEFINE CW_PDC0WE_Enable			(0x0001<<5)
.DEFINE CW_PDC1WE_Enable			(0x0001<<6)
.DEFINE CW_TPM2WE_Enable			(0x0001<<7)
.DEFINE CW_EXT0WE_Enable			(0x0001<<11)
.DEFINE CW_EXT1WE_Enable			(0x0001<<12)
.DEFINE CW_SPIWE_Enable				(0x0001<<13)
.DEFINE CW_UARTWE_Enable			(0x0001<<14)
.DEFINE CW_KEYWE_Enable				(0x0001<<15)

// Bit set //
.DEFINE CB_CMTWE_Enable					4
.DEFINE CB_PDC0WE_Enable				5
.DEFINE CB_PDC1WE_Enable				6
.DEFINE CB_TPM2WE_Enable				7
.DEFINE CB_EXT0WE_Enable				11
.DEFINE CB_EXT1WE_Enable				12
.DEFINE CB_SPIWE_Enable					13
.DEFINE CB_UARTWE_Enable				14
.DEFINE CB_KEYWE_Enable					15

// P_Flash_RW register //
// word set //
.DEFINE	CW_BK15WDIS					0x4000			//BANK 15 Write Disable
.DEFINE	CW_BK14WDIS					0x4000			//BANK 14 Write Disable
.DEFINE	CW_BK13WDIS					0x2000			//BANK 13 Write Disable
.DEFINE	CW_BK12WDIS					0x1000			//BANK 12 Write Disable
.DEFINE	CW_BK11WDIS					0x0800			//BANK 11 Write Disable
.DEFINE	CW_BK10WDIS					0x0400			//BANK 10 Write Disable
.DEFINE	CW_BK9WDIS					0x0200			//BANK 9 Write Disable
.DEFINE	CW_BK8WDIS					0x0100			//BANK 8 Write Disable
.DEFINE	CW_BK7WDIS					0x0080			//BANK 7 Write Disable
.DEFINE	CW_BK6WDIS					0x0040			//BANK 6 Write Disable
.DEFINE	CW_BK5WDIS					0x0020			//BANK 5 Write Disable
.DEFINE	CW_BK4WDIS					0x0010			//BANK 4 Write Disable
.DEFINE	CW_BK3WDIS					0x0008			//BANK 3 Write Disable
.DEFINE	CW_BK2WDIS					0x0004			//BANK 2 Write Disable
.DEFINE	CW_BK1WDIS					0x0002			//BANK 1 Write Disable
.DEFINE	CW_BK0WDIS					0x0001			//BANK 0 Write Disable

// Bit set //
.DEFINE	CB_BK14WDIS						14			//BANK 14 Write Disable
.DEFINE	CB_BK13WDIS						13			//BANK 13 Write Disable
.DEFINE	CB_BK12WDIS						12			//BANK 12 Write Disable
.DEFINE	CB_BK11WDIS						11			//BANK 11 Write Disable
.DEFINE	CB_BK10WDIS						10			//BANK 10 Write Disable
.DEFINE	CB_BK9WDIS						9			//BANK 9 Write Disable
.DEFINE	CB_BK8WDIS						8			//BANK 8 Write Disable
.DEFINE	CB_BK7WDIS						7			//BANK 7 Write Disable
.DEFINE	CB_BK6WDIS						6			//BANK 6 Write Disable
.DEFINE	CB_BK5WDIS						5			//BANK 5 Write Disable
.DEFINE	CB_BK4WDIS						4			//BANK 4 Write Disable
.DEFINE	CB_BK3WDIS						3			//BANK 3 Write Disable
.DEFINE	CB_BK2WDIS						2			//BANK 2 Write Disable
.DEFINE	CB_BK1WDIS						1			//BANK 1 Write Disable
.DEFINE	CB_BK0WDIS						0			//BANK 0 Write Disable

// P_Flash_Cmd register //
// word set //
.DEFINE	CW_FlashRW_CMD				0x5A5A			//Flash RW Command
.DEFINE	CW_FlashCMD					0xAAAA			//Flash Command FLash Block
.DEFINE	CW_PageErase				0x5511			//Flash Page Erase Command
.DEFINE	CW_Program					0x5533			//Flash Program Command
.DEFINE	CW_Sequential				0x5544			//Flash Sequential Program Command
.DEFINE	CW_SequentialEnd			0xFFFF			//Flash Sequential Program End Command

// P_IOA_SPE register //
// word set //
.DEFINE CW_IOA_TMR2_TGRA_SFR_EN		0x0200			//TGRA of Timer2 special function enable
.DEFINE CW_IOA_TMR2_TGRB_SFR_EN		0x0400			//TGRB of Timer2 special function enable
.DEFINE CW_IOA_TCLKA_SFR_EN			0x0800			//External clock A input enable
.DEFINE CW_IOA_TCLKB_SFR_EN			0x1000			//External clock B input enable
.DEFINE CW_IOA_TCLKC_SFR_EN			0x2000			//External clock C input enable
.DEFINE CW_IOA_TCLKD_SFREN			0x4000			//External clock D input enable

// Bit set //
.DEFINE CB_IOA_TMR2_TGRA_SFR_EN			9			//TGRA of Timer2 special function enable
.DEFINE CB_IOA_TMR2_TGRB_SFR_EN			10			//TGRB of Timer2 special function enable
.DEFINE CB_IOA_TCLKA_SFR_EN				11			//External clock A input enable
.DEFINE CB_IOA_TCLKB_SFR_EN				12			//External clock B input enable
.DEFINE CB_IOA_TCLKC_SFR_EN				13			//External clock C input enable
.DEFINE CB_IOA_TCLKD_SFREN				14			//External clock D input enable

// P_IOA_KCER register //
// word set //
.DEFINE CW_IOA_KC8_EN				0x0100			//IOA8 key change enable
.DEFINE CW_IOA_KC9_EN				0x0200			//IOA9 key change enable
.DEFINE CW_IOA_KC10_EN				0x0400			//IOA10 key change enable
.DEFINE CW_IOA_KC11_EN				0x0800			//IOA11 key change enable
.DEFINE CW_IOA_KC12_EN				0x1000			//IOA12 key change enable
.DEFINE CW_IOA_KC13_EN				0x2000			//IOA13 key change enable
.DEFINE CW_IOA_KC14_EN				0x4000			//IOA14 key change enable
.DEFINE CW_IOA_KC15_EN				0x8000			//IOA15 key change enable

// Bit set //
.DEFINE CB_IOA_KC8_EN					8			//IOA8 key change enable
.DEFINE CB_IOA_KC9_EN					9			//IOA9 key change enable
.DEFINE CB_IOA_KC10_EN					10			//IOA10 key change enable
.DEFINE CB_IOA_KC11_EN					11			//IOA11 key change enable
.DEFINE CB_IOA_KC12_EN					12			//IOA12 key change enable
.DEFINE CB_IOA_KC13_EN					13			//IOA13 key change enable
.DEFINE CB_IOA_KC14_EN					14			//IOA14 key change enable
.DEFINE CB_IOA_KC15_EN					15			//IOA15 key change enable

// P_IOB_SPE register //
// word set //
.DEFINE CW_IOB_W1N_SFR_EN			0x0001			//IOB0 serves as W1N
.DEFINE CW_IOB_V1N_SFR_EN			0x0002			//IOB1 serves as V1N
.DEFINE CW_IOB_U1N_SFR_EN			0x0004			//IOB2 serves as U1N
.DEFINE CW_IOB_W1_SFR_EN			0x0008			//IOB3 serves as W1
.DEFINE CW_IOB_V1_SFR_EN			0x0010			//IOB4 serves as V1
.DEFINE CW_IOB_U1_SFR_EN			0x0020			//IOB5 serves as U1
.DEFINE CW_IOB_FTIN1_SFR_EN			0x0040			//IOB6 serves as FTIN1
.DEFINE CW_IOB_OL1_SFR_EN			0x0080			//IOB7 serves as OL1
.DEFINE CW_IOB_TMR0_TGRC_SFR_EN		0x0100			//TGRC of Timer0 special function enable 
.DEFINE CW_IOB_TMR0_TGRB_SFR_EN		0x0200			//TGRB of Timer0 special function enable 
.DEFINE CW_IOB_TMR0_TGRA_SFR_EN		0x0400			//TGRA of Timer0 special function enable 

// Bit set //
.DEFINE CB_IOB_W1N_SFR_EN				0			//IOB0 serves as W1N
.DEFINE CB_IOB_V1N_SFR_EN				1			//IOB1 serves as V1N
.DEFINE CB_IOB_U1N_SFR_EN				2			//IOB2 serves as U1N
.DEFINE CB_IOB_W1_SFR_EN				3			//IOB3 serves as W1
.DEFINE CB_IOB_V1_SFR_EN				4			//IOB4 serves as V1
.DEFINE CB_IOB_U1_SFR_EN				5			//IOB5 serves as U1
.DEFINE CB_IOB_FTIN1_SFR_EN				6			//IOB6 serves as FTIN1
.DEFINE CB_IOB_OL1_SFR_EN				7			//IOB7 serves as OL1
.DEFINE CB_IOB_TMR0_TGRC_SFR_EN			8			//TGRC of Timer0 special function enable 
.DEFINE CB_IOB_TMR0_TGRB_SFR_EN			9			//TGRB of Timer0 special function enable 
.DEFINE CB_IOB_TMR0_TGRA_SFR_EN			10			//TGRA of Timer0 special function enable 

// P_IOC_SPE register //
// word set //
.DEFINE CW_IOC_EXTINT0_SFR_EN		0x0004			//IOC2 external input interrupt 0 enable
.DEFINE CW_IOC_EXTINT1_SFR_EN		0x0008			//IOC3 external input interrupt 0 enable
.DEFINE CW_IOC_TMR1_TGRA_SFR_EN		0x0010			//TGRA of Timer1 special function enable 
.DEFINE CW_IOC_TMR1_TGRB_SFR_EN		0x0020			//TGRB of Timer1 special function enable 
.DEFINE CW_IOC_TMR1_TGRC_SFR_EN		0x0040			//TGRC of Timer1 special function enable 
.DEFINE CW_IOC_OL2_SFR_EN			0x0100			//IOC8 serves as OL2
.DEFINE CW_IOC_FTIN2_SFR_EN			0x0200			//IOC9 serves as FTIN2
.DEFINE CW_IOC_U2_SFR_EN			0x0400			//IOC10 serves as U2
.DEFINE CW_IOC_V2_SFR_EN			0x0800			//IOC11 serves as V2
.DEFINE CW_IOC_W2_SFR_EN			0x1000			//IOC12 serves as W2
.DEFINE CW_IOC_U2N_SFR_EN			0x2000			//IOC13 serves as U2N
.DEFINE CW_IOC_V2N_SFR_EN			0x4000			//IOC14 serves as V2N
.DEFINE CW_IOC_W2N_SFR_EN			0x8000			//IOC15 serves as W2N

// Bit set //
.DEFINE CB_IOC_EXTINT0_SFR_EN			2			//IOC2 external input interrupt 0 enable
.DEFINE CB_IOC_EXTINT1_SFR_EN			3			//IOC3 external input interrupt 0 enable
.DEFINE CB_IOC_TMR1_TGRA_SFR_EN			4			//TGRA of Timer1 special function enable 
.DEFINE CB_IOC_TMR1_TGRB_SFR_EN			5			//TGRB of Timer1 special function enable 
.DEFINE CB_IOC_TMR1_TGRC_SFR_EN			6			//TGRC of Timer1 special function enable 
.DEFINE CB_IOC_OL2_SFR_EN				8			//IOC8 serves as OL2
.DEFINE CB_IOC_FTIN2_SFR_EN				9			//IOC9 serves as FTIN2
.DEFINE CB_IOC_U2_SFR_EN				10			//IOC10 serves as U2
.DEFINE CB_IOC_V2_SFR_EN				11			//IOC11 serves as V2
.DEFINE CB_IOC_W2_SFR_EN				12			//IOC12 serves as W2
.DEFINE CB_IOC_U2N_SFR_EN				13			//IOC13 serves as U2N
.DEFINE CB_IOC_V2N_SFR_EN				14			//IOC14 serves as V2N
.DEFINE CB_IOC_W2N_SFR_EN				15			//IOC15 serves as W2N

//=================================//
// B. Timer0/Timer1/Timer2 register//
//=================================//
// P_TMR0_Ctrl register //
// word set //
.DEFINE CW_TMR0_TMRPS_FCKdiv1			0x0000
.DEFINE CW_TMR0_TMRPS_FCKdiv4			0x0001
.DEFINE CW_TMR0_TMRPS_FCKdiv16			0x0002
.DEFINE CW_TMR0_TMRPS_FCKdiv64			0x0003
.DEFINE CW_TMR0_TMRPS_FCKdiv256			0x0004
.DEFINE CW_TMR0_TMRPS_FCKdiv1024		0x0005
.DEFINE CW_TMR0_TMRPS_TCLKA				0x0006
.DEFINE CW_TMR0_TMRPS_TCLKB				0x0007
.DEFINE CW_TMR0_CKEGS_Rising			(0x0000 << 3)
.DEFINE CW_TMR0_CKEGS_Falling			(0x0001 << 3)
.DEFINE CW_TMR0_CKEGS_Both				(0x0002 << 3)
.DEFINE CW_TMR0_CCLS_Disabled			(0x0000 << 5)
.DEFINE CW_TMR0_CCLS_TGRA				(0x0001 << 5)
.DEFINE CW_TMR0_CCLS_TGRB				(0x0002 << 5)
.DEFINE CW_TMR0_CCLS_TGRC				(0x0003 << 5)
.DEFINE CW_TMR0_CCLS_PDR6				(0x0004 << 5)			
.DEFINE CW_TMR0_CCLS_PDR3				(0x0005	<< 5)		
.DEFINE CW_TMR0_CCLS_PDR				(0x0006 << 5)
.DEFINE CW_TMR0_CCLS_TPR				(0x0007 << 5)
.DEFINE CW_TMR0_CLEGS_NotClear			(0x0000 << 8)
.DEFINE CW_TMR0_CLEGS_Rising			(0x0001 << 8)
.DEFINE CW_TMR0_CLEGS_Falling			(0x0002 << 8)
.DEFINE CW_TMR0_CLEGS_Both				(0x0003 << 8)
.DEFINE CW_TMR0_MODE_Normal				(0x0000 << 10)
.DEFINE CW_TMR0_MODE_Mode1				(0x0004 << 10)
.DEFINE CW_TMR0_MODE_Mode2				(0x0005 << 10)
.DEFINE CW_TMR0_MODE_Mode3				(0x0006 << 10)
.DEFINE CW_TMR0_MODE_Mode4				(0x0007 << 10)
.DEFINE CW_TMR0_MODE_PWM_Edge			(0x0008 << 10)
.DEFINE CW_TMR0_MODE_PWM_Center			(0x000A << 10)
.DEFINE CW_TMR0_SPCK_FCKdiv1			(0x0000 << 14)
.DEFINE CW_TMR0_SPCK_FCKdiv2			(0x0001 << 14)
.DEFINE CW_TMR0_SPCK_FCKdiv4			(0x0002 << 14)
.DEFINE CW_TMR0_SPCK_FCKdiv8			(0x0003 << 14)

// Bit set //
.DEFINE CB_TMR0_TMRPS0					0
.DEFINE CB_TMR0_TMRPS1					1
.DEFINE CB_TMR0_TMRPS2					2
.DEFINE CB_TMR0_CKEGS0					3
.DEFINE CB_TMR0_CKEGS1					4
.DEFINE CB_TMR0_CCLS0					5
.DEFINE CB_TMR0_CCLS1					6
.DEFINE CB_TMR0_CCLS2					7
.DEFINE CB_TMR0_CLEGS0					8
.DEFINE CB_TMR0_CLEGS1					9
.DEFINE CB_TMR0_MODE0					10
.DEFINE CB_TMR0_MODE1					11
.DEFINE CB_TMR0_MODE2					12
.DEFINE CB_TMR0_MODE3					13
.DEFINE CB_TMR0_SPCK0					14
.DEFINE CB_TMR0_SPCK1					15

// P_TMR1_Ctrl register //
// word set //
.DEFINE CW_TMR1_TMRPS_FCKdiv1			0x0000
.DEFINE CW_TMR1_TMRPS_FCKdiv4			0x0001
.DEFINE CW_TMR1_TMRPS_FCKdiv16			0x0002
.DEFINE CW_TMR1_TMRPS_FCKdiv64			0x0003
.DEFINE CW_TMR1_TMRPS_FCKdiv256			0x0004
.DEFINE CW_TMR1_TMRPS_FCKdiv1024		0x0005
.DEFINE CW_TMR1_TMRPS_TCLKA				0x0006
.DEFINE CW_TMR1_TMRPS_TCLKB				0x0007
.DEFINE CW_TMR1_CKEGS_Rising			(0x0000 << 3)
.DEFINE CW_TMR1_CKEGS_Falling			(0x0001 << 3)
.DEFINE CW_TMR1_CKEGS_Both				(0x0002 << 3)
.DEFINE CW_TMR1_CCLS_Disabled			(0x0000 << 5)
.DEFINE CW_TMR1_CCLS_TGRA				(0x0001 << 5)
.DEFINE CW_TMR1_CCLS_TGRB				(0x0002 << 5)
.DEFINE CW_TMR1_CCLS_TGRC				(0x0003 << 5)
.DEFINE CW_TMR1_CCLS_PDR6				(0x0004 << 5)			
.DEFINE CW_TMR1_CCLS_PDR3				(0x0005	<< 5)		
.DEFINE CW_TMR1_CCLS_PDR				(0x0006 << 5)
.DEFINE CW_TMR1_CCLS_TPR				(0x0007 << 5)
.DEFINE CW_TMR1_CLEGS_NotClear			(0x0000 << 8)
.DEFINE CW_TMR1_CLEGS_Rising			(0x0001 << 8)
.DEFINE CW_TMR1_CLEGS_Falling			(0x0002 << 8)
.DEFINE CW_TMR1_CLEGS_Both				(0x0003 << 8)
.DEFINE CW_TMR1_MODE_Normal				(0x0000 << 10)
.DEFINE CW_TMR1_MODE_Mode1				(0x0004 << 10)
.DEFINE CW_TMR1_MODE_Mode2				(0x0005 << 10)
.DEFINE CW_TMR1_MODE_Mode3				(0x0006 << 10)
.DEFINE CW_TMR1_MODE_Mode4				(0x0007 << 10)
.DEFINE CW_TMR1_MODE_PWM_Edge			(0x0008 << 10)
.DEFINE CW_TMR1_MODE_PWM_Center			(0x000A << 10)
.DEFINE CW_TMR1_SPCK_FCKdiv1			(0x0000 << 14)
.DEFINE CW_TMR1_SPCK_FCKdiv2			(0x0001 << 14)
.DEFINE CW_TMR1_SPCK_FCKdiv4			(0x0002 << 14)
.DEFINE CW_TMR1_SPCK_FCKdiv8			(0x0003 << 14)

// Bit set //
.DEFINE CB_TMR1_TMRPS0					0
.DEFINE CB_TMR1_TMRPS1					1
.DEFINE CB_TMR1_TMRPS2					2
.DEFINE CB_TMR1_CKEGS0					3
.DEFINE CB_TMR1_CKEGS1					4
.DEFINE CB_TMR1_CCLS0					5
.DEFINE CB_TMR1_CCLS1					6
.DEFINE CB_TMR1_CCLS2					7
.DEFINE CB_TMR1_CLEGS0					8
.DEFINE CB_TMR1_CLEGS1					9
.DEFINE CB_TMR1_MODE0					10
.DEFINE CB_TMR1_MODE1					11
.DEFINE CB_TMR1_MODE2					12
.DEFINE CB_TMR1_MODE3					13
.DEFINE CB_TMR1_SPCK0					14
.DEFINE CB_TMR1_SPCK1					15

// P_TMR2_Ctrl register //
// word set //
.DEFINE CW_TMR2_TMRPS_FCKdiv1			0x0000
.DEFINE CW_TMR2_TMRPS_FCKdiv4			0x0001
.DEFINE CW_TMR2_TMRPS_FCKdiv16			0x0002
.DEFINE CW_TMR2_TMRPS_FCKdiv64			0x0003
.DEFINE CW_TMR2_TMRPS_FCKdiv256			0x0004
.DEFINE CW_TMR2_TMRPS_FCKdiv1024		0x0005
.DEFINE CW_TMR2_TMRPS_TCLKA				0x0006
.DEFINE CW_TMR2_TMRPS_TCLKB				0x0007
.DEFINE CW_TMR2_CKEGS_Rising			(0x0000 << 3)
.DEFINE CW_TMR2_CKEGS_Falling			(0x0001 << 3)
.DEFINE CW_TMR2_CKEGS_Both				(0x0002 << 3)
.DEFINE CW_TMR2_CCLS_Disabled			(0x0000 << 5)
.DEFINE CW_TMR2_CCLS_TGRA				(0x0001 << 5)
.DEFINE CW_TMR2_CCLS_TGRB				(0x0002 << 5)
.DEFINE CW_TMR2_CCLS_TPR				(0x0007 << 5)
.DEFINE CW_TMR2_CLEGS_NotClear			(0x0000 << 8)
.DEFINE CW_TMR2_CLEGS_Rising			(0x0001 << 8)
.DEFINE CW_TMR2_CLEGS_Falling			(0x0002 << 8)
.DEFINE CW_TMR2_CLEGS_Both				(0x0003 << 8)
.DEFINE CW_TMR2_MODE_Normal				(0x0000 << 10)
.DEFINE CW_TMR2_MODE_PWM_Edge			(0x0008 << 10)
.DEFINE CW_TMR2_MODE_PWM_Center			(0x000A << 10)
.DEFINE CW_TMR2_SPCK_FCKdiv1			(0x0000 << 14)
.DEFINE CW_TMR2_SPCK_FCKdiv2			(0x0001 << 14)
.DEFINE CW_TMR2_SPCK_FCKdiv4			(0x0002 << 14)
.DEFINE CW_TMR2_SPCK_FCKdiv8			(0x0003 << 14)

// Bit set //
.DEFINE CB_TMR2_TMRPS0					0
.DEFINE CB_TMR2_TMRPS1					1
.DEFINE CB_TMR2_TMRPS2					2
.DEFINE CB_TMR2_CKEGS0					3
.DEFINE CB_TMR2_CKEGS1					4
.DEFINE CB_TMR2_CCLS0					5
.DEFINE CB_TMR2_CCLS1					6
.DEFINE CB_TMR2_CCLS2					7
.DEFINE CB_TMR2_CLEGS0					8
.DEFINE CB_TMR2_CLEGS1					9
.DEFINE CB_TMR2_MODE0					10
.DEFINE CB_TMR2_MODE1					11
.DEFINE CB_TMR2_MODE2					12
.DEFINE CB_TMR2_MODE3					13
.DEFINE CB_TMR2_SPCK0					14
.DEFINE CB_TMR2_SPCK1					15

// P_TMR3_Ctrl register //
// word set //
.DEFINE CW_TMR3_TMRPS_FCKdiv1			0x0000
.DEFINE CW_TMR3_TMRPS_FCKdiv4			0x0001
.DEFINE CW_TMR3_TMRPS_FCKdiv16			0x0002
.DEFINE CW_TMR3_TMRPS_FCKdiv64			0x0003
.DEFINE CW_TMR3_TMRPS_FCKdiv256			0x0004
.DEFINE CW_TMR3_TMRPS_FCKdiv1024		0x0005
.DEFINE CW_TMR3_TMRPS_TCLKA				0x0006
.DEFINE CW_TMR3_TMRPS_TCLKB				0x0007
.DEFINE CW_TMR3_CKEGS_Rising			(0x0000 << 3)
.DEFINE CW_TMR3_CKEGS_Falling			(0x0001 << 3)
.DEFINE CW_TMR3_CKEGS_Both				(0x0002 << 3)
.DEFINE CW_TMR3_CCLS_Disabled			(0x0000 << 5)
.DEFINE CW_TMR3_CCLS_TPR				(0x0007 << 5)

//.DEFINE CW_TMR3_LDOK					(0x0001 << 9)

.DEFINE CW_TMR3_MODE_Normal				(0x0000 << 10)
.DEFINE CW_TMR3_MODE_PWM_Edge			(0x0008 << 10)
.DEFINE CW_TMR3_MODE_PWM_Center			(0x000A << 10)
.DEFINE CW_TMR3_PRDINT_Period			(0x0000 << 14)
.DEFINE CW_TMR3_PRDINT_2Period			(0x0001 << 14)
.DEFINE CW_TMR3_PRDINT_4Period			(0x0002 << 14)
.DEFINE CW_TMR3_PRDINT_8Period			(0x0003 << 14)

// Bit set //
.DEFINE CB_TMR3_TMRPS0					0
.DEFINE CB_TMR3_TMRPS1					1
.DEFINE CB_TMR3_TMRPS2					2
.DEFINE CB_TMR3_CKEGS0					3
.DEFINE CB_TMR3_CKEGS1					4
.DEFINE CB_TMR3_CCLS0					5
.DEFINE CB_TMR3_CCLS1					6
.DEFINE CB_TMR3_CCLS2					7
.DEFINE CB_TMR3_MODE0					10
.DEFINE CB_TMR3_MODE1					11
.DEFINE CB_TMR3_MODE2					12
.DEFINE CB_TMR3_MODE3					13
.DEFINE CB_TMR3_PRDINT0					14
.DEFINE CB_TMR3_PRDINT1					15

// P_TMR4_Ctrl register //
// word set //
.DEFINE CW_TMR4_TMRPS_FCKdiv1			0x0000
.DEFINE CW_TMR4_TMRPS_FCKdiv4			0x0001
.DEFINE CW_TMR4_TMRPS_FCKdiv16			0x0002
.DEFINE CW_TMR4_TMRPS_FCKdiv64			0x0003
.DEFINE CW_TMR4_TMRPS_FCKdiv256			0x0004
.DEFINE CW_TMR4_TMRPS_FCKdiv1024		0x0005
.DEFINE CW_TMR4_TMRPS_TCLKA				0x0006
.DEFINE CW_TMR4_TMRPS_TCLKB				0x0007
.DEFINE CW_TMR4_CKEGS_Rising			(0x0000 << 3)
.DEFINE CW_TMR4_CKEGS_Falling			(0x0001 << 3)
.DEFINE CW_TMR4_CKEGS_Both				(0x0002 << 3)
.DEFINE CW_TMR4_CCLS_Disabled			(0x0000 << 5)
.DEFINE CW_TMR4_CCLS_TPR				(0x0007 << 5)

//.DEFINE CW_TMR4_LDOK					(0x0001 << 9)

.DEFINE CW_TMR4_MODE_Normal				(0x0000 << 10)
.DEFINE CW_TMR4_MODE_PWM_Edge			(0x0008 << 10)
.DEFINE CW_TMR4_MODE_PWM_Center			(0x000A << 10)
.DEFINE CW_TMR4_PRDINT_Period			(0x0000 << 14)
.DEFINE CW_TMR4_PRDINT_2Period			(0x0001 << 14)
.DEFINE CW_TMR4_PRDINT_4Period			(0x0002 << 14)
.DEFINE CW_TMR4_PRDINT_8Period			(0x0003 << 14)

// Bit set //
.DEFINE CB_TMR4_TMRPS0					0
.DEFINE CB_TMR4_TMRPS1					1
.DEFINE CB_TMR4_TMRPS2					2
.DEFINE CB_TMR4_CKEGS0					3
.DEFINE CB_TMR4_CKEGS1					4
.DEFINE CB_TMR4_CCLS0					5
.DEFINE CB_TMR4_CCLS1					6
.DEFINE CB_TMR4_CCLS2					7
.DEFINE CB_TMR4_MODE0					10
.DEFINE CB_TMR4_MODE1					11
.DEFINE CB_TMR4_MODE2					12
.DEFINE CB_TMR4_MODE3					13
.DEFINE CB_TMR4_PRDINT0					14
.DEFINE CB_TMR4_PRDINT1					15	

// P_TMR0_IOCtrl register //
// word set //
.DEFINE CW_TMR0_IOAMOD_Output_00		0x0000
.DEFINE CW_TMR0_IOAMOD_Output_01		0x0001
.DEFINE CW_TMR0_IOAMOD_Output_10		0x0002
.DEFINE CW_TMR0_IOAMOD_Output_11		0x0003
.DEFINE CW_TMR0_IOAMOD_Output_Hold		0x0004
.DEFINE CW_TMR0_IOAMOD_Capture_Rising	0x0008	
.DEFINE CW_TMR0_IOAMOD_Capture_Falling	0x0009	
.DEFINE CW_TMR0_IOAMOD_Capture_Both		0x000A	
.DEFINE CW_TMR0_IOAMOD_Capture_PDR		0x000C	
.DEFINE CW_TMR0_IOBMOD_Output_00		(0x0000 << 4)
.DEFINE CW_TMR0_IOBMOD_Output_01		(0x0001 << 4)
.DEFINE CW_TMR0_IOBMOD_Output_10		(0x0002 << 4)
.DEFINE CW_TMR0_IOBMOD_Output_11		(0x0003 << 4)
.DEFINE CW_TMR0_IOBMOD_Output_Hold		(0x0004 << 4)
.DEFINE CW_TMR0_IOBMOD_Capture_Rising	(0x0008 << 4)	
.DEFINE CW_TMR0_IOBMOD_Capture_Falling	(0x0009 << 4)	
.DEFINE CW_TMR0_IOBMOD_Capture_Both		(0x000A << 4)	
.DEFINE CW_TMR0_IOBMOD_Capture_PDR		(0x000C << 4)	
.DEFINE CW_TMR0_IOCMOD_Output_00		(0x0000 << 8)
.DEFINE CW_TMR0_IOCMOD_Output_01		(0x0001 << 8)
.DEFINE CW_TMR0_IOCMOD_Output_10		(0x0002 << 8)
.DEFINE CW_TMR0_IOCMOD_Output_11		(0x0003 << 8)
.DEFINE CW_TMR0_IOCMOD_Output_Hold		(0x0004 << 8)
.DEFINE CW_TMR0_IOCMOD_Capture_Rising	(0x0008 << 8)	
.DEFINE CW_TMR0_IOCMOD_Capture_Falling	(0x0009 << 8)	
.DEFINE CW_TMR0_IOCMOD_Capture_Both		(0x000A << 8)	
.DEFINE CW_TMR0_IOCMOD_Capture_PDR		(0x000C << 8)	

// Bit set //
.DEFINE CB_TMR0_IOAMOD0					0
.DEFINE CB_TMR0_IOAMOD1					1
.DEFINE CB_TMR0_IOAMOD2					2
.DEFINE CB_TMR0_IOAMOD3					3
.DEFINE CB_TMR0_IOBMOD0					4
.DEFINE CB_TMR0_IOBMOD1					5
.DEFINE CB_TMR0_IOBMOD2					6
.DEFINE CB_TMR0_IOBMOD3					7
.DEFINE CB_TMR0_IOCMOD0					8
.DEFINE CB_TMR0_IOCMOD1					9
.DEFINE CB_TMR0_IOCMOD2					10
.DEFINE CB_TMR0_IOCMOD3					11

// P_TMR1_IOCtrl register //
// word set //
.DEFINE CW_TMR1_IOAMOD_Output_00		0x0000
.DEFINE CW_TMR1_IOAMOD_Output_01		0x0001
.DEFINE CW_TMR1_IOAMOD_Output_10		0x0002
.DEFINE CW_TMR1_IOAMOD_Output_11		0x0003
.DEFINE CW_TMR1_IOAMOD_Output_Hold		0x0004
.DEFINE CW_TMR1_IOAMOD_Capture_Rising	0x0008	
.DEFINE CW_TMR1_IOAMOD_Capture_Falling	0x0009	
.DEFINE CW_TMR1_IOAMOD_Capture_Both		0x000A	
.DEFINE CW_TMR1_IOAMOD_Capture_PDR		0x000C	
.DEFINE CW_TMR1_IOBMOD_Output_00		(0x0000 << 4)
.DEFINE CW_TMR1_IOBMOD_Output_01		(0x0001 << 4)
.DEFINE CW_TMR1_IOBMOD_Output_10		(0x0002 << 4)
.DEFINE CW_TMR1_IOBMOD_Output_11		(0x0003 << 4)
.DEFINE CW_TMR1_IOBMOD_Output_Hold		(0x0004 << 4)
.DEFINE CW_TMR1_IOBMOD_Capture_Rising	(0x0008 << 4)	
.DEFINE CW_TMR1_IOBMOD_Capture_Falling	(0x0009 << 4)	
.DEFINE CW_TMR1_IOBMOD_Capture_Both		(0x000A << 4)	
.DEFINE CW_TMR1_IOBMOD_Capture_PDR		(0x000C << 4)	
.DEFINE CW_TMR1_IOCMOD_Output_00		(0x0000 << 8)
.DEFINE CW_TMR1_IOCMOD_Output_01		(0x0001 << 8)
.DEFINE CW_TMR1_IOCMOD_Output_10		(0x0002 << 8)
.DEFINE CW_TMR1_IOCMOD_Output_11		(0x0003 << 8)
.DEFINE CW_TMR1_IOCMOD_Output_Hold		(0x0004 << 8)
.DEFINE CW_TMR1_IOCMOD_Capture_Rising	(0x0008 << 8)	
.DEFINE CW_TMR1_IOCMOD_Capture_Falling	(0x0009 << 8)	
.DEFINE CW_TMR1_IOCMOD_Capture_Both		(0x000A << 8)	
.DEFINE CW_TMR1_IOCMOD_Capture_PDR		(0x000C << 8)	

// Bit set //
.DEFINE CB_TMR1_IOAMOD0					0
.DEFINE CB_TMR1_IOAMOD1					1
.DEFINE CB_TMR1_IOAMOD2					2
.DEFINE CB_TMR1_IOAMOD3					3
.DEFINE CB_TMR1_IOBMOD0					4
.DEFINE CB_TMR1_IOBMOD1					5
.DEFINE CB_TMR1_IOBMOD2					6
.DEFINE CB_TMR1_IOBMOD3					7
.DEFINE CB_TMR1_IOCMOD0					8
.DEFINE CB_TMR1_IOCMOD1					9
.DEFINE CB_TMR1_IOCMOD2					10
.DEFINE CB_TMR1_IOCMOD3					11	

// P_TMR2_IOCtrl register //
// word set //
.DEFINE CW_TMR2_IOAMOD_Output_00		0x0000
.DEFINE CW_TMR2_IOAMOD_Output_01		0x0001
.DEFINE CW_TMR2_IOAMOD_Output_10		0x0002
.DEFINE CW_TMR2_IOAMOD_Output_11		0x0003
.DEFINE CW_TMR2_IOAMOD_Output_Hold		0x0004
.DEFINE CW_TMR2_IOAMOD_Capture_Rising	0x0008	
.DEFINE CW_TMR2_IOAMOD_Capture_Falling	0x0009	
.DEFINE CW_TMR2_IOAMOD_Capture_Both		0x000A	
.DEFINE CW_TMR2_IOBMOD_Output_00		(0x0000 << 4)
.DEFINE CW_TMR2_IOBMOD_Output_01		(0x0001 << 4)
.DEFINE CW_TMR2_IOBMOD_Output_10		(0x0002 << 4)
.DEFINE CW_TMR2_IOBMOD_Output_11		(0x0003 << 4)
.DEFINE CW_TMR2_IOBMOD_Output_Hold		(0x0004 << 4)
.DEFINE CW_TMR2_IOBMOD_Capture_Rising	(0x0008 << 4)	
.DEFINE CW_TMR2_IOBMOD_Capture_Falling	(0x0009 << 4)	
.DEFINE CW_TMR2_IOBMOD_Capture_Both		(0x000A << 4)	

// Bit set //
.DEFINE CB_TMR2_IOAMOD0					0
.DEFINE CB_TMR2_IOAMOD1					1
.DEFINE CB_TMR2_IOAMOD2					2
.DEFINE CB_TMR2_IOAMOD3					3
.DEFINE CB_TMR2_IOBMOD0					4
.DEFINE CB_TMR2_IOBMOD1					5
.DEFINE CB_TMR2_IOBMOD2					6
.DEFINE CB_TMR2_IOBMOD3					7

// P_TMR3_IOCtrl register //
// word set //
.DEFINE CW_TMR3_IOAMOD_Output_00		0x0000
.DEFINE CW_TMR3_IOAMOD_Output_01		0x0001
.DEFINE CW_TMR3_IOAMOD_Output_10		0x0002
.DEFINE CW_TMR3_IOAMOD_Output_11		0x0003
.DEFINE CW_TMR3_IOAMOD_Output_Hold		0x0004
.DEFINE CW_TMR3_IOBMOD_Output_00		(0x0000 << 4)
.DEFINE CW_TMR3_IOBMOD_Output_01		(0x0001 << 4)
.DEFINE CW_TMR3_IOBMOD_Output_10		(0x0002 << 4)
.DEFINE CW_TMR3_IOBMOD_Output_11		(0x0003 << 4)
.DEFINE CW_TMR3_IOBMOD_Output_Hold		(0x0004 << 4)
.DEFINE CW_TMR3_IOCMOD_Output_00		(0x0000 << 8)
.DEFINE CW_TMR3_IOCMOD_Output_01		(0x0001 << 8)
.DEFINE CW_TMR3_IOCMOD_Output_10		(0x0002 << 8)
.DEFINE CW_TMR3_IOCMOD_Output_11		(0x0003 << 8)
.DEFINE CW_TMR3_IOCMOD_Output_Hold		(0x0004 << 8)

// Bit set //
.DEFINE CB_TMR3_IOAMOD0					0
.DEFINE CB_TMR3_IOAMOD1					1
.DEFINE CB_TMR3_IOAMOD2					2
.DEFINE CB_TMR3_IOAMOD3					3
.DEFINE CB_TMR3_IOBMOD0					4
.DEFINE CB_TMR3_IOBMOD1					5
.DEFINE CB_TMR3_IOBMOD2					6
.DEFINE CB_TMR3_IOBMOD3					7
.DEFINE CB_TMR3_IOCMOD0					8
.DEFINE CB_TMR3_IOCMOD1					9
.DEFINE CB_TMR3_IOCMOD2					10
.DEFINE CB_TMR3_IOCMOD3					11

// P_TMR4_IOCtrl register //
// word set //
.DEFINE CW_TMR4_IOAMOD_Output_00		0x0000
.DEFINE CW_TMR4_IOAMOD_Output_01		0x0001
.DEFINE CW_TMR4_IOAMOD_Output_10		0x0002
.DEFINE CW_TMR4_IOAMOD_Output_11		0x0003
.DEFINE CW_TMR4_IOAMOD_Output_Hold		0x0004
.DEFINE CW_TMR4_IOBMOD_Output_00		(0x0000 << 4)
.DEFINE CW_TMR4_IOBMOD_Output_01		(0x0001 << 4)
.DEFINE CW_TMR4_IOBMOD_Output_10		(0x0002 << 4)
.DEFINE CW_TMR4_IOBMOD_Output_11		(0x0003 << 4)
.DEFINE CW_TMR4_IOBMOD_Output_Hold		(0x0004 << 4)
.DEFINE CW_TMR4_IOCMOD_Output_00		(0x0000 << 8)
.DEFINE CW_TMR4_IOCMOD_Output_01		(0x0001 << 8)
.DEFINE CW_TMR4_IOCMOD_Output_10		(0x0002 << 8)
.DEFINE CW_TMR4_IOCMOD_Output_11		(0x0003 << 8)
.DEFINE CW_TMR4_IOCMOD_Output_Hold		(0x0004 << 8)

// Bit set //
.DEFINE CB_TMR4_IOAMOD0					0
.DEFINE CB_TMR4_IOAMOD1					1
.DEFINE CB_TMR4_IOAMOD2					2
.DEFINE CB_TMR4_IOAMOD3					3
.DEFINE CB_TMR4_IOBMOD0					4
.DEFINE CB_TMR4_IOBMOD1					5
.DEFINE CB_TMR4_IOBMOD2					6
.DEFINE CB_TMR4_IOBMOD3					7
.DEFINE CB_TMR4_IOCMOD0					8
.DEFINE CB_TMR4_IOCMOD1					9
.DEFINE CB_TMR4_IOCMOD2					10
.DEFINE CB_TMR4_IOCMOD3					11

// P_TMR0_INT register //
// word set //
.DEFINE CW_TMR0_TGAIE_Enable			0x0001	
.DEFINE CW_TMR0_TGBIE_Enable			(0x0001 << 1)	
.DEFINE CW_TMR0_TGCIE_Enable			(0x0001 << 2)	
.DEFINE CW_TMR0_TPRIE_Enable			(0x0001 << 4)	
.DEFINE CW_TMR0_TCVIE_Enable			(0x0001 << 5)	
.DEFINE CW_TMR0_TCUIE_Enable			(0x0001 << 6)	
.DEFINE CW_TMR0_TADSE_Enable			(0x0001 << 7)	
.DEFINE CW_TMR0_PDCIE_Enable			(0x0001 << 8)	

// Bit set //
.DEFINE CB_TMR0_TGAIE					0	
.DEFINE CB_TMR0_TGBIE					1
.DEFINE CB_TMR0_TGCIE					2	
.DEFINE CB_TMR0_TPRIE					4	
.DEFINE CB_TMR0_TCVIE					5	
.DEFINE CB_TMR0_TCUIE					6	
.DEFINE CB_TMR0_TADSE					7	
.DEFINE CB_TMR0_PDCIE					8

// P_TMR1_INT register //
// word set //
.DEFINE CW_TMR1_TGAIE_Enable			0x0001	
.DEFINE CW_TMR1_TGBIE_Enable			(0x0001 << 1)	
.DEFINE CW_TMR1_TGCIE_Enable			(0x0001 << 2)	
.DEFINE CW_TMR1_TPRIE_Enable			(0x0001 << 4)	
.DEFINE CW_TMR1_TCVIE_Enable			(0x0001 << 5)	
.DEFINE CW_TMR1_TCUIE_Enable			(0x0001 << 6)	
.DEFINE CW_TMR1_TADSE_Enable			(0x0001 << 7)	
.DEFINE CW_TMR1_PDCIE_Enable			(0x0001 << 8)	

// Bit set //
.DEFINE CB_TMR1_TGAIE					0	
.DEFINE CB_TMR1_TGBIE					1	
.DEFINE CB_TMR1_TGCIE					2
.DEFINE CB_TMR1_TPRIE					4
.DEFINE CB_TMR1_TCVIE					5	
.DEFINE CB_TMR1_TCUIE					6	
.DEFINE CB_TMR1_TADSE					7	
.DEFINE CB_TMR1_PDCIE					8	

// P_TMR2_INT register //
// word set //
.DEFINE CW_TMR2_TGAIE_Enable			0x0001	
.DEFINE CW_TMR2_TGBIE_Enable			(0x0001 << 1)	
.DEFINE CW_TMR2_TPRIE_Enable			(0x0001 << 4)	
.DEFINE CW_TMR2_TADSE_Enable			(0x0001 << 7)	

// Bit set //
.DEFINE CB_TMR2_TGAIE					0	
.DEFINE CB_TMR2_TGBIE					1	
.DEFINE CB_TMR2_TPRIE					4	
.DEFINE CB_TMR2_TADSE					7	

// P_TMR3_INT register //
// word set //
.DEFINE CW_TMR3_TGDIE_Enable			(0x0001 << 3)	
.DEFINE CW_TMR3_TPRIE_Enable			(0x0001 << 4)	
.DEFINE CW_TMR3_TADSE_Enable			(0x0001 << 7)	

// Bit set //
.DEFINE CB_TMR3_TGDIE					3	
.DEFINE CB_TMR3_TPRIE					4
.DEFINE CB_TMR3_TADSE					7

// P_TMR4_INT register //
// word set //
.DEFINE CW_TMR4_TGDIE_Enable			(0x0001 << 3)	
.DEFINE CW_TMR4_TPRIE_Enable			(0x0001 << 4)	
.DEFINE CW_TMR4_TADSE_Enable			(0x0001 << 7)	

// Bit set //
.DEFINE CB_TMR4_TGDIE					3	
.DEFINE CB_TMR4_TPRIE					4	
.DEFINE CB_TMR4_TADSE					7

// P_TMR0_Status register //
// word set //
.DEFINE CW_TMR0_TGAIF_Enable			0x0001	
.DEFINE CW_TMR0_TGBIF_Enable			(0x0001 << 1)	
.DEFINE CW_TMR0_TGCIF_Enable			(0x0001 << 2)	
.DEFINE CW_TMR0_TPRIF_Enable			(0x0001 << 4)	
.DEFINE CW_TMR0_TCVIF_Enable			(0x0001 << 5)	
.DEFINE CW_TMR0_TCUIF_Enable			(0x0001 << 6)	
.DEFINE CW_TMR0_TCDF_Enable				(0x0001 << 7)	
.DEFINE CW_TMR0_PDCIF_Enable			(0x0001 << 8)	

// Bit set //
.DEFINE CB_TMR0_TGAIF					0	
.DEFINE CB_TMR0_TGBIF					1
.DEFINE CB_TMR0_TGCIF					2	
.DEFINE CB_TMR0_TPRIF					3
.DEFINE CB_TMR0_TCVIF					4
.DEFINE CB_TMR0_TCUIF					6	
.DEFINE CB_TMR0_TCDF					7	
.DEFINE CB_TMR0_PDCIF					8

// P_TMR1_Status register //
// word set //
.DEFINE CW_TMR1_TGAIF_Enable			0x0001	
.DEFINE CW_TMR1_TGBIF_Enable			(0x0001 << 1)	
.DEFINE CW_TMR1_TGCIF_Enable			(0x0001 << 2)	
.DEFINE CW_TMR1_TPRIF_Enable			(0x0001 << 4)	
.DEFINE CW_TMR1_TCVIF_Enable			(0x0001 << 5)	
.DEFINE CW_TMR1_TCUIF_Enable			(0x0001 << 6)	
.DEFINE CW_TMR1_TCDF_Enable				(0x0001 << 7)	
.DEFINE CW_TMR1_PDCIF_Enable			(0x0001 << 8)	

// Bit set //
.DEFINE CB_TMR1_TGAIF					0	
.DEFINE CB_TMR1_TGBIF					1	
.DEFINE CB_TMR1_TGCIF					2
.DEFINE CB_TMR1_TPRIF					3	
.DEFINE CB_TMR1_TCVIF					4	
.DEFINE CB_TMR1_TCUIF					5
.DEFINE CB_TMR1_TCDF					6	
.DEFINE CB_TMR1_PDCIF					7

// P_TMR2_Status register //
// word set //
.DEFINE CW_TMR2_TGAIF_Enable			0x0001	
.DEFINE CW_TMR2_TGBIF_Enable			(0x0001 << 1)	
.DEFINE CW_TMR2_TPRIF_Enable			(0x0001 << 4)	
.DEFINE CW_TMR2_TCDF_Enable				(0x0001 << 7)	

// Bit set //
.DEFINE CB_TMR2_TGAIF_Enable			0	
.DEFINE CB_TMR2_TGBIF_Enable			1
.DEFINE CB_TMR2_TPRIF_Enable			4
.DEFINE CB_TMR2_TCDF_Enable				7

// P_TMR3_Status register //
// word set //
.DEFINE CW_TMR3_TGDIF_Enable			(0x0001 << 3)	
.DEFINE CW_TMR3_TPRIF_Enable			(0x0001 << 4)	
.DEFINE CW_TMR3_TCDF_Enable				(0x0001 << 7)	

// Bit set //
.DEFINE CB_TMR3_TGDIF_Enable			3	
.DEFINE CB_TMR3_TPRIF_Enable			4	
.DEFINE CB_TMR3_TCDF_Enable				7

// P_TMR4_Status register //
// word set //
.DEFINE CW_TMR4_TGDIF_Enable			(0x0001 << 3)	
.DEFINE CW_TMR4_TPRIF_Enable			(0x0001 << 4)	
.DEFINE CW_TMR4_TCDF_Enable				(0x0001 << 7)	

// Bit set //
.DEFINE CB_TMR4_TGDIF_Enable			3
.DEFINE CB_TMR4_TPRIF_Enable			4
.DEFINE CB_TMR4_TCDF_Enable				7

// P_TMR_Start register //
// word set //
.DEFINE CW_TMR_TMR0ST_Start				0x0001	
.DEFINE CW_TMR_TMR1ST_Start				(0x0001 << 1)	
.DEFINE CW_TMR_TMR2ST_Start				(0x0001 << 2)	
.DEFINE CW_TMR_TMR3ST_Start				(0x0001 << 3)	
.DEFINE CW_TMR_TMR4ST_Start				(0x0001 << 4)	

// Bit set //
.DEFINE CB_TMR_TMR0ST_Start				0	
.DEFINE CB_TMR_TMR1ST_Start				1	
.DEFINE CB_TMR_TMR2ST_Start				2
.DEFINE CB_TMR_TMR3ST_Start				3
.DEFINE CB_TMR_TMR4ST_Start				4

// P_TMR_Output register //
// word set //
.DEFINE CW_TMR_TMR3AOE_Enable			0x0001
.DEFINE CW_TMR_TMR3BOE_Enable			(0x0001 << 1)
.DEFINE CW_TMR_TMR3COE_Enable			(0x0001 << 2)
.DEFINE CW_TMR_TMR3DOE_Enable			(0x0001 << 3)
.DEFINE CW_TMR_TMR3EOE_Enable			(0x0001 << 4)
.DEFINE CW_TMR_TMR3FOE_Enable			(0x0001 << 5)
.DEFINE CW_TMR_TMR4AOE_Enable			(0x0001 << 8)
.DEFINE CW_TMR_TMR4BOE_Enable			(0x0001 << 9)
.DEFINE CW_TMR_TMR4COE_Enable			(0x0001 << 10)
.DEFINE CW_TMR_TMR4DOE_Enable			(0x0001 << 11)
.DEFINE CW_TMR_TMR4EOE_Enable			(0x0001 << 12)
.DEFINE CW_TMR_TMR4FOE_Enable			(0x0001 << 13)

// Bit set //
.DEFINE CB_TMR_TMR3AOE_Enable			0
.DEFINE CB_TMR_TMR3BOE_Enable			1
.DEFINE CB_TMR_TMR3COE_Enable			2
.DEFINE CB_TMR_TMR3DOE_Enable			3
.DEFINE CB_TMR_TMR3EOE_Enable			4
.DEFINE CB_TMR_TMR3FOE_Enable			5
.DEFINE CB_TMR_TMR4AOE_Enable			8
.DEFINE CB_TMR_TMR4BOE_Enable			9
.DEFINE CB_TMR_TMR4COE_Enable			10
.DEFINE CB_TMR_TMR4DOE_Enable			11
.DEFINE CB_TMR_TMR4EOE_Enable			12
.DEFINE CB_TMR_TMR4FOE_Enable			13

// P_TMR3_OutputCtrl register //
// word set //
.DEFINE CW_TMR3_UOC_Mode0				0x0000	
.DEFINE CW_TMR3_UOC_Mode1				0x0001
.DEFINE CW_TMR3_UOC_Mode2				0x0002
.DEFINE CW_TMR3_UOC_Mode3				0x0003
.DEFINE CW_TMR3_VOC_Mode0				(0x0000 << 2)	
.DEFINE CW_TMR3_VOC_Mode1				(0x0001 << 2)
.DEFINE CW_TMR3_VOC_Mode2				(0x0002 << 2)
.DEFINE CW_TMR3_VOC_Mode3				(0x0003 << 2)
.DEFINE CW_TMR3_WOC_Mode0				(0x0000 << 4)	
.DEFINE CW_TMR3_WOC_Mode1				(0x0001 << 4)
.DEFINE CW_TMR3_WOC_Mode2				(0x0002 << 4)
.DEFINE CW_TMR3_WOC_Mode3				(0x0003 << 4)
.DEFINE CW_TMR3_SYNC_NoSync				(0x0000 << 6)	
.DEFINE CW_TMR3_SYNC_PDR				(0x0001 << 6)	
.DEFINE CW_TMR3_SYNC_TGB				(0x0002 << 6)	
.DEFINE CW_TMR3_SYNC_TGC				(0x0003 << 6)	
.DEFINE CW_TMR3_UPWM_Out_HL				(0x0000 << 8)	
.DEFINE CW_TMR3_UPWM_Out_PWM			(0x0001 << 8)	
.DEFINE CW_TMR3_VPWM_Out_HL				(0x0000 << 9)	
.DEFINE CW_TMR3_VPWM_Out_PWM			(0x0001 << 9)	
.DEFINE CW_TMR3_WPWM_Out_HL				(0x0000 << 10)
.DEFINE CW_TMR3_WPWM_Out_PWM			(0x0001 << 10)
.DEFINE CW_TMR3_POLP_Active_Low			(0x0000 << 14)
.DEFINE CW_TMR3_POLP_Active_High		(0x0001 << 14)
.DEFINE CW_TMR3_DUTYMODE_UCom			(0x0000 << 15)
.DEFINE CW_TMR3_DUTYMODE_Independent	(0x0001 << 15)

// Bit set //
.DEFINE CB_TMR3_UOC0					0	
.DEFINE CB_TMR3_UOC1					1
.DEFINE CB_TMR3_VOC0					2	
.DEFINE CB_TMR3_VOC1					3
.DEFINE CB_TMR3_WOC0					4	
.DEFINE CB_TMR3_WOC1					5
.DEFINE CB_TMR3_SYNC0					6	
.DEFINE CB_TMR3_SYNC1					7		
.DEFINE CB_TMR3_UPWM					8	
.DEFINE CB_TMR3_VPWM					9	
.DEFINE CB_TMR3_WPWM					10
.DEFINE CB_TMR3_POLP_Active				14
.DEFINE CB_TMR3_DUTYMODE				15

// POLP = 1 //
.DEFINE CW_TMR3_POLP_1_UP_CPWM_UN_PWM			(CW_TMR3_UOC_Mode0 | CW_TMR3_UPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_1_UP_L_UN_PWM				(CW_TMR3_UOC_Mode1 | CW_TMR3_UPWM_Out_PWM)				
.DEFINE CW_TMR3_POLP_1_UP_PWM_UN_L				(CW_TMR3_UOC_Mode2 | CW_TMR3_UPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_1_UP_PWM_UN_CPWM			(CW_TMR3_UOC_Mode3 | CW_TMR3_UPWM_Out_PWM)

.DEFINE CW_TMR3_POLP_1_VP_CPWM_VN_PWM			(CW_TMR3_VOC_Mode0 | CW_TMR3_VPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_1_VP_L_VN_PWM				(CW_TMR3_VOC_Mode1 | CW_TMR3_VPWM_Out_PWM)				
.DEFINE CW_TMR3_POLP_1_VP_PWM_VN_L				(CW_TMR3_VOC_Mode2 | CW_TMR3_VPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_1_VP_PWM_VN_CPWM			(CW_TMR3_VOC_Mode3 | CW_TMR3_VPWM_Out_PWM)

.DEFINE CW_TMR3_POLP_1_WP_CPWM_WN_PWM			(CW_TMR3_WOC_Mode0 | CW_TMR3_WPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_1_WP_L_WN_PWM				(CW_TMR3_WOC_Mode1 | CW_TMR3_WPWM_Out_PWM)				
.DEFINE CW_TMR3_POLP_1_WP_PWM_WN_L				(CW_TMR3_WOC_Mode2 | CW_TMR3_WPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_1_WP_PWM_WN_CPWM			(CW_TMR3_WOC_Mode3 | CW_TMR3_WPWM_Out_PWM)

.DEFINE CW_TMR3_POLP_1_UP_L_UN_L				(CW_TMR3_UOC_Mode0 | CW_TMR3_UPWM_Out_HL)
.DEFINE CW_TMR3_POLP_1_UP_L_UN_H				(CW_TMR3_UOC_Mode1 | CW_TMR3_UPWM_Out_HL)
.DEFINE CW_TMR3_POLP_1_UP_H_UN_L				(CW_TMR3_UOC_Mode2 | CW_TMR3_UPWM_Out_HL)
.DEFINE CW_TMR3_POLP_1_UP_H_UN_H				(CW_TMR3_UOC_Mode3 | CW_TMR3_UPWM_Out_HL)

.DEFINE CW_TMR3_POLP_1_VP_L_VN_L				(CW_TMR3_VOC_Mode0 | CW_TMR3_VPWM_Out_HL)
.DEFINE CW_TMR3_POLP_1_VP_L_VN_H				(CW_TMR3_VOC_Mode1 | CW_TMR3_VPWM_Out_HL)
.DEFINE CW_TMR3_POLP_1_VP_H_VN_L				(CW_TMR3_VOC_Mode2 | CW_TMR3_VPWM_Out_HL)
.DEFINE CW_TMR3_POLP_1_VP_H_VN_H				(CW_TMR3_VOC_Mode3 | CW_TMR3_VPWM_Out_HL)

.DEFINE CW_TMR3_POLP_1_WP_L_WN_L				(CW_TMR3_WOC_Mode0 | CW_TMR3_WPWM_Out_HL)
.DEFINE CW_TMR3_POLP_1_WP_L_WN_H				(CW_TMR3_WOC_Mode1 | CW_TMR3_WPWM_Out_HL)
.DEFINE CW_TMR3_POLP_1_WP_H_WN_L				(CW_TMR3_WOC_Mode2 | CW_TMR3_WPWM_Out_HL)
.DEFINE CW_TMR3_POLP_1_WP_H_WN_H				(CW_TMR3_WOC_Mode3 | CW_TMR3_WPWM_Out_HL)

// POLP = 0 //
.DEFINE CW_TMR3_POLP_0_UP_PWM_UN_CPWM			(CW_TMR3_UOC_Mode0 | CW_TMR3_UPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_0_UP_H_UN_CPWM				(CW_TMR3_UOC_Mode1 | CW_TMR3_UPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_0_UP_CPWM_UN_H				(CW_TMR3_UOC_Mode2 | CW_TMR3_UPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_0_UP_CPWM_UN_PWM			(CW_TMR3_UOC_Mode3 | CW_TMR3_UPWM_Out_PWM)

.DEFINE CW_TMR3_POLP_0_VP_PWM_VN_CPWM			(CW_TMR3_VOC_Mode0 | CW_TMR3_VPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_0_VP_H_VN_CPWM				(CW_TMR3_VOC_Mode1 | CW_TMR3_VPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_0_VP_CPWM_VN_H				(CW_TMR3_VOC_Mode2 | CW_TMR3_VPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_0_VP_CPWM_VN_PWM			(CW_TMR3_VOC_Mode3 | CW_TMR3_VPWM_Out_PWM)

.DEFINE CW_TMR3_POLP_0_WP_PWM_WN_CPWM			(CW_TMR3_WOC_Mode0 | CW_TMR3_WPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_0_WP_H_WN_CPWM				(CW_TMR3_WOC_Mode1 | CW_TMR3_WPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_0_WP_CPWM_WN_H				(CW_TMR3_WOC_Mode2 | CW_TMR3_WPWM_Out_PWM)
.DEFINE CW_TMR3_POLP_0_WP_CPWM_WN_PWM			(CW_TMR3_WOC_Mode3 | CW_TMR3_WPWM_Out_PWM)

.DEFINE CW_TMR3_POLP_0_UP_H_UN_H				(CW_TMR3_UOC_Mode0 | CW_TMR3_UPWM_Out_HL)
.DEFINE CW_TMR3_POLP_0_UP_H_UN_L				(CW_TMR3_UOC_Mode1 | CW_TMR3_UPWM_Out_HL)
.DEFINE CW_TMR3_POLP_0_UP_L_UN_H				(CW_TMR3_UOC_Mode2 | CW_TMR3_UPWM_Out_HL)
.DEFINE CW_TMR3_POLP_0_UP_L_UN_L				(CW_TMR3_UOC_Mode3 | CW_TMR3_UPWM_Out_HL)

.DEFINE CW_TMR3_POLP_0_VP_H_VN_H				(CW_TMR3_VOC_Mode0 | CW_TMR3_VPWM_Out_HL)
.DEFINE CW_TMR3_POLP_0_VP_H_VN_L				(CW_TMR3_VOC_Mode1 | CW_TMR3_VPWM_Out_HL)
.DEFINE CW_TMR3_POLP_0_VP_L_VN_H				(CW_TMR3_VOC_Mode2 | CW_TMR3_VPWM_Out_HL)
.DEFINE CW_TMR3_POLP_0_VP_L_VN_L				(CW_TMR3_VOC_Mode3 | CW_TMR3_VPWM_Out_HL)

.DEFINE CW_TMR3_POLP_0_WP_H_WN_H				(CW_TMR3_WOC_Mode0 | CW_TMR3_WPWM_Out_HL)
.DEFINE CW_TMR3_POLP_0_WP_H_WN_L				(CW_TMR3_WOC_Mode1 | CW_TMR3_WPWM_Out_HL)
.DEFINE CW_TMR3_POLP_0_WP_L_WN_H				(CW_TMR3_WOC_Mode2 | CW_TMR3_WPWM_Out_HL)
.DEFINE CW_TMR3_POLP_0_WP_L_WN_L				(CW_TMR3_WOC_Mode3 | CW_TMR3_WPWM_Out_HL)


// P_TMR4_OutputCtrl register //
// word set //
.DEFINE CW_TMR4_UOC_Out1				0x0000	
.DEFINE CW_TMR4_UOC_Out2				0x0001
.DEFINE CW_TMR4_UOC_Out3				0x0002
.DEFINE CW_TMR4_UOC_Out4				0x0003
.DEFINE CW_TMR4_VOC_Out1				(0x0000 << 2)	
.DEFINE CW_TMR4_VOC_Out2				(0x0001 << 2)
.DEFINE CW_TMR4_VOC_Out3				(0x0002 << 2)
.DEFINE CW_TMR4_VOC_Out4				(0x0003 << 2)
.DEFINE CW_TMR4_WOC_Out1				(0x0000 << 4)	
.DEFINE CW_TMR4_WOC_Out2				(0x0001 << 4)
.DEFINE CW_TMR4_WOC_Out3				(0x0002 << 4)
.DEFINE CW_TMR4_WOC_Out4				(0x0003 << 4)
.DEFINE CW_TMR4_SYNC_NoSync				(0x0000 << 6)	
.DEFINE CW_TMR4_SYNC_PDR				(0x0001 << 6)	
.DEFINE CW_TMR4_SYNC_TGB				(0x0002 << 6)	
.DEFINE CW_TMR4_SYNC_TGC				(0x0003 << 6)	
.DEFINE CW_TMR4_UPWM_Out_HL				(0x0000 << 8)	
.DEFINE CW_TMR4_UPWM_Out_PWM			(0x0001 << 8)	
.DEFINE CW_TMR4_VPWM_Out_HL				(0x0000 << 9)	
.DEFINE CW_TMR4_VPWM_Out_PWM			(0x0001 << 9)	
.DEFINE CW_TMR4_WPWM_Out_HL				(0x0000 << 10)
.DEFINE CW_TMR4_WPWM_Out_PWM			(0x0001 << 10)
.DEFINE CW_TMR4_POLP_Active_Low			(0x0000 << 14)
.DEFINE CW_TMR4_POLP_Active_High		(0x0001 << 14)
.DEFINE CW_TMR4_DUTYMODE_UCom			(0x0000 << 15)
.DEFINE CW_TMR4_DUTYMODE_Independent	(0x0001 << 15)

// Bit set //
.DEFINE CB_TMR4_UOC0					0	
.DEFINE CB_TMR4_UOC1					1
.DEFINE CB_TMR4_VOC0					2	
.DEFINE CB_TMR4_VOC1					3
.DEFINE CB_TMR4_WOC0					4	
.DEFINE CB_TMR4_WOC1					5
.DEFINE CB_TMR4_SYNC0					6	
.DEFINE CB_TMR4_SYNC1					7		
.DEFINE CB_TMR4_UPWM					8		
.DEFINE CB_TMR4_VPWM					9	
.DEFINE CB_TMR4_WPWM					10
.DEFINE CB_TMR4_POLP_Active				14
.DEFINE CB_TMR4_DUTYMODE				15

// P_POS0_DectCtrl register //							//Timer 0 Position Detection Control Register
// word set //
.DEFINE CW_TMR0_PDCR_PDEN				(0x0001 << 7)
.DEFINE CW_TMR0_PDCR_SPLMOD_Mode1		(0x0000 << 12)
.DEFINE CW_TMR0_PDCR_SPLMOD_Mode2		(0x0001 << 12)
.DEFINE CW_TMR0_PDCR_SPLMOD_Mode3		(0x0002 << 12)
.DEFINE CW_TMR0_PDCR_SPLCK_FCKdiv4		(0x0000 << 14)
.DEFINE CW_TMR0_PDCR_SPLCK_FCKdiv8		(0x0001 << 14)
.DEFINE CW_TMR0_PDCR_SPLCK_FCKdiv16		(0x0002 << 14)
.DEFINE CW_TMR0_PDCR_SPLCK_FCKdiv32		(0x0003 << 14)

// Bit set //
.DEFINE CB_TMR0_PDCR_PDEN				7
.DEFINE CB_TMR0_PDCR_SPLMOD0			12
.DEFINE CB_TMR0_PDCR_SPLMOD1			13
.DEFINE CB_TMR0_PDCR_SPLCK0				14
.DEFINE CB_TMR0_PDCR_SPLCK1				15

// P_POS1_DectCtrl register //							//Timer 1 Position Detection Control Register
// word set //
.DEFINE CW_TMR1_PDCR_PDEN				(0x0001 << 7)
.DEFINE CW_TMR1_PDCR_SPLMOD_Mode1		(0x0000 << 12)
.DEFINE CW_TMR1_PDCR_SPLMOD_Mode2		(0x0001 << 12)
.DEFINE CW_TMR1_PDCR_SPLMOD_Mode3		(0x0002 << 12)
.DEFINE CW_TMR1_PDCR_SPLCK_FCKdiv4		(0x0000 << 14)
.DEFINE CW_TMR1_PDCR_SPLCK_FCKdiv8		(0x0001 << 14)
.DEFINE CW_TMR1_PDCR_SPLCK_FCKdiv16		(0x0002 << 14)
.DEFINE CW_TMR1_PDCR_SPLCK_FCKdiv32		(0x0003 << 14)

// Bit set //
.DEFINE CB_TMR1_PDCR_PDEN				7
.DEFINE CB_TMR1_PDCR_SPLMOD0			12
.DEFINE CB_TMR1_PDCR_SPLMOD1			13
.DEFINE CB_TMR1_PDCR_SPLCK0				14
.DEFINE CB_TMR1_PDCR_SPLCK1				15

// P_POS0_DectData register //							//Timer 0 Position Detection Register
// word set //
.DEFINE CW_TMR0_PDR_TIO0A				0x0001
.DEFINE CW_TMR0_PDR_TIO0B				(0x0001 << 1)
.DEFINE CW_TMR0_PDR_TIO0C				(0x0001 << 2)

// Bit set //
.DEFINE CB_TMR0_PDR_TIO0A				0
.DEFINE CB_TMR0_PDR_TIO0B				1
.DEFINE CB_TMR0_PDR_TIO0C				2

// P_POS1_DectData register //							//Timer 1 Position Detection Register
// word set //
.DEFINE CW_TMR1_PDR_TIO1A				0x0001
.DEFINE CW_TMR1_PDR_TIO1B				(0x0001 << 1)
.DEFINE CW_TMR1_PDR_TIO1C				(0x0001 << 2)

// Bit set //
.DEFINE CB_TMR1_PDR_TIO1A				0
.DEFINE CB_TMR1_PDR_TIO1B				1
.DEFINE CB_TMR1_PDR_TIO1C				2

// P_TMR3_DeadTime register //							//Timer 3 Dead Time Control Register
// word set //
.DEFINE CW_TMR3_DTCR_DTUE				(0x0001 << 12)
.DEFINE CW_TMR3_DTCR_DTVE				(0x0001 << 13)
.DEFINE CW_TMR3_DTCR_DTWE				(0x0001 << 14)

// Bit set //
.DEFINE CB_TMR3_DTCR_DTUE				12
.DEFINE CB_TMR3_DTCR_DTVE				13
.DEFINE CB_TMR3_DTCR_DTWE				14

// P_TMR4_DeadTime register //							//Timer 4 Dead Time Control Register
// word set //
.DEFINE CW_TMR4_DTCR_DTUE				(0x0001 << 12)
.DEFINE CW_TMR4_DTCR_DTVE				(0x0001 << 13)
.DEFINE CW_TMR4_DTCR_DTWE				(0x0001 << 14)

// Bit set //
.DEFINE CB_TMR4_DTCR_DTUE				12
.DEFINE CB_TMR4_DTCR_DTVE				13
.DEFINE CB_TMR4_DTCR_DTWE				14

// P_TPWM_Write register //								//Timer /PWM Module Write Enable Control Register
// word set //
.DEFINE CW_TWCR_TMR3WE					0x0001
.DEFINE CW_TWCR_TMR4WE					(0x0001 << 1)

// Bit set //
.DEFINE CB_TWCR_TMR3WE					0
.DEFINE CB_TWCR_TMR4WE					1

// P_Fault1_Ctrl register //							//Timer 3 Fault Input Control Register
// word set //
.DEFINE CW_TMR3_FCR_FTPINIF				(0x0001 << 5)
.DEFINE CW_TMR3_FCR_FTPINIE				(0x0001 << 6)
.DEFINE CW_TMR3_FCR_FTPINE				(0x0001 << 7)
.DEFINE CW_TMR3_FCR_OSF					(0x0001 << 12)
.DEFINE CW_TMR3_FCR_OCLS_Low			(0x0000 << 13)
.DEFINE CW_TMR3_FCR_OCLS_High			(0x0001 << 13)
.DEFINE CW_TMR3_FCR_OCIE				(0x0001 << 14)
.DEFINE CW_TMR3_FCR_OCE					(0x0001 << 15)

// Bit set //
.DEFINE CB_TMR3_FCR_FTPINIF				5
.DEFINE CB_TMR3_FCR_FTPINIE				6
.DEFINE CB_TMR3_FCR_FTPINE				7
.DEFINE CB_TMR3_FCR_OSF					12
.DEFINE CB_TMR3_FCR_OCLS				13
.DEFINE CB_TMR3_FCR_OCIE				14
.DEFINE CB_TMR3_FCR_OCE					15

// P_Fault2_Ctrl register //							//Timer 4 Fault Input Control Register
// word set //
.DEFINE CW_TMR4_FCR_FTPINIF				(0x0001 << 5)
.DEFINE CW_TMR4_FCR_FTPINIE				(0x0001 << 6)
.DEFINE CW_TMR4_FCR_FTPINE				(0x0001 << 7)
.DEFINE CW_TMR4_FCR_OSF					(0x0001 << 12)
.DEFINE CW_TMR4_FCR_OCLS_Low			(0x0000 << 13)
.DEFINE CW_TMR4_FCR_OCLS_High			(0x0001 << 13)
.DEFINE CW_TMR4_FCR_OCIE				(0x0001 << 14)
.DEFINE CW_TMR4_FCR_OCE					(0x0001 << 15)

// Bit set //
.DEFINE CB_TMR4_FCR_FTPINIF				5
.DEFINE CB_TMR4_FCR_FTPINIE				6
.DEFINE CB_TMR4_FCR_FTPINE				7
.DEFINE CB_TMR4_FCR_OSF					12
.DEFINE CB_TMR4_FCR_OCLS				13
.DEFINE CB_TMR4_FCR_OCIE				14
.DEFINE CB_TMR4_FCR_OCE					15

// P_OL1_Ctrl register //							//Timer 3 Overload Protecttion Control/Status Register
// word set //
.DEFINE CW_TMR3_OPR_RTOL				(0x0001 << 8)
.DEFINE CW_TMR3_OPR_RTPWM_Enable		(0x0001 << 9)
.DEFINE CW_TMR3_OPR_RTTMB_Enable		(0x0001 << 10)
.DEFINE CW_TMR3_OPR_OLST_UP				(0x0001 << 11)
.DEFINE CW_TMR3_OPR_OLMD_NoDis			(0x0000 << 12)
.DEFINE CW_TMR3_OPR_OLMD_AllDis			(0x0001 << 12)
.DEFINE CW_TMR3_OPR_OLMD_PWMDis			(0x0002 << 12)
.DEFINE CW_TMR3_OPR_OLMD_Dis			(0x0003 << 12)
.DEFINE CW_TMR3_OPR_CNTSP				(0x0001 << 14)
.DEFINE CW_TMR3_OPR_OLEN				(0x0001 << 15)

// Bit set //
.DEFINE CB_TMR3_OPR_RTOL				8
.DEFINE CB_TMR3_OPR_RTPWM_Enable		9
.DEFINE CB_TMR3_OPR_RTTMB_Enable		10
.DEFINE CB_TMR3_OPR_OLST_UP				11
.DEFINE CB_TMR3_OPR_OLMD0				12
.DEFINE CB_TMR3_OPR_OLMD1				13
.DEFINE CB_TMR3_OPR_CNTSP				14
.DEFINE CB_TMR3_OPR_OLEN				15

// P_OL2_Ctrl register //							//Timer 4 Overload Protecttion Control/Status Register
// word set //
.DEFINE CW_TMR4_OPR_RTOL				(0x0001 << 8)
.DEFINE CW_TMR4_OPR_RTPWM_Enable		(0x0001 << 9)
.DEFINE CW_TMR4_OPR_RTTMB_Enable		(0x0001 << 10)
.DEFINE CW_TMR4_OPR_OLST_UP				(0x0001 << 11)
.DEFINE CW_TMR4_OPR_OLMD_NoDis			(0x0000 << 12)
.DEFINE CW_TMR4_OPR_OLMD_AllDis			(0x0001 << 12)
.DEFINE CW_TMR4_OPR_OLMD_PWMDis			(0x0002 << 12)
.DEFINE CW_TMR4_OPR_OLMD_Dis			(0x0003 << 12)
.DEFINE CW_TMR4_OPR_CNTSP				(0x0001 << 14)
.DEFINE CW_TMR4_OPR_OLEN				(0x0001 << 15)

// Bit set //
.DEFINE CB_TMR4_OPR_RTOL				8
.DEFINE CB_TMR4_OPR_RTPWM_Enable		9
.DEFINE CB_TMR4_OPR_RTTMB_Enable		10
.DEFINE CB_TMR4_OPR_OLST_UP				11
.DEFINE CB_TMR4_OPR_OLMD0				12
.DEFINE CB_TMR4_OPR_OLMD1				13
.DEFINE CB_TMR4_OPR_CNTSP				14
.DEFINE CB_TMR4_OPR_OLEN				15

// P_TMR_LDOK register */								//Timer Load Ok Control Register
// word set */
.DEFINE CW_TMR_LDOK0					0x00A9  		//P_TMR3_TGRA-C ok to load bit
.DEFINE CW_TMR_LDOK1					0x00AA          //P_TMR4_TGRA-C ok to load bit



//=================================//
// C. 10-bit A/D Converter register//
//=================================//
// P_ADC_Setup register //
// word set //
.DEFINE CW_ADC_ASPEN					(0x0001 << 7)
.DEFINE CW_ADC_ADCEXTRG_Disable			(0x0000 << 8)
.DEFINE CW_ADC_ADCEXTRG_Enable			(0x0001 << 8)
.DEFINE CW_ADC_ADCFS_CPUCLKdiv8			(0x0000 << 9)
.DEFINE CW_ADC_ADCFS_CPUCLKdiv16		(0x0001 << 9)
.DEFINE CW_ADC_ADCFS_CPUCLKdiv32		(0x0002 << 9)
.DEFINE CW_ADC_ADCFS_CPUCLKdiv64		(0x0003 << 9)
.DEFINE CW_ADC_VRXEN_Internal			(0x0000 << 12)
.DEFINE CW_ADC_VRXEN_External			(0x0001 << 12)
.DEFINE CW_ADC_ADCEN					(0x0001 << 14)
.DEFINE CW_ADC_ADCCS_Select 			(0x0001 << 15)
.DEFINE CW_ADC_ADCCS_UnSelect 			(0x0000 << 15)

// Bit set //
.DEFINE CB_ADC_ASPEN					7
.DEFINE CB_ADC_ADCEXTRG					8
.DEFINE CB_ADC_ADCFS0					9
.DEFINE CB_ADC_ADCFS1					10
.DEFINE CB_ADC_VRXEN					12
.DEFINE CB_ADC_ADCEN					14
.DEFINE CB_ADC_ADCCS		 			15

// P_ADC_Ctrl register //
// word set //
.DEFINE CW_ADC_ADCCHS_Ch0				0x0000
.DEFINE CW_ADC_ADCCHS_Ch1				0x0001
.DEFINE CW_ADC_ADCCHS_Ch2				0x0002
.DEFINE CW_ADC_ADCCHS_Ch3				0x0003
.DEFINE CW_ADC_ADCCHS_Ch4				0x0004
.DEFINE CW_ADC_ADCCHS_Ch5				0x0005
.DEFINE CW_ADC_ADCCHS_Ch6				0x0006
.DEFINE CW_ADC_ADCCHS_Ch7				0x0007
.DEFINE CW_ADC_ADCSTR					(0x0001 << 6)
.DEFINE CW_ADC_ADCRDY					(0x0001 << 7)
.DEFINE CW_ADC_ADCIE					(0x0001 << 14)
.DEFINE CW_ADC_ADCIF					(0x0001 << 15)

// Bit set //
.DEFINE CB_ADC_ADCCHS0					0
.DEFINE CB_ADC_ADCCHS1					1
.DEFINE CB_ADC_ADCCHS2					2
.DEFINE CB_ADC_ADCSTR					6
.DEFINE CB_ADC_ADCRDY					7
.DEFINE CB_ADC_ADCIE					14
.DEFINE CB_ADC_ADCIF					15

// P_ADC_Channel register //
// word set //
.DEFINE CW_ADC_ADCCH0_Enable			0x0001
.DEFINE CW_ADC_ADCCH1_Enable			(0x0001 << 1)
.DEFINE CW_ADC_ADCCH2_Enable			(0x0001 << 2)
.DEFINE CW_ADC_ADCCH3_Enable			(0x0001 << 3)
.DEFINE CW_ADC_ADCCH4_Enable			(0x0001 << 4)
.DEFINE CW_ADC_ADCCH5_Enable			(0x0001 << 5)
.DEFINE CW_ADC_ADCCH6_Enable			(0x0001 << 6)
.DEFINE CW_ADC_ADCCH7_Enable			(0x0001 << 7)

// Bit set //
.DEFINE CB_ADC_ADCCH0_Enable			0
.DEFINE CB_ADC_ADCCH1_Enable			1
.DEFINE CB_ADC_ADCCH2_Enable			2
.DEFINE CB_ADC_ADCCH3_Enable			3
.DEFINE CB_ADC_ADCCH4_Enable			4
.DEFINE CB_ADC_ADCCH5_Enable			5
.DEFINE CB_ADC_ADCCH6_Enable			6
.DEFINE CB_ADC_ADCCH7_Enable			7


//=================================//
// D. SPI register	 		       //
//=================================//
// P_SPI_Ctrl register //
// word set //
.DEFINE CW_SPI_SPIFS_CPUCLKdiv4			0x0000
.DEFINE CW_SPI_SPIFS_CPUCLKdiv8			0x0001
.DEFINE CW_SPI_SPIFS_CPUCLKdiv16		0x0002
.DEFINE CW_SPI_SPIFS_CPUCLKdiv32		0x0003
.DEFINE CW_SPI_SPIFS_CPUCLKdiv64		0x0004
.DEFINE CW_SPI_SPIFS_CPUCLKdiv128		0x0005
.DEFINE CW_SPI_SPISMPS_Middle			(0x0000 << 3)
.DEFINE CW_SPI_SPISMPS_End				(0x0001 << 3)
.DEFINE CW_SPI_SPIPOL					(0x0001 << 4)
.DEFINE CW_SPI_SPIPHA					(0x0001 << 5)
.DEFINE CW_SPI_SPIMS_Master 			(0x0000 << 8)
.DEFINE CW_SPI_SPIMS_Slave  			(0x0001 << 8)
.DEFINE CW_SPI_SPISPCLK_NO	 			(0x0000 << 9)
.DEFINE CW_SPI_SPISPCLK_FCK	 			(0x0001 << 9)
.DEFINE CW_SPI_SPISPCLK_FCKdiv2			(0x0002 << 9)
.DEFINE CW_SPI_SPISPCLK_FCKdiv4			(0x0003 << 9)
.DEFINE CW_SPI_SPIRST					(0x0001 << 11)
.DEFINE CW_SPI_SPIE						(0x0001 << 15)

// Bit set //
.DEFINE CB_SPI_SPIFS0					0
.DEFINE CB_SPI_SPIFS1					1
.DEFINE CB_SPI_SPIFS2					2
.DEFINE CB_SPI_SPISMPS					3
.DEFINE CB_SPI_SPIPOL					4
.DEFINE CB_SPI_SPIPHA					5
.DEFINE CB_SPI_SPIMS		 			8
.DEFINE CB_SPI_SPISPCLK0	 			9
.DEFINE CB_SPI_SPISPCLK1	 			10
.DEFINE CB_SPI_SPIRST					11
.DEFINE CB_SPI_SPIE						15

// P_SPI_TxStatus register //
// word set //
.DEFINE CW_SPI_SPITXBF					(0x0001 << 13)
.DEFINE CW_SPI_SPITXIE					(0x0001 << 14)
.DEFINE CW_SPI_SPITXIF					(0x0001 << 15)

// Bit set //
.DEFINE CB_SPI_SPITXBF					13
.DEFINE CB_SPI_SPITXIE					14
.DEFINE CB_SPI_SPITXIF					15

// P_SPI_RxStatus register //
// word set //
.DEFINE CW_SPI_FERR						(0x0001 << 10)
.DEFINE CW_SPI_SPIRXIE					(0x0001 << 14)
.DEFINE CW_SPI_SPIRXIF					(0x0001 << 15)

// Bit set //
.DEFINE CB_SPI_FERR						10
.DEFINE CB_SPI_SPIRXIE					14
.DEFINE CB_SPI_SPIRXIF					15

// P_UART_Data register //
// word set //
.DEFINE CW_UARTData_FE				(0x0001 << 8)
.DEFINE CW_UARTData_PE				(0x0001 << 9)
.DEFINE CW_UARTData_OE				(0x0001 << 11)

// Bit set //
.DEFINE CB_UARTData_FE					8
.DEFINE CB_UARTData_PE					9
.DEFINE CB_UARTData_OE					11

// P_UART_RXStatus register //
// word set //
.DEFINE CW_UARTRx_FE				0x0001		
.DEFINE CW_UARTRx_PE				(0x0001 << 1)
.DEFINE CW_UARTRx_OE				(0x0001 << 3)
.DEFINE CW_UART_Clear_FE			0x0001
.DEFINE CW_UART_Clear_PE			(0x0001 << 1)
.DEFINE CW_UART_Clear_OE			(0x0001 << 3)

// Bit set //
.DEFINE CB_UARTRx_FE					0		
.DEFINE CB_UARTRx_PE					1
.DEFINE CB_UARTRx_OE					2

// P_UART_Ctrl register //
// word set //
.DEFINE CW_UART_PEN					(0x0001 << 1)
.DEFINE CW_UART_PSEL_Odd			(0x0000 << 2)
.DEFINE CW_UART_PSEL_Even			(0x0001 << 2)
.DEFINE CW_UART_SBSEL_1Stop			(0x0000 << 3)
.DEFINE CW_UART_SBSEL_2Stop			(0x0001 << 3)
.DEFINE CW_UART_RXCHSEL_No1			(0x0001<<9)			
.DEFINE CW_UART_RXCHSEL_No2			(0x0000<<9)			
.DEFINE CW_UART_TXCHSEL_No1			(0x0001<<10)		
.DEFINE CW_UART_TXCHSEL_No2			(0x0000<<10)		
.DEFINE CW_UART_Reset				(0x0001 << 11)
.DEFINE CW_UART_TXEN				(0x0001 << 12)
.DEFINE CW_UART_RXEN				(0x0001 << 13)
.DEFINE CW_UART_TXIE				(0x0001 << 14)
.DEFINE CW_UART_RXIE				(0x0001 << 15)

// Bit set //
.DEFINE CB_UART_PEN						1
.DEFINE CB_UART_PSEL					2
.DEFINE CB_UART_SBSEL					3
.DEFINE CB_UART_RXCHSEL					9					
.DEFINE CB_UART_TXCHSEL					10				
.DEFINE CB_UART_Reset					11
.DEFINE CB_UART_TXEN					12
.DEFINE CB_UART_RXEN					13
.DEFINE CB_UART_TXIE					14
.DEFINE CB_UART_RXIE					15

// P_UART_BaudRate register //
// word set //
.DEFINE CW_UARTBUD_1200					0xFB1E			//1200 bps Set
.DEFINE CW_UARTBUD_2400					0xFD8F			//2400 bps Set
.DEFINE CW_UARTBUD_4800					0xFEC8			//4800 bps Set
.DEFINE CW_UARTBUDR_9600				0xFF64			//9600 bps Set	
.DEFINE CW_UARTBUD_19200				0xFFB2			//19200 bps Set
.DEFINE CW_UARTBUD_57600				0xFFE6			//57600 bps Set
.DEFINE CW_UARTBUD_115200				0xFFF3			//115200 bps Set


// P_UART_Status register //
// word set //
.DEFINE CW_UART_Ready					(0x0000 << 3)
.DEFINE CW_UART_BY						(0x0001 << 3)
.DEFINE CW_UART_RXBF					(0x0001 << 6)
.DEFINE CW_UART_TXIF					(0x0001 << 14)
.DEFINE CW_UART_RXIF					(0x0001 << 15)

// Bit set //
.DEFINE CB_UART_BY						3
.DEFINE CB_UART_RXBF					6
.DEFINE CB_UART_TXIF					14
.DEFINE CB_UART_RXIF					15

// P_INT_Status register //
// word set //
.DEFINE CW_INT_FTIF						0x0001
.DEFINE CW_INT_OSCSF					(0x0001 << 1)
.DEFINE CW_INT_CMTIF					(0x0001 << 4)
.DEFINE CW_INT_PDC0IF					(0x0001 << 5)
.DEFINE CW_INT_PDC1IF					(0x0001 << 6)
.DEFINE CW_INT_TPM2IF					(0x0001 << 7)
.DEFINE CW_INT_MCP3IF					(0x0001 << 8)
.DEFINE CW_INT_MCP4IF					(0x0001 << 9)
.DEFINE CW_INT_ADCIF					(0x0001 << 10)
.DEFINE CW_INT_EXTIF					(0x0001 << 11)
.DEFINE CW_INT_SPIIF					(0x0001 << 13)
.DEFINE CW_INT_UARTIF					(0x0001 << 14)
.DEFINE CW_INT_KEYIF					(0x0001 << 15)

// Bit set //
.DEFINE CB_INT_FTIF						0
.DEFINE CB_INT_OSCSF					1
.DEFINE CB_INT_CMTIF					4
.DEFINE CB_INT_PDC0IF					5
.DEFINE CB_INT_PDC1IF					6
.DEFINE CB_INT_TPM2IF					7
.DEFINE CB_INT_MCP3IF					8
.DEFINE CB_INT_MCP4IF					9
.DEFINE CB_INT_ADCIF					10
.DEFINE CB_INT_EXTIF					11
.DEFINE CB_INT_SPIIF					13
.DEFINE CB_INT_UARTIF					14
.DEFINE CB_INT_KEYIF					15

// P_INT_Priority register //
// word set //
.DEFINE CW_INT_FTIP						0x0001
.DEFINE CW_INT_OSCIP					(0x0001 << 1)
.DEFINE CW_INT_CMTIP					(0x0001 << 4)
.DEFINE CW_INT_PDC0IP					(0x0001 << 5)
.DEFINE CW_INT_PDC1IP					(0x0001 << 6)
.DEFINE CW_INT_TPM2IP					(0x0001 << 7)
.DEFINE CW_INT_MCP3IP					(0x0001 << 8)
.DEFINE CW_INT_MCP4IP					(0x0001 << 9)
.DEFINE CW_INT_ADCIP					(0x0001 << 10)
.DEFINE CW_INT_EXTIP					(0x0001 << 11)
.DEFINE CW_INT_SPIIP					(0x0001 << 13)
.DEFINE CW_INT_UARTIP					(0x0001 << 14)
.DEFINE CW_INT_KEYIP					(0x0001 << 15)

// Bit set //
.DEFINE CB_INT_FTIP						0
.DEFINE CB_INT_OSCIP					1
.DEFINE CB_INT_CMTIP					4
.DEFINE CB_INT_PDC0IP					5
.DEFINE CB_INT_PDC1IP					6
.DEFINE CB_INT_TPM2IP					7
.DEFINE CB_INT_MCP3IP					8
.DEFINE CB_INT_MCP4IP					9
.DEFINE CB_INT_ADCIP					10
.DEFINE CB_INT_EXTIP					11
.DEFINE CB_INT_SPIIP					13
.DEFINE CB_INT_UARTIP					14
.DEFINE CB_INT_KEYIP					15

// P_MisINT_Ctrl register //
// word set //
.DEFINE CW_INT_EXT0IE					(0x0001 << 11)
.DEFINE CW_INT_EXT1IE					(0x0001 << 12)
.DEFINE CW_INT_EXT0MS					(0x0001 << 13)
.DEFINE CW_INT_EXT1MS					(0x0001 << 14)
.DEFINE CW_INT_KEYIE					(0x0001 << 15)

// Bit set //
.DEFINE CB_INT_EXT0IE					11
.DEFINE CB_INT_EXT1IE					12
.DEFINE CB_INT_EXT0MS					13
.DEFINE CB_INT_EXT1MS					14
.DEFINE CB_INT_KEYIE					15

//=================================//
// H. Compare Match Time Register  //
//=================================//
// P_CMT_Start register //
// word set //
.DEFINE CW_CMT0_Start					0x0001
.DEFINE CW_CMT1_Start					0x0002

// Bit set //
.DEFINE CB_CMT0_Start					0
.DEFINE CB_CMT1_Start					1

// P_CMT_Ctrl register //
// word set //
.DEFINE CW_CKA_FCK_1					0x0000		//CKA = FCK / 1		
.DEFINE CW_CKA_FCK_2					0x0001		//CKA = FCK / 2		
.DEFINE CW_CKA_FCK_4					0x0002		//CKA = FCK / 4		
.DEFINE CW_CKA_FCK_8					0x0003		//CKA = FCK / 8		
.DEFINE CW_CKA_FCK_16					0x0004		//CKA = FCK / 16		
.DEFINE CW_CKA_FCK_64					0x0005		//CKA = FCK / 64		
.DEFINE CW_CKA_FCK_256					0x0006		//CKA = FCK / 256		
.DEFINE CW_CKA_FCK_1024					0x0007		//CKA = FCK / 1024
.DEFINE CW_CMT0_INT_EN					0x0040		//CMT0 compare match interrupt enable
.DEFINE CW_CLEAR_CM0IF					0x0080		
.DEFINE CW_CKB_FCK_1					0x0000		//CKA = FCK / 1		
.DEFINE CW_CKB_FCK_2					0x0100		//CKA = FCK / 2		
.DEFINE CW_CKB_FCK_4					0x0200		//CKA = FCK / 4		
.DEFINE CW_CKB_FCK_8					0x0300		//CKA = FCK / 8		
.DEFINE CW_CKB_FCK_16					0x0400		//CKA = FCK / 16		
.DEFINE CW_CKB_FCK_64					0x0500		//CKA = FCK / 64		
.DEFINE CW_CKB_FCK_256					0x0600		//CKA = FCK / 256		
.DEFINE CW_CKB_FCK_1024					0x0700		//CKA = FCK / 1024
.DEFINE CW_CMT1_INT_EN					0x4000		//CMT1 compare match interrupt enable
.DEFINE CW_CLEAR_CM1IF					0x8000		

// Bit set //
.DEFINE CB_CKA_FCK0						0	
.DEFINE CB_CKA_FCK1						1	
.DEFINE CB_CKA_FCK2						2
.DEFINE CB_CMT0_INT_EN					2
.DEFINE CB_CLEAR_CM0IF					3		
.DEFINE CB_CKB_FCK0						8
.DEFINE CB_CKB_FCK1						9
.DEFINE CB_CKB_FCK2						10
.DEFINE CB_CMT1_INT_EN					14
.DEFINE CB_CLEAR_CM1IF					15

//=================================//
// H. Time Base Register  		   //
//=================================//
// P_BZO_Ctrl register //
// word set //
.DEFINE CW_BZOCK_FCK_16384				0x0000
.DEFINE CW_BZOCK_FCK_8192				0x0001
.DEFINE CW_BZOCK_FCK_4096				0x0002
.DEFINE CW_BZOCK_FCK_2048				0x0003
.DEFINE CW_BZO_EN						0x8000

// Bit set //
.DEFINE CB_BZOCK_FCK0					0
.DEFINE CB_BZOCK_FCK1					1
.DEFINE CB_BZO_EN						15




