/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_main.c											     */	
/* Description : main entry function of C programming					     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v2.0A or later version				         */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */
/* Environemnts of this demo:												 */								
/* HW : SPMC75F2413A EVM board V1.2											 */
/* SW : u'nSP IDE V2.0A, Windows XP 										 */
/* ========================================================================= */

#include "Spmc75f2413a.h"
#include "Spmc_typedef.h"
#include "unspmacro.h"

UInt16 counter = 0;

int main(void)
{
	Disable_FIQ_IRQ();

	P_IOD_Dir->W = 0x00FF;					// PD[7:0] = LED port
	P_IOD_Attrib->W = 0xFFFF;
	
	P_IOB_Dir->B.bit12 = 1;					// PB12 = RCLK
	P_SPI_Ctrl->W = 0x8020;

	P_CMT_Ctrl->B.CKA = CB_CKA_FCK_1024;
	P_CMT0_TPR->W = 23436;					// interrupt frequency = 1.0 Hz
	P_CMT_Ctrl->B.CM0IE = CB_CMT0_INT_EN;
	P_CMT_Start->B.ST0 = CB_CMT0_Start;     
	
	INT_IRQ();					     		 /* enable IRQ channel interrupt */
	
	for(;;)
	{
		Display_Number(counter);
	}
	
	return (1);
} /* main() */

/*****************************************************************************/
/* IRQ7() : IRQ7 interrup service routine, possibile int. sources are		 */
/* 			KEYIF, ADCIF, CM0IF, CM1IF										 */
/*****************************************************************************/
void IRQ7(void)	__attribute__ ((ISR));
void IRQ7(void)
{
	if(P_CMT_Ctrl->B.CM0IF)
	{
		P_CMT_Ctrl->B.CM0IF = 1;

		P_IOD_Data->W ^= 0x00FF;

		if(++counter > 9999)
			counter = 0;
	}	
} /* IRQ7() */	
