/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_main.c											     */	
/* Description : main entry function of C programming					     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v2.0A or later version				         */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */
/* Environemnts of this demo:												 */								
/* HW : SPMC75F2413A EVM board V1.2											 */
/* SW : u'nSP IDE V2.0A, Windows XP 										 */
/* ========================================================================= */

#include "Spmc75f2413a.h"
#include "Spmc_typedef.h"
#include "unspmacro.h"
#include "Spmc75_iic_ext.h"

UInt16 addr = 0;
UInt16 byte_cnt = 0;

int main(void)
{
	Disable_FIQ_IRQ();

	MC75F_IIC_Init();

	P_IOB_Dir->B.bit12 = 1;								/* use IOB12 = RCLK */
	P_SPI_Ctrl->W = 0x8024;
	P_SPI_TxStatus->B.SPITXIE = 1;			     /* enable SPITXD interrupt */
	byte_cnt = 0;
	
	INT_IRQ();
	
	P_SPI_TxBuf->W = 0x0000;

	while(1)
	{
		for(addr = 0; addr < 512; addr++)
		{
			HEXtoBCD(addr);
	
			// write 0x55
			MC75F_IIC_Write_B(addr, 0x55);
			if(MC75F_IIC_Read_B(addr) != 0x55) break;
		
			// write 0xAA
			MC75F_IIC_Write_B(addr, 0xAA);
			if(MC75F_IIC_Read_B(addr) != 0xAA) break;
		}
		
		while(1);
	}

} /* main() */