/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_serial.h										     */	
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v2.0A or later version				         */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */

#ifndef __SPMC75_SERIAL_INT_H
#define __SPMC75_SERIAL_INT_H

/*****************************************************************************/
/* 			Seven segments display of ASCII to Segment					     */	
/*                                                             a		     */	
/*                                                           ------          */
/*                                                        f |      | b       */
/*                                                          |  g   |         */
/* Note: The segments are mapped as follows:                 ------          */
/*                                                        e |      | c       */
/*        dp    g    f    e    d    c    b    a             |  d   |         */
/*        --   --   --   --   --   --   --   --              ------  . dp    */
/*        B7   B6   B5   B4   B3   B2   B1   B0							     */	
/* if the specified bit = 0 --> active the led							     */
/* 						= 1 --> inactive the led						     */
/*****************************************************************************/
#define Char_0			0xC0						   			      /* '0' */
#define Char_1			0xF9						 			      /* '1' */
#define Char_2			0xA4						 			      /* '2' */
#define Char_3			0xB0						 			      /* '3' */
#define Char_4			0x99						 			      /* '4' */
#define Char_5			0x92						 			      /* '5' */
#define Char_6			0x82						 			      /* '6' */
#define Char_7			0xD8						 		          /* '7' */
#define Char_8			0x80						 			      /* '8' */
#define Char_9			0x90						 			      /* '9' */
#define Char_A			0x88					 			   	      /* 'A' */
#define Char_B			0x83						 			      /* 'b' */
#define Char_C			0xC6						 			      /* 'C' */
#define Char_D			0xA1						 			      /* 'd' */
#define Char_E			0x86						 			      /* 'E' */
#define Char_F			0x8E						 			      /* 'F' */

#endif /* #ifndef __SPMC75_SERIAL_INT_H */