/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_main.c											     */	
/* Description : main entry function of C programming					     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v2.0A or later version				         */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */
/* Environemnts of this demo:												 */								
/* HW : SPMC75F2413A EVM board V1.2											 */
/* SW : u'nSP IDE V2.0, Windows XP 										     */
/* ========================================================================= */

#include "Spmc75f2413a.h"
#include "unspmacro.h"

void F_Delay(unsigned int uiTimeMs);

int main(void)
{
	Disable_FIQ_IRQ();
	
	/* Set IOD[7:0] Configuration */
	P_IOD_Attrib->W = 0x00FF;
	P_IOD_Dir->W = 0x00FF;
	P_IOD_Data->W =	0x0000;
	

	for(;;)
	{
 		P_IOD_Buffer->B.bit0 ^=	1;		                 /* toggle IOD0 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOD_Buffer->B.bit1 ^=	1;		                 /* toggle IOD1 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOD_Buffer->B.bit2 ^=	1;		                 /* toggle IOD2 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOD_Buffer->B.bit3 ^=	1;		                 /* toggle IOD3 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOD_Buffer->B.bit4 ^=	1;		                 /* toggle IOD4 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOD_Buffer->B.bit5 ^=	1;		                 /* toggle IOD5 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOD_Buffer->B.bit6 ^= 1;			             /* toggle IOD6 */
 		F_Delay(250);									 /* Delay 250ms */

 		P_IOD_Buffer->B.bit7 ^= 1;			             /* toggle IOD7 */
 		F_Delay(250);									 /* Delay 250ms */

	}

	return (1);
} /* main() */

//=============================================================
// F_Delay() : delay x(uiTime) ms
//=============================================================
void F_Delay(unsigned int uiTimeMs)
{
	unsigned int i,j;
    for(i = 0; i < uiTimeMs; i++)
    	for(j = 0; j < 0x120; j++)
    	   P_WatchDog_Clr->W = CW_WatchDog_Clear;
} /* F_delay() */
