/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_main.c											     */	
/* Description : main entry function of C programming					     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v2.0A or later version				         */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */
/* Environemnts of this demo:												 */								
/* HW : SPMC75F2413A EVM Demo Board V1.2									 */
/* SW : u'nSP IDE V2.0, Windows XP 										     */
/* ========================================================================= */

#include "spmc75f2413a.h"
#include "spmc_typedef.h"
#include "unspmacro.h"

extern void Init_MCP3_Timer(void);

int main(void)
{
	Disable_FIQ_IRQ();

	Init_MCP3_Timer(); 								 
	P_TMR_Output->W = 0x003F;			// enable MCP3 timer PWM output
	
	// use CMT timer to simulate hall sensor timing
	P_CMT_Ctrl->B.CKA = CB_CKA_FCK_4;
	P_CMT0_TPR->W = 12000;					// interrupt frequency = 500 Hz
	P_CMT_Ctrl->B.CM0IE = CB_CMT0_INT_EN;
	P_CMT_Start->B.ST0 = CB_CMT0_Start;     
	

	INT_IRQ();					     	// enable IRQ channel interrupt
	
	P_TMR_Start->W =  CW_TMR_TMR3ST_Start;					   /* start TMR3 */

	while(1);

	return (1);	
} /* main() */

