// ========================================================================= 
// The information contained herein is the exclusive property of             
// Sunplus Technology Co. And shall not be distributed, reproduced,          
// or disclosed in whole in part without prior written permission.           
//             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     
//                    ALL RIGHTS RESERVED                                    
// The entire notice above must be reproduced on all authorized copies.      
// ========================================================================= 
// File Name   : Spmc75_isr.asm										     	
// Description : ISR of assembly					     
// Processor   : SPMC75X series											     	
// Author      : Chih ming Huang										     
// Tools	   : u'nSP IDE tools v2.0A or later version				     
// Version     : 1.00 													     	
// Security    : Confidential Proprietary 							         
// E-Mail      : MaxHuang@sunplus.com.tw								     
// ========================================================================= 
	.include 	spmc75_regs.inc			// for SPMC75F2413A body -> spmc75_regs.inc
										//                       -> spmc75f2413a.inc
										// for SPMC75F2313A body -> spmc75f2313a.inc

//
	.public		_BREAK, _FIQ
	.public		_IRQ0,_IRQ1, _IRQ2, _IRQ3, _IRQ4,_IRQ5, _IRQ6, _IRQ7
	
	.TEXT

//****************************************************************************/
// BREAK() : software break interrupt										 */ 
//****************************************************************************/
_BREAK:
	push	R1, R5 to [SP];
	//
	POP		R1, R5 from [SP];
	RETI

//****************************************************************************/
// FIQ() : Fast interrupt ISR												 */
//****************************************************************************/
_FIQ:
	push	R1, R5 to [SP];
	//
	POP		R1, R5 from [SP];
	RETI

//****************************************************************************/
// IRQ0() : IRQ0 interrup service routine, possibile int. sources are		 */
// 			FTPINIF, OLIF, OSF, OSCSF										 */
//****************************************************************************/
_IRQ0:
	push	R1, R5 to [SP];
	//
	POP		R1, R5 from [SP];
	RETI
	
//****************************************************************************/
// IRQ1() : IRQ1 interrup service routine, possibile int. sources are		 */
// 			PDC0IF															 */
//****************************************************************************/
_IRQ1:
	push	R1, R5 to [SP];
	//
	POP		R1, R5 from [SP];
	RETI
		
//****************************************************************************/
// IRQ2() : IRQ2 interrup service routine, possibile int. sources are		 */
// 			PDC1IF															 */
//****************************************************************************/
_IRQ2:
	push	R1, R5 to [SP];
	//
	POP		R1, R5 from [SP];
	RETI

//****************************************************************************/
// IRQ3() : IRQ3 interrup service routine, possibile int. sources are		 */
//			MCP3IF, MCP4IF													 */
//****************************************************************************/
_IRQ3:
	push	R1, R5 to [SP];
	//
	POP		R1, R5 from [SP];
	RETI

//****************************************************************************/
// IRQ4() : IRQ4 interrup service routine, possibile int. sources are		 */
// 			TPM2IF															 */
//****************************************************************************/
_IRQ4:
	push	R1, R5 to [SP];
	//
	POP		R1, R5 from [SP];
	RETI

//****************************************************************************/
// IRQ5() : IRQ5 interrup service routine, possibile int. sources are		 */
// 			EX0IF, EX1IF													 */
//****************************************************************************/
_IRQ5:
	push	R1, R5 to [SP];
	//
	POP		R1, R5 from [SP];
	RETI

//****************************************************************************/
// IRQ6() : IRQ6 interrup service routine, possibile int. sources are		 */
// 			RXIF, TXIF, SPIRXIF, SPITXIF									 */
//****************************************************************************/
_IRQ6:
	push	R1, R5 to [SP];
	//
	POP		R1, R5 from [SP];
	RETI

//****************************************************************************/
// IRQ7() : IRQ7 interrup service routine, possibile int. sources are		 */
// 			KEYIF, ADCIF, CM0IF, CM1IF										 */
//****************************************************************************/
_IRQ7:
	push	R1, R5 to [SP];
	//
	POP		R1, R5 from [SP];
	RETI
		
	.END