/* ========================================================================= */
/* The information contained herein is the exclusive property of             */
/* Sunplus Technology Co. And shall not be distributed, reproduced,          */
/* or disclosed in whole in part without prior written permission.           */
/*             (C) COPYRIGHT 2001 SUNPLUS TECHNOLOGY CO.                     */
/*                    ALL RIGHTS RESERVED                                    */
/* The entire notice above must be reproduced on all authorized copies.      */
/* ========================================================================= */
/* File Name   : Spmc75_main.c											     */	
/* Description : main entry function of C programming					     */
/* Processor   : SPMC75X series											     */	
/* Author      : Chih ming Huang										     */
/* Tools	   : u'nSP IDE tools v2.0A or later version				         */
/* Version     : 1.00 													     */	
/* Security    : Confidential Proprietary 							         */
/* E-Mail      : MaxHuang@sunplus.com.tw								     */
/* ========================================================================= */
/* Environemnts of this demo:												 */								
/* HW : SPMC75F2413A EVM board V1.2											 */
/* SW : u'nSP IDE V2.0A, Windows XP 										 */
/* ========================================================================= */

#include "Spmc75f2413a.h"
#include "unspmacro.h"
#include "Spmc75_dmc_uart_ext.h"
#include "Spmc_dmc_api_ext.h"
#include "ParamDef.h"

int main(void)
{
	Disable_FIQ_IRQ();
//
	MC75_DMC_UART_Setup(57600, UART_CHANNEL);		
						// baud-rate = 57600 
						// UART_CHANNEL_1 -> UART channel is IOB12/IOB13
						// UART_CHANNEL_2 -> UART channel is IOC0/IOC1
//	
	
	INT_IRQ();					     /* enable IRQ channel interrupt */

	for(;;)
	{
		MC75_DMC_UART_Service();	// must be called frequently
		
		// continuous send data to PC via UART port
		SPMC_DMC_Save_Aux(0, 1);	// R0 = 1
		SPMC_DMC_Save_Aux(1, 2);	// R1 = 2
		SPMC_DMC_Save_Aux(2, 3);	// R2 = 3
		SPMC_DMC_Save_Aux(3, 4);	// R3 = 4
		SPMC_DMC_Save_Aux(4, 5);	// R4 = 5
		SPMC_DMC_Save_Aux(5, 6);	// R5 = 6
		SPMC_DMC_Save_Aux(6, 7);	// R6 = 7
		SPMC_DMC_Save_Aux(7, 8);	// R7 = 8
	}

	return (1);
} /* main() */

/*****************************************************************************/
/* IRQ6() : IRQ6 interrup service routine, possibile int. sources are		 */
/* 			RXIF, TXIF, SPIRXIF, SPITXIF									 */
/*****************************************************************************/
void IRQ6(void)	__attribute__ ((ISR));
void IRQ6(void)
{
	if(P_UART_Status->B.RXIF && P_UART_Ctrl->B.RXIE)
	{
		MC75_DMC_RcvStream();
	}	
} /* IRQ6() */