//main.c

#include "ParamDef.h"
#include "unspmacro.h"
#include "SPMC75F2413A.h"
#define Key_Source		1 << Key_Source_Bit

int main()
{
	Disable_FIQ_IRQ();
	
	/* IO Init */
	P_IOA_SPE->W = 0x0000;	
	P_IOA_Dir->W = 0x0000;
	P_IOA_Attrib->W = 0x0000;
	P_IOA_Data->W = 0x0000;	
	P_IOA_KCER->W = Key_Source;				// Key change enable
	
	P_IOD_Attrib->W = 0x00ff;
	P_IOD_Data->W = 0x0000;
	P_IOD_Dir->W = 0x00ff;
	
	P_MisINT_Ctrl->B.KEYIE = 1;				// Key change interrupt enable
	
	INT_IRQ();
	
	P_IOA_Latch->W = P_IOA_Latch->W;		// Read P_IOA_Latch to latch the state of key source

	while(1);
	
	return 1;
}

void IRQ7(void)	__attribute__((ISR));
void IRQ7(void)
{
	if(P_INT_Status->B.KEYIF)
	{
		P_INT_Status->B.KEYIF = 1;			// Clear interrrupt flag
		
		P_IOD_Data->W ^= 0x00ff;
	
		P_IOA_Latch->W = P_IOA_Latch->W;	// latch for the next key change
	}
}