//isr.c
#include "SPMC75F2413A.h"
#include "ParamDef.h"
#include "TimerPeriod.h"
#define Sin_Freq	60				// 60Hz sine PWM is generated


extern unsigned int F_Mul_Q16(unsigned int, unsigned int); // Q16 format multiplication
extern int		SinTab[1024];		// 1024-point sine table			
unsigned int	Table_idx_a = 0;	// Sine table index of phase A 
unsigned int	Table_idx_b = 683;	// Sine table index of phase B
unsigned int	Table_idx_c = 341;	// Sine table index of phase C
const unsigned int	Table_idx_inc = 1024/(Carrier_Freq*1000/Sin_Freq);	// Sine table index increasement	
const unsigned int 	C_Timer_Prd = Timer_Period;		// The value is to store in period register


void BREAK(void) __attribute__ ((ISR));

void FIQ(void) __attribute__ ((ISR));

void IRQ0(void) __attribute__ ((ISR));

void IRQ1(void) __attribute__ ((ISR));

void IRQ2(void) __attribute__ ((ISR));

void IRQ3(void) __attribute__ ((ISR));

void IRQ4(void) __attribute__ ((ISR));

void IRQ5(void) __attribute__ ((ISR));

void IRQ6(void) __attribute__ ((ISR));

void IRQ7(void) __attribute__ ((ISR));




void BREAK(void)
{
	//add your code here

}

void FIQ(void)
{
	if(P_INT_Status->B.FTIF)
	{
		if(P_Fault2_Ctrl->B.FTPINIF)
		{
			P_Fault2_Release->W = 0x55aa;
			P_Fault2_Release->W = 0xaa55;		// Clear fault input pin 2 flag
			P_Fault2_Ctrl->B.FTPINE = 1;		// Re-enable fault input pin 2	
		}	
	}

}


void IRQ0(void)
{
	if(P_INT_Status->B.FTIF)
	{
		if(P_Fault2_Ctrl->B.FTPINIF)
		{
			P_Fault2_Release->W = 0x55aa;
			P_Fault2_Release->W = 0xaa55;		// Clear fault input pin 2 flag
			P_Fault2_Ctrl->B.FTPINE = 1;		// Re-enalbe fault input pin 2	
		}	
	}
}

void IRQ1(void)
{
	//add your code here

}

void IRQ2(void)
{
	//add your code here

}

void IRQ3(void)
{
	if(P_TMR4_Status->B.TPRIF)
	{
		P_TMR4_Status->B.TPRIF = 1;				// Clear interrupt flag
		
		if(P_OL2_Ctrl->B.OLST)					// Overload protection occured?
		{
			// Record the over-loading event history, then execute the necessary tasks.
		}
		
		Table_idx_a += Table_idx_inc;
		Table_idx_b += Table_idx_inc;
		Table_idx_c += Table_idx_inc;
	
		if(Table_idx_a >= 1024)
			Table_idx_a -= 1024;
				
		else if(Table_idx_b >= 1024)
			Table_idx_b -= 1024;
				
		else if(Table_idx_c >= 1024)
			Table_idx_c -= 1024;
		
		P_TMR4_TGRA->W = F_Mul_Q16(C_Timer_Prd, (SinTab[Table_idx_a] + 32768));
		P_TMR4_TGRB->W = F_Mul_Q16(C_Timer_Prd, (SinTab[Table_idx_b] + 32768));
		P_TMR4_TGRC->W = F_Mul_Q16(C_Timer_Prd, (SinTab[Table_idx_c] + 32768));

		P_TMR_LDOK->W = CW_TMR_LDOK1;		
	}		

}

void IRQ4(void)
{
	//add your code here

}

void IRQ5(void)
{
	//add your code here

}

void IRQ6(void)
{
	//add your code here

}

void IRQ7(void)
{
	//add your code here

}
