//main.c

#include "ParamDef.h"
#include "TimerPeriod.h"
#include "unspmacro.h"
#include "SPMC75F2413A.h"

int main()
 {
	Disable_FIQ_IRQ();
	
	/* Init MCP4 */
	P_IOC_SPE->W = 0xfc00;
	P_TPWM_Write->W = CW_TWCR_TMR4WE;
	P_TMR4_Ctrl->W = CW_TMR4_MODE_PWM_Edge + Timer_Prescalar + CW_TMR4_CCLS_TPR;
	P_TMR4_IOCtrl->W = 0x0111;				// PWM initial output 0, output 1 at compare match
	P_TMR4_INT->W = CW_TMR4_TPRIE_Enable;	
	P_TMR_Output->W = 0x3f00;				// Enable Timer4 PWM outputs
	P_TMR4_OutputCtrl->W = CW_TMR4_DUTYMODE_Independent + PWM_Polarity;
	P_TMR4_OutputCtrl->W += 0x073f;			// Complementary PWM
	P_TMR4_DeadTime->W = CW_TMR4_DTCR_DTUE + CW_TMR4_DTCR_DTVE + CW_TMR4_DTCR_DTWE + Dead_Time_Unit;
	P_TMR4_TPR->W = Timer_Period;
	
	/* Init fault protection */
	P_IOC_SPE->B.FTIN2EN = Fault_Protect;
	P_Fault2_Ctrl->B.FTPINE = Fault_Protect;
	P_Fault2_Ctrl->B.FTPINIE = Fault_Protect;	// Enable or diable fault input protection
	P_INT_Priority->B.FTIP = IRQ0_FIQ_Sel;
	
	/* Init overload protection */
	P_IOC_SPE->B.OL2EN = OL_Protect;
	P_OL2_Ctrl->B.OLEN = OL_Protect;			// Enable or disable overload protection
	P_OL2_Ctrl->B.OLMD = 2;						// Disable PMW output when OL is occured
	P_OL2_Ctrl->B.OLCNT = OL_Cnt;	
	P_OL2_Ctrl->B.RTOL = 1;						// Automatically return from overload protection state if OL2 pin
												//  is brought to high level		
	P_TMR_Start->W = CW_TMR_TMR4ST_Start;	// Start Timer 4
	  

	INT_FIQ_IRQ();
	
	while(1);
	
	return 1;
}

