//main.c

#include "ParamDef.h"
#include "unspmacro.h"
#include "SPMC75F2413A.h"

unsigned int	TGRA_temp = 0;
unsigned int	Pos_temp = 0xdead;

int main()
{
	Disable_FIQ_IRQ();
	
	/* Init PDC1 */
	P_TMR1_Ctrl->B.CCLS = PDR_Times;
	P_TMR1_IOCtrl->W = CW_TMR1_IOAMOD_Capture_PDR + CW_TMR1_IOBMOD_Capture_PDR + CW_TMR1_IOCMOD_Capture_PDR; 
	P_POS1_DectCtrl->B.SPLMOD = Pos_Sample_Mode;
	P_POS1_DectCtrl->B.SPLCNT = Pos_Sample_Cnt << 8;
	P_POS1_DectCtrl->B.SPDLY = Pos_Sample_Dly;		
	P_POS1_DectCtrl->B.PDEN = CB_TMR1_PDCR_PDEN;	// Position detection enable
	P_TMR1_INT->B.PDCIE = CB_TMR1_PDCIE_Enable;		// Enable position detection change interrupt
	
	/* Init MCP4 */
	P_IOC_SPE->W = 0xfc00;
	P_TPWM_Write->W = CW_TWCR_TMR4WE;
	P_TMR4_Ctrl->W = CW_TMR4_MODE_PWM_Edge + CB_TMR4_TMRPS_FCKdiv1 + CW_TMR4_CCLS_TPR;
	P_TMR4_IOCtrl->W = 0x0111;
	P_TMR4_OutputCtrl->W = 0x4209;					// PWM active high; VP PWM and UN high
	P_TMR4_TPR->W = 2399;							// 10kHz PWM
		
	P_TMR_Start->W = CW_TMR_TMR1ST_Start + CW_TMR_TMR4ST_Start;		// Start TMR1 and TMR4
	P_TMR_Output->W = 0x3f00;						// Enable Timer4 PWM outputs
	
	P_TMR4_TGRA->W = 1200;							// Set PWM duty ratio
	P_TMR_LDOK->W = CW_TMR_LDOK1;
	
	INT_IRQ();
	
	while(1);
	
	return 1;
}

void IRQ2(void)	__attribute__((ISR));
void IRQ2(void)
{
	if(P_TMR1_Status->B.PDCIF)
	{
		P_TMR1_Status->B.PDCIF = 1;					// Clear interrtup flag
		
		TGRA_temp = P_TMR1_TGRA->W;
		if(TGRA_temp > P_TMR1_TCNT->W)
		{
			/* Process when TGRA is updated */
		}
		
		Pos_temp = P_POS1_DectData->W;				// Get Current position
	}
}